/***************************************************************************
                          mosixhistory.h  -  description
                             -------------------
    begin                : Sun Sep 23 18:46:39 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOSIXHISTORY_H
#define MOSIXHISTORY_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qscrollbar.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qprogressbar.h>
#include <qlistbox.h>
#include <qaccel.h>
#include <qlistbox.h>
#include <qtextstream.h>
#include <qtabdialog.h>
#include <qmultilineedit.h>
#include <qtimer.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/resource.h>

#include "resource.h"





// application specific includes
#include "mosixhistoryview.h"
#include "mosixhistorydoc.h"

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class MosixhistoryView is
  * created which creates your view.
  */
class MosixhistoryApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    MosixhistoryApp();
    /** destructor */
    ~MosixhistoryApp();

    void initActions();
    void initMenuBar();

  public slots:

    void slotFileOpen();
    void slotHelpAbout();
    void slotHelpAbout1();
		void neuwin();
		void neuwin(const char *filename);
		void fill_procbox();
		void fill_procbox(int time_val);
    void printit();

	protected:

	QListView *processbox;
	QLabel *titel_2;
	QLabel *titel_3;
	QLabel *titel_4;
	QLabel *titel_5;
	QLabel *titel_6;
	QLabel *output_label;
	QLabel *output_label1;
	QLabel *wann;
	QSlider *QSlider_timeline;
	QLCDNumber *plus_min;
	QListViewItem *i1[1000];

	virtual void resizeEvent(QResizeEvent* ev) {
	processbox->setGeometry(5,150,ev->size().width()-5,ev->size().height()-185);
	QSlider_timeline->setGeometry(5,90,ev->size().width()-15,30);
	output_label->setGeometry(ev->size().width()-345,ev->size().height()-25,250,20);
	output_label1->setGeometry(ev->size().width()-395,ev->size().height()-25,50,20);
  titel_4->setGeometry(ev->size().width()-40,75,35,20);
		}

  private:

  MosixhistoryDoc *doc;
  QPopupMenu *fileMenu;
  QPopupMenu *helpMenu;
  QToolBar *fileToolbar;
  QAction *fileOpen;
  QAction *filePrint;
  QAction *fileQuit;
  QAction *helpAboutApp;
  QAction *helpAboutApp1;

};
#endif 

