/***************************************************************************
                          mosixload.h  -  description
                             -------------------
    begin                : Sat Aug 18 17:37:09 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOSIXLOAD_H
#define MOSIXLOAD_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qpen.h>
#include <qscrollbar.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtimer.h>
#include <qcheckbox.h>
#include <qtabdialog.h>

#include "loganalyzer.h"
#include "avarage_load.h"

#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>




// application specific includes
#include "mosixloadview.h"
#include "mosixloaddoc.h"


class MosixloadApp : public QMainWindow
{
  Q_OBJECT
  
  public:

    MosixloadApp();
    ~MosixloadApp();
    void initActions();
    void initMenuBar();

  public slots:

		void setupQuit();
		void scroll_view(int value);
		void right_left(int value);
		void analyze();
		void analyze(const char *filename);
		void refreshit();
		void refreshit_manual();
		void get_avarage();
    void slotFileOpen();
    void slotHelpAbout();
    void slotHelpAbout1();
    void printit();

	protected:

		QScrollBar *QScrollBar_1;
		QScrollBar *QScrollBar_2;
		QGroupBox *QGroupBox_1;
		QGroupBox *QGroupBox_2;
		QGroupBox *QGroupBox_3;
		QLabel *QLabel_stat[1000];
		QPushButton *QButton_avarage[1000];
		QPushButton *QButton_print[1000];
		QPushButton *QPushButton_2;
		QLabel *timeline;
		QLabel *timeline1;
		QLabel *nummer[1000];
		QLabel *titel_1;
		QLabel *titel_2;
		QLabel *titel_3;
		QCheckBox *QCheckBox_1;
		QLabel *wann;
		QLabel *wielange;
		QLabel *tux;
		QLabel *black_legend;
		QLabel *black_legend1;
		QLabel *yellow_legend;
		QLabel *yellow_legend1;
		QLabel *red_legend;
		QLabel *red_legend1;
		QLabel *blue_legend;
		QLabel *blue_legend1;
		QLabel *QLabel_toptime;
		QLabel *QLabel_topblack;
	  loganalyzer *lognode[1000];
		avarage_load *mittel;

	virtual void resizeEvent(QResizeEvent* ev) {
	  QGroupBox_2->setGeometry(0,0,ev->size().width(),90);
	  tux->setGeometry(ev->size().width()-20,ev->size().height()-20,20,20);
	  QScrollBar_1->setGeometry(ev->size().width()-20,130, 20, ev->size().height()-150);
	  QScrollBar_2->setGeometry(0,ev->size().height()-20,ev->size().width()-20, 20);
		}

  private:

    MosixloadView *view;
    MosixloadDoc *doc;
		QPopupMenu *fileMenu;
    QPopupMenu *helpMenu;
    QAction *fileOpen;
    QAction *fileQuit;
    QAction *helpAboutApp;
    QAction *helpAboutApp1;
    QToolBar *fileToolbar;

};
#endif 

