/***************************************************************************
                          mosixmem.cpp  -  description
                             -------------------
    begin                : Mon Sep 10 17:39:57 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include "mosixmem.h"

#include "white.xpm"
#include "helpicon.xpm"
#include "ende.xpm"
#include "refresh.xpm"
#include "fileopen.xpm"
#include "red.xpm"
#include "black.xpm"
#include "yellow.xpm"
#include "blue.xpm"
#include "avarage.xpm"
#include "comment.xpm"
#include "load.xpm"
#include "collector.xpm"
#include "fileopen_hell.xpm"
#include "filefind.xpm"
#include "fileprint.xpm"



MosixmemApp::MosixmemApp() {

  setCaption(tr("Mosixmem " VERSION));
  initActions();
  initMenuBar();
	setupQuit();
}

MosixmemApp::~MosixmemApp()
{
}

/** initializes all QActions of the application */

void MosixmemApp::setupQuit(){

	int i=1;
	int wo=0;
	int ten=10;

  QPixmap help;
  help = QPixmap(helpicon);
	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
	QPixmap black_pix;
	black_pix= QPixmap(black_xpm);
	QPixmap yellow_pix;
	yellow_pix= QPixmap(yellow_xpm);
	QPixmap red_pix;
	red_pix= QPixmap(red_xpm);
	QPixmap blue_pix;
	blue_pix= QPixmap(blue_xpm);

  this->resize(660,2000);
  this->setMinimumSize(600,380);

  QGroupBox_1= new QGroupBox(this,"NoName");
  QGroupBox_1->setGeometry(0,100,21700,60);
  QGroupBox_1->setMinimumSize(0,0);
  QGroupBox_1->setTitle("");

  QScrollBar_1= new QScrollBar(0, 50, 1, 10, 0, QScrollBar::Vertical, this,"NoName");
  QScrollBar_1->setGeometry(640,90,20,345);
  QScrollBar_1->setMinimumSize(0,0);
  QScrollBar_1->setRange(0,50);
	QObject::connect(QScrollBar_1, SIGNAL(sliderMoved ( int )), this, SLOT(scroll_view( int  )) );

  QScrollBar_2= new QScrollBar(0, 50, 1, 10, 0, QScrollBar::Horizontal, this,"NoName");
  QScrollBar_2->setGeometry(0,0,660,75);
  QScrollBar_2->setRange(0,21100);
	QObject::connect(QScrollBar_2, SIGNAL(sliderMoved ( int )), this, SLOT(right_left( int  )) );

  QGroupBox_2= new QGroupBox(this,"NoName");
  QGroupBox_2->setGeometry(0,0,660,75);
  QGroupBox_2->setMinimumSize(0,0);
  QGroupBox_2->setTitle("");

  fileToolbar = new QToolBar(this, "QWhatsThis");
  fileToolbar->setGeometry(0,0,25,25);
  fileOpen->addTo(fileToolbar);
  fileToolbar->addSeparator();
  QWhatsThis::whatsThisButton(fileToolbar);

  QLabel_toptime= new QLabel(this,"NoName");
  QLabel_toptime->setGeometry(0,90,21700,40);
  QLabel_toptime->setMinimumSize(0,0);
  QLabel_toptime->setAlignment( AlignVCenter | AlignLeft );

	QLabel_topblack= new QLabel(this,"NoName");
  QLabel_topblack->setGeometry(0,130,21700,1);
  QLabel_topblack->setMinimumSize(0,0);
  QLabel_topblack->setBackgroundPixmap(QPixmap(black_pix));

  timeline= new QLabel(QLabel_toptime,"NoName");
  timeline->setGeometry(20,5,100,20);
  timeline->setMinimumSize(0,0);
  timeline->setText("time line (min.)");
  timeline->setMargin(0);
  timeline->setAlignment( AlignVCenter | AlignCenter );

  timeline1= new QLabel(QLabel_toptime,"NoName");
  timeline1->setGeometry(21610,5,70,20);
  timeline1->setMinimumSize(0,0);
  timeline1->setText("1 day");
  timeline1->setMargin(0);
  timeline1->setAlignment( AlignVCenter | AlignCenter );

	for (i=0; i<=1440; i++) {
		wo=i*15;

		if (ten==10) {
			ten=0;
		  nummer[i]= new QLabel(QLabel_toptime,"NoName");
		  nummer[i]->setGeometry(wo+10,20,40,20);
		  nummer[i]->setMinimumSize(0,0);
		  nummer[i]->setNum(i);
		  nummer[i]->setMargin(0);
		  nummer[i]->setAlignment( AlignVCenter | AlignCenter );
		}
		ten++;
	}

	QTimer *proctimer = new QTimer( this );
	proctimer->start(5000);
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit()) );

  tux= new QLabel(this,"NoName");
  tux->setGeometry(640,415,20,20);
  tux->setMinimumSize(0,0);
  tux->setPixmap(help);
  tux->setMargin(0);
  tux->setAlignment( AlignVCenter | AlignCenter );
	QWhatsThis::add(tux,"The amazing TUX :)");

  QGroupBox_3= new QGroupBox(this,"NoName");
  QGroupBox_3->setGeometry(400,35,240,50);
  QGroupBox_3->setMinimumSize(0,0);
  QGroupBox_3->setTitle("legend");

  black_legend= new QLabel(QGroupBox_3,"NoName");
  black_legend->setGeometry(10,25,10,15);
  black_legend->setMinimumSize(0,0);
  black_legend->setBackgroundPixmap(QPixmap(white_xpm));

  black_legend1= new QLabel(QGroupBox_3,"NoName");
  black_legend1->setGeometry(25,25,30,15);
  black_legend1->setMinimumSize(0,0);
  black_legend1->setText("mem");

  yellow_legend= new QLabel(QGroupBox_3,"NoName");
  yellow_legend->setGeometry(65,25,10,15);
  yellow_legend->setMinimumSize(0,0);
  yellow_legend->setBackgroundPixmap(QPixmap(black_xpm));

  yellow_legend1= new QLabel(QGroupBox_3,"NoName");
  yellow_legend1->setGeometry(80,25,60,15);
  yellow_legend1->setMinimumSize(0,0);
  yellow_legend1->setText("used mem");

  blue_legend= new QLabel(QGroupBox_3,"NoName");
  blue_legend->setGeometry(150,25,10,15);
  blue_legend->setMinimumSize(0,0);
  blue_legend->setBackgroundPixmap(QPixmap(blue_pix));

  blue_legend1= new QLabel(QGroupBox_3,"NoName");
  blue_legend1->setGeometry(165,25,65,15);
  blue_legend1->setMinimumSize(0,0);
  blue_legend1->setText("checkpoint");
}






void MosixmemApp::scroll_view( int value ) {

	int current_h=0;

	current_h=QGroupBox_1->height();
	QGroupBox_1->setGeometry(-QScrollBar_2->value(), -value+90, 21700, current_h);
}




void MosixmemApp::right_left( int value ) {

	int current_h=0;

	current_h=QGroupBox_1->height();
	QGroupBox_1->setGeometry (-value, -QScrollBar_1->value()+90, 21700, current_h );
  QLabel_toptime->setGeometry(-value, 90, 21700,40);
}






void MosixmemApp::analyze() {

	int status;
	int nummerint=0;
	FILE *zahl2;
	int labelheight=50;
	int current_h=0;
	int current_range=0;
	char *cstatus;
	cstatus = new char[4];
	char *dat1;
	dat1 = new char[50];
	char *dat2;
	dat2 = new char[50];
	char *dat3;
	dat3 = new char[50];
	char *dat4;
	dat4 = new char[50];
	char *dat5;
	dat5 = new char[50];
	char *analyzer_name;
	analyzer_name = new char[50];
	char *tmp;
	tmp = new char[50];

	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
	QPixmap end;
	end = QPixmap(ende);
	QPixmap fresh;
	fresh = QPixmap(refresh);
	QPixmap avarage_pix;
	avarage_pix= QPixmap(avarage_xpm);
 	QPixmap print;
	print= QPixmap(fileprint);

	if((zahl2=fopen("/tmp/mosixview/mosix.load", "r")) == NULL) {
		printf("could not open mosix data information file\n");
		strcpy(dat4, "no data");
		} else {
		fscanf(zahl2, "%d", &nummerint);
		fscanf(zahl2, "%s %s %s %s %s", dat1, dat2, dat3, dat4, dat5);
		fclose(zahl2);
	}

  wann= new QLabel(QGroupBox_2,"NoName");
  wann->setGeometry(10,65,70,20);
  wann->setMinimumSize(0,0);
  wann->setBackgroundPixmap(QPixmap(white_pix));
  wann->setText(dat4);
  wann->setMargin(0);
  wann->setAlignment( AlignVCenter | AlignCenter );
  wann->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QWhatsThis::add(wann,"This box shows the start-date\nof the mosix-collector.");

  titel_1= new QLabel(QGroupBox_2,"NoName");
  titel_1->setGeometry(80,25,350,25);
  titel_1->setMinimumSize(0,0);
  titel_1->setText("MOSIXMEM");
  titel_1->setMargin(1);
  titel_1->setAlignment( AlignVCenter | AlignLeft );

  titel_2= new QLabel(QGroupBox_2,"NoName");
  titel_2->setGeometry(80,65,100,20);
  titel_2->setMinimumSize(0,0);
  titel_2->setText("start date/time");
  titel_2->setMargin(1);
  titel_2->setAlignment( AlignVCenter | AlignLeft );

  QPushButton_2= new QPushButton(fresh, "NoName", this);
  QPushButton_2->setGeometry(165,65,80,20);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setText("refresh");
	QObject::connect(QPushButton_2, SIGNAL(clicked()), this, SLOT(refreshit_manual()) );
	QWhatsThis::add(QPushButton_2,"This button refresh the MOSIXMEM-view.");

  QCheckBox_1= new QCheckBox(this,"NoName");
  QCheckBox_1->setGeometry(255,65,90,20);
  QCheckBox_1->setMinimumSize(0,0);
  QCheckBox_1->setText("auto-refresh");
  QCheckBox_1->setChecked(false);
	QWhatsThis::add(QCheckBox_1,"Enable this checkbox to\nauto-refresh the MOSIXMEM-view.");

// initialize

	for (status=1;status<=nummerint;status++) {
	  QLabel_stat[status]= new QLabel(QGroupBox_1,"NoName");
	  QLabel_stat[status]->setGeometry(5,labelheight,25,100);
	  QLabel_stat[status]->setMinimumSize(0,0);
	  QLabel_stat[status]->setBackgroundPixmap(QPixmap(white_pix));
	  QLabel_stat[status]->setNum(status);
	  QLabel_stat[status]->setMargin(0);
	  QLabel_stat[status]->setAlignment( AlignVCenter | AlignCenter );
	  QLabel_stat[status]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
		QWhatsThis::add(QLabel_stat[status] ,"This box shows the mosix-ID of the analyezd\nmosix-node. Click on the X-button\nto get the avarage value.");

		sprintf(cstatus, "%d", status);
		strcpy(analyzer_name, "");
		strcpy(analyzer_name, "/tmp/mosixview/");
		strcat(analyzer_name, cstatus);
		strcat(analyzer_name, ".mem");
		strcat(analyzer_name, "\0");

	  lognode[status]= new loganalyzer(QGroupBox_1,analyzer_name);
	  lognode[status]->setGeometry(30,labelheight,21600,100);
	  lognode[status]->setMinimumSize(0,0);
		QWhatsThis::add(lognode[status],"This widget displays the memory-view of one mosix-node.");

	  QButton_avarage[status]= new QPushButton(QGroupBox_1,analyzer_name);
	  QButton_avarage[status]->setGeometry(5,labelheight,25,25);
	  QButton_avarage[status]->setMinimumSize(0,0);
	  QButton_avarage[status]->setPixmap(avarage_pix);
		QObject::connect(QButton_avarage[status], SIGNAL(clicked()), this, SLOT(get_avarage()));
		QWhatsThis::add(QButton_avarage[status] ,"Click on the X-button\nto get the avarage value.");

	  QButton_print[status]= new QPushButton(QGroupBox_1,analyzer_name);
	  QButton_print[status]->setGeometry(5,labelheight+75,25,25);
	  QButton_print[status]->setMinimumSize(0,0);
	  QButton_print[status]->setPixmap(print);
		QWhatsThis::add(QButton_print[status] ,"Print.");
		QObject::connect(QButton_print[status], SIGNAL(clicked()), this, SLOT(printit()));

		labelheight=((status+1)*100)-50;

		current_h=QGroupBox_1->height();
		current_h=current_h+100;
		QGroupBox_1->setGeometry(0, 90,21700, current_h );

		current_range=QScrollBar_1->maxValue ();
		current_range=current_range+100;
		QScrollBar_1->setRange ( 0, current_range );
	}

	delete [] cstatus;
	delete [] dat1;
	delete [] dat2;
	delete [] dat3;
	delete [] dat4;
	delete [] dat5;
	delete [] analyzer_name;
	delete [] tmp;

}






void MosixmemApp::analyze(const char *filename) {

	int status;
	int nummerint=0;
	FILE *zahl2;
	int labelheight=50;
	int current_h=0;
	int current_range=0;
	char *cstatus;
	cstatus = new char[4];
	char *dat1;
	dat1 = new char[50];
	char *dat2;
	dat2 = new char[50];
	char *dat3;
	dat3 = new char[50];
	char *dat4;
	dat4 = new char[50];
	char *dat5;
	dat5 = new char[50];
	int laenge=0;
	char *analyzer_name;
	analyzer_name = new char[50];
	char *tmp;
	tmp = new char[50];

	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
	QPixmap end;
	end = QPixmap(ende);
	QPixmap fresh;
	fresh = QPixmap(refresh);
	QPixmap avarage_pix;
	avarage_pix= QPixmap(avarage_xpm);
 	QPixmap print;
	print= QPixmap(fileprint);

	if((zahl2=fopen(filename, "r")) == NULL) {
		printf("could not open mosix data information file 1\n");
		strcpy(dat4, "no data");
		} else {
		printf("open file %s\n", filename);
		fscanf(zahl2, "%d", &nummerint);
		fscanf(zahl2, "%s %s %s %s %s", dat1, dat2, dat3, dat4, dat5);
		fclose(zahl2);
	}
	laenge=strlen(filename);
  wann= new QLabel(QGroupBox_2,"NoName");
  wann->setGeometry(10,65,70,20);
  wann->setMinimumSize(0,0);
  wann->setBackgroundPixmap(QPixmap(white_pix));
  wann->setText(dat4);
  wann->setMargin(0);
  wann->setAlignment( AlignVCenter | AlignCenter );
  wann->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QWhatsThis::add(wann,"This box shows the start-date\nof the mosix-collector.");

  titel_1= new QLabel(QGroupBox_2,"NoName");
  titel_1->setGeometry(80,25,350,25);
  titel_1->setMinimumSize(0,0);
  titel_1->setText("MOSIXMEM");
  titel_1->setMargin(1);
  titel_1->setAlignment( AlignVCenter | AlignLeft );

  titel_2= new QLabel(QGroupBox_2,"NoName");
  titel_2->setGeometry(80,65,100,20);
  titel_2->setMinimumSize(0,0);
  titel_2->setText("start date/time");
  titel_2->setMargin(1);
  titel_2->setAlignment( AlignVCenter | AlignLeft );

  QPushButton_2= new QPushButton(fresh, "NoName", this);
  QPushButton_2->setGeometry(165,65,80,20);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setText("refresh");
	QObject::connect(QPushButton_2, SIGNAL(clicked()), this, SLOT(refreshit_manual()) );
	QWhatsThis::add(QPushButton_2,"This button refresh the MOSIXMEM-view.");

  QCheckBox_1= new QCheckBox(this,"NoName");
  QCheckBox_1->setGeometry(255,65,90,20);
  QCheckBox_1->setMinimumSize(0,0);
  QCheckBox_1->setText("auto-refresh");
  QCheckBox_1->setChecked(false);
	QWhatsThis::add(QCheckBox_1,"Enable this checkbox to\nauto-refresh the MOSIXMEM-view.");

// initialize

	for (status=1;status<=nummerint;status++) {
	  QLabel_stat[status]= new QLabel(QGroupBox_1,"NoName");
	  QLabel_stat[status]->setGeometry(5,labelheight+25,25,75);
	  QLabel_stat[status]->setMinimumSize(0,0);
	  QLabel_stat[status]->setBackgroundPixmap(QPixmap(white_pix));
	  QLabel_stat[status]->setNum(status);
	  QLabel_stat[status]->setMargin(0);
	  QLabel_stat[status]->setAlignment( AlignVCenter | AlignCenter );
	  QLabel_stat[status]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
		QWhatsThis::add(QLabel_stat[status] ,"This box shows the mosix-ID of the analyezd\nmosix-node. Click on the X-button\nto get the avarage value.");

		sprintf(cstatus, "%d", status);

		strcpy(tmp, "");
		strncat(tmp, filename, laenge-10);
		strcpy(analyzer_name, "");
		strcpy(analyzer_name, tmp);
		strcat(analyzer_name, cstatus);
		strcat(analyzer_name, ".mem");
		strcat(analyzer_name, "\0");

	  lognode[status]= new loganalyzer(QGroupBox_1,analyzer_name);
	  lognode[status]->setGeometry(30,labelheight,21600,100);
	  lognode[status]->setMinimumSize(0,0);
		QWhatsThis::add(lognode[status],"This widget displays the memory-view of one mosix-node.");

	  QButton_avarage[status]= new QPushButton(QGroupBox_1,analyzer_name);
	  QButton_avarage[status]->setGeometry(5,labelheight,25,25);
	  QButton_avarage[status]->setMinimumSize(0,0);
	  QButton_avarage[status]->setPixmap(avarage_pix);
		QObject::connect(QButton_avarage[status], SIGNAL(clicked()), this, SLOT(get_avarage()));
		QWhatsThis::add(QButton_avarage[status] ,"Click on the X-button\nto get the avarage value.");

	  QButton_print[status]= new QPushButton(QGroupBox_1,analyzer_name);
	  QButton_print[status]->setGeometry(5,labelheight+75,25,25);
	  QButton_print[status]->setMinimumSize(0,0);
	  QButton_print[status]->setPixmap(print);
		QWhatsThis::add(QButton_print[status] ,"Print.");
		QObject::connect(QButton_print[status], SIGNAL(clicked()), this, SLOT(printit()));

		labelheight=((status+1)*100)-50;

		current_h=QGroupBox_1->height();
		current_h=current_h+100;
		QGroupBox_1->setGeometry(0, 90,21700, current_h );

		current_range=QScrollBar_1->maxValue();
		current_range=current_range+100;
		QScrollBar_1->setRange(0, current_range);
	}

	delete [] cstatus;
	delete [] dat1;
	delete [] dat2;
	delete [] dat3;
	delete [] dat4;
	delete [] dat5;
	delete [] analyzer_name;
	delete [] tmp;

}





void MosixmemApp::refreshit(){

	int status;
	int nummerint=0;
	FILE *zahl2;

	if(QCheckBox_1->isChecked()) {

		if((zahl2=fopen("/tmp/mosixview/mosix.load", "r")) == NULL) {
			printf("could not open mosix data information file\n");
			} else {
			fscanf(zahl2, "%d", &nummerint);
			fclose(zahl2);
		}
		for (status=1;status<=nummerint;status++) {
		  lognode[status]->repaint();
		}
	}
}






void MosixmemApp::refreshit_manual(){

	int status;
	int nummerint=0;
	FILE *zahl2;

	if((zahl2=fopen("/tmp/mosixview/mosix.load", "r")) == NULL) {
		printf("could not open mosix data information file\n");
		} else {
		fscanf(zahl2, "%d", &nummerint);
		fclose(zahl2);
	}
	for (status=1;status<=nummerint;status++) {
	  lognode[status]->repaint();
	}
}





void MosixmemApp::initActions(){

  QPixmap openIcon, saveIcon, newIcon;
  openIcon = QPixmap(fileopen);

  fileOpen = new QAction(tr("Open File"), openIcon, tr("&Open..."), 0, this);
  fileOpen->setStatusTip(tr("Opens an mosixcollector logfile"));
  fileOpen->setWhatsThis(tr("Open an\n\nmosixcollector logfile"));
  connect(fileOpen, SIGNAL(activated()), this, SLOT(slotFileOpen()));

  fileQuit = new QAction(tr("Exit"), tr("E&xit"), QAccel::stringToKey(tr("Ctrl+Q")), this);
  fileQuit->setStatusTip(tr("Quits the application"));
  fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
  connect(fileQuit, SIGNAL(activated()), qApp, SLOT(quit()));

  helpAboutApp = new QAction(tr("About"), tr("&About..."), 0, this);
  helpAboutApp->setStatusTip(tr("About the application"));
  helpAboutApp->setWhatsThis(tr("About\n\nAbout the application"));
  connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));

  helpAboutApp1 = new QAction(tr("Help"), tr("&Help"), 0, this);
  helpAboutApp1->setStatusTip(tr("Help"));
  helpAboutApp1->setWhatsThis(tr("Help"));
  connect(helpAboutApp1, SIGNAL(activated()), this, SLOT(slotHelpAbout1()));
}





void MosixmemApp::initMenuBar() {

  fileMenu=new QPopupMenu();
  fileOpen->addTo(fileMenu);
  fileMenu->insertSeparator();
  fileQuit->addTo(fileMenu);
  helpMenu=new QPopupMenu();
  helpAboutApp1->addTo(helpMenu);
	helpMenu->insertSeparator();
  helpAboutApp->addTo(helpMenu);
  menuBar()->insertItem(tr("&File"), fileMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Help"), helpMenu);

}








void MosixmemApp::slotFileOpen() {

  QString fileName = QFileDialog::getOpenFileName(0,0,this);
  if (!fileName.isEmpty()) {

		if(fileName.contains("mosix.load", 1)) {
	    doc->load(fileName);
			printf("analyze logfile\n");
			} else {
			printf("not a mosixcollector logfile! (default is /tmp/mosixview_[collect_date]/mosix.load\n");
		  QMessageBox::about(this,tr("not a mosixcollector logfile"), tr("Please load a main mosixcollector history logfile!\n e.g. /tmp/mosixview_[collect_date]/mosix.load") );
		}
	  } else {
	}

}





void MosixmemApp::slotHelpAbout() {

  QMessageBox::about(this,tr("About..."), tr("MOSIXMEM\nVersion " VERSION "\n(c) 2001 by M. Rechenburg") );
}





void MosixmemApp::get_avarage() {

	const  char *afilename;
	const QObject *button = sender();

	afilename=button->name();

	mittel=new avarage_mem(0, afilename);
	mittel->setGeometry(100,100,130,200);
  mittel->setMinimumSize(0,0);
  mittel->setFixedSize(130,200);
	mittel->show();

}





void MosixmemApp::slotHelpAbout1() {

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
  QPixmap help, com, load_icon, collector_icon, open_icon, finder;
	help = QPixmap(helpicon);
	com = QPixmap(comment);
	load_icon = QPixmap(load);
	collector_icon = QPixmap(collector);
	open_icon = QPixmap(fileopen_hell);
	finder = QPixmap(filefind);

	QTabDialog *tabs = new QTabDialog();
	tabs->setGeometry(200,50,300,200);
	tabs->resize(530, 300);

	QLabel *a = new QLabel(tabs, 0, 0);
	a->setGeometry(5,5,20,20);
	a->resize(200, 200);
	a->setMargin(3);
	a->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	a->setBackgroundPixmap(QPixmap(white_pix));
	a->setText("Help on MOSIX- LOAD, MEM, HISTORY and COLLECTOR\n\n"	\
	"MOSIXLOAD, MOSIXMEM, MOSIXHISTORY and MOSIXCOLLECTOR are \n" \
	"usefull to have a history-view of your MOSIX-cluster.\n" \
	"The MOSIXCOLLECTOR is a daemon running on one cluster-node.\n" \
	"It saves the load+mem of each cluster-member to a directory.\n" \
	"MOSIXLOAD, -MEM and HISTORY analyzes the files in this directory\n" \
	"and produce a graphical overview of the load- and memory history.\n" \
	"All MOSIX-tools can be managed from the main MOSIXVIEW-application.\n" \
	"You can even set checkpoints everytime you want. These checkpoints\n" \
	"are marked in MOSIXLOAD/MOSIXMEM. This help describes how to use these tools.\n" \
	"M. Rechenburg / rechenburger@netcologne.de");

	QLabel *b = new QLabel(tabs, 0, 0);
	b->setGeometry(5,5,20,20);
	b->resize(200, 200);
	b->setMargin(3);
	b->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	b->setBackgroundPixmap(QPixmap(white_pix));
	b->setText("MOSIXCOLLECTOR\n"	\
	"The MOSIXCOLLECTOR is a small daemon started on one cluster-member.\n" \
	"It collects the load/mem/procs of all cluster-nodes to /tmp/mosixview/*\n" \
	"and writes a  PID-file to /tmp/mosixcollector.pid.\n" \
	"mosixcollector -d			// starts the collector as a daemon\n" \
	"mosixcollector -k			// stops the collector\n" \
	"mosixcollector -c			// stops the collector and delete the history-files\n" \
	"mosixcollector -n			// write a checkpoint to the history\n" \
	"mosixcollector -r			// saves the history and start a new one\n" \
	"				// (automatically executed once a day!)\n" \
	"mosixcollector -help		// print out a short help\n" \
	"mosixcollector -h			// print out a short help\n");

	QLabel *c = new QLabel(tabs, 0, 0);
	c->setGeometry(5,5,20,20);
	c->resize(200, 200);
	c->setMargin(3);
	c->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	c->setBackgroundPixmap(QPixmap(white_pix));
	c->setText("MOSIXLOAD\n\n"	\
	"MOSIXLOAD analyzes the data collected by MOSIXCOLLECTOR\n" \
	"in a graphical way. By default it displays the current dataset\n" \
	"from the directory /tmp/mosixview/* but of course you can open older\n" \
	"history logfiles by the filemenu.\n" \
	"MOSIXLOAD displays one whole day of load information from your cluster.\n" \
	"Black lines are values <50, yellow lines are values >50 and the red lines are\n" \
	"values above 80. If there was a checkpoint written you can see it as\n" \
	"a vertical blue line. You can easily get the avarage value of each node\n" \
	"by clicking on the X-button of each node.\n");

	QLabel *d = new QLabel(tabs, 0, 0);
	d->setGeometry(5,5,20,20);
	d->resize(200, 200);
	d->setMargin(3);
	d->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	d->setBackgroundPixmap(QPixmap(white_pix));
	d->setText("MOSIXMEM\n\n"	\
	"MOSIXMEM is similar to MOSIXLOAD\n" \
	"By default it displays the current dataset from the directory\n" \
	"/tmp/mosixview/* and like MOSIXLOAD you can open older history\n" \
	"logfiles by the filemenu, too.\n" \
	"MOSIXMEM displays one whole day of memory information from your cluster.\n" \
	"The black line shows the used memory in percent from the avaiable mem.\n" \
	"You can get the avarage value of used memory by clicking on the\n" \
	"X-button of each node.\n");

	QLabel *e = new QLabel(tabs, 0, 0);
	e->setGeometry(5,5,20,20);
	e->resize(200, 200);
	e->setMargin(3);
	e->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	e->setBackgroundPixmap(QPixmap(white_pix));
	e->setText("MOSIXHISTORY\n\n"	\
	"MOSIXHISTORY is a process-history view.\n" \
	"By default it displays the current dataset from the directory\n" \
	"/tmp/mosixview/* and like MOSIXLOAD (or MOSIXMEM) you can \n" \
	"open older history logfiles by the filemenu, too.\n" \
	"MOSIXHISTORY starts at the start-date of the MOSIXCOLLECTOR\n" \
	"and you can move on in time by the time-line slider.\n" \
	"One mouseclick is similar to one minute.\n" \
	"The processbox displays the processes and where they ran\n" \
	"in dependency of the time (startdate +minutes).\n");

	QLabel *f = new QLabel(tabs, 0, 0);
	f->setGeometry(5,5,20,20);
	f->resize(200, 200);
	f->setMargin(3);
	f->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	f->setBackgroundPixmap(QPixmap(white_pix));
	f->setText("Open older logfiles\n\n"	\
	"The MOSIXCOLLECTOR writes the current dataset of load-informations to\n" \
	"/tmp/mosixview/*  and saves this directory to /tmp/mosixview[date]/*\n" \
	"automatically once a day.\n" \
	"Open the main logfile /tmp/mosixview[date]/mosix.load by the filemenu\n" \
	"and you can analyze the older logfiles.\n" \
	"\n" \
	"You have to open only the main logfile mosix.load for the complet history\n" \
	"information view.\n" \
	"\n");

	QLabel *g = new QLabel(tabs, 0, 0);
	g->setGeometry(5,5,20,20);
	g->resize(200, 200);
	g->setMargin(3);
	g->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	g->setBackgroundPixmap(QPixmap(white_pix));
	g->setText("Comments\n\n"	\
	"If you have more questions on MOSIXLOAD, MOSIXMEM, MOSIXCOLLECTOR\n" \
	"or MOSIXHISTORY you may want to take a look at the MOSIXVIEW-website.\n" \
	"There is a section which describes how to use them.\n" \
	"\n" \
	"http://www.waplocater.de/mosixview/\n" \
	"\n" \
	"Any comments/wanted features/bug-reports are welcome!\n" \
	"Please send them to the MOSIXVIEW-mailinglist or directly to me.\n" \
	"\n" \
	"M. Rechenburg / rechenburger@netcologne.de\n");

	tabs->addTab(a, help,  "general");
	tabs->addTab(b, collector_icon,  "collector");
	tabs->addTab(c, load_icon,  "load-analyzer");
	tabs->addTab(d, load_icon,  "mem-analyzer");
	tabs->addTab(e, finder,  "proc-history");
	tabs->addTab(f, open_icon,  "open logfile");
	tabs->addTab(g, com,  "comments");
	tabs->show();

}






void MosixmemApp::printit() {

	int nummerint1=0;
	int nummerint2=0;
	int nummerint3=0;
	int nummerint4=0;
	int nummerint_mittel1=0;
	int nummerint_mittel2=0;
	int nummerint_mittel3=0;
	int nummerinttmp=0;
	int mittelwert=0;
	FILE *zahl2;
	FILE *zahl3;
	int summe=0;
	const char *cwhich;
	cwhich = new char[50];
	const char *zehn;
	zehn = new char[4];
	char *temp;
	temp = new char[50];
  int j=25;
	int pages=1;
	int h=0;
	char *minutes;
	minutes = new char[3];
	char *cpages;
	cpages = new char[3];
	char *cmittel;
	cmittel = new char[4];
	char *cnummerint3;
	cnummerint3 = new char[6];
	const  char *afilename;
	const QObject *button = sender();

	afilename=button->name();

	QPen pen1(black, 0);
	QPen pen2(black, 2);
  QPrinter printer;
	printer.setOrientation(QPrinter::Landscape);

  if (printer.setup(this)) {

		if((zahl3=fopen(afilename, "r")) == NULL) {
			printf("could not open mosix data information file %s\n", afilename);
			} else {

			 while( (!feof(zahl3))&&(j<21600) ) {
					fscanf(zahl3, "%d %d %d", &nummerint_mittel1, &nummerint_mittel2, &nummerint_mittel3);
					if(nummerint_mittel3>0) {
						summe=summe+((nummerint_mittel3-nummerint_mittel1)*100)/nummerint_mittel3;
					}
					h=h+1;
			}
			fclose(zahl3);
			mittelwert=summe/h;
			if (mittelwert>=100) {
	      mittelwert=100;
			}
		}
		sprintf(cmittel, "%d", mittelwert);

		if((zahl2=fopen(afilename, "r")) == NULL) {
			printf("could not open mosix data information file %s\n", afilename);
			} else {
			QPainter painter;
			painter.begin(&printer);
			painter.setPen(pen1);
			painter.moveTo(25, 420);
			for(int i=25;i<=700; i++) {
				painter.lineTo(i, 420);
			}

			painter.moveTo(25, 20);
			for(int i=25;i<=700; i++) {
				painter.lineTo(i, 20);
			}

			painter.moveTo(25, 420);
			for(int i=20;i<=420; i++) {
				painter.lineTo(25, i);
			}

			painter.moveTo(700, 420);
			for(int i=20;i<=420; i++) {
				painter.lineTo(700, i);
			}
			for(int i=40;i<=700; i=i+15) {
				painter.moveTo(i, 420);
				painter.lineTo(i, 410);
			}

			painter.setFont(QFont("Helvetica", 10));
			for(int i=0;i<=9; i++) {
				sprintf(minutes, "%d", i*5);
				painter.drawText(i*75+20, 430, minutes, 3);
  		}

			sprintf(cnummerint3, "%d", nummerint_mittel3);
			painter.drawText(720, 430, "min.", 4);
			painter.drawText(35, 430, "min.", 4);
			painter.drawText(5, 420, "0", 1);
			painter.drawText(5, 25, cnummerint3, strlen(cnummerint3));
			painter.drawText(5, 40, "MB", 3);
			painter.drawText(0, 55, "mem", 4);
			painter.drawText(350, 5, "1", 1);
			painter.drawText(25, 450, "logfile-date:", 14);
			painter.drawText(100, 450, wann->text(), strlen(wann->text()));
			painter.drawText(150, 450, "+1*45 min.", 11);
			painter.drawText(25, 465, "logfile-name:", 14);
			painter.drawText(100, 465, afilename, strlen(afilename));
			painter.drawText(300, 450, "mem-avarage=");
			painter.drawText(370, 450, cmittel);
			painter.drawText(390, 450, "%", 1);
			painter.setFont(QFont("Helvetica", 6));
			painter.drawText(550, 480, "printed by MOSIXVIEW (rechenburger@netcologne.de)", 50);
			painter.setFont(QFont("Helvetica", 10));
			painter.moveTo(25, 420);
	
		 while(!feof(zahl2)) {
			fscanf(zahl2, "%d %d %d", &nummerint1, &nummerint2, &nummerint3);
			nummerint4=((nummerint3-nummerint1)*400)/nummerint3;

			if(nummerint3==-999) {
				painter.setPen(pen2);
				painter.moveTo(j, 420);
				painter.lineTo(j, 20);
				painter.setPen(pen1);
				painter.moveTo(j, nummerinttmp);
				} else {

				if (nummerint4>400) {
					nummerint4=400;
				}
				j=j+1;

// ########## new page

				if(j==700) {

					pages++;
					printer.newPage();
					painter.moveTo(25, 420);
					for(int i=25;i<=700; i++) {
						painter.lineTo(i, 420);
					}

					painter.moveTo(25, 20);
					for(int i=25;i<=700; i++) {
						painter.lineTo(i, 20);
					}

					painter.moveTo(25, 420);
					for(int i=20;i<=420; i++) {
						painter.lineTo(25, i);
					}

					painter.moveTo(700, 420);
					for(int i=20;i<=420; i++) {
						painter.lineTo(700, i);
					}

					for(int i=85;i<=700; i=i+60) {
						painter.moveTo(i, 420);
						painter.lineTo(i, 410);
					}
					painter.setFont(QFont("Helvetica", 10));
					for(int i=0;i<=9; i++) {
						sprintf(minutes, "%d", i*5);
						painter.drawText(i*75+25, 430, minutes, 3);
	  			}
					painter.drawText(720, 430, "min.", 4);
					painter.drawText(35, 430, "min.", 4);
					painter.drawText(5, 420, "0", 1);
					painter.drawText(5, 25, cnummerint3, strlen(cnummerint3));
					painter.drawText(5, 40, "MB", 3);
					painter.drawText(0, 55, "mem", 4);
					painter.drawText(25, 450, "logfile-date:", 14);
					painter.drawText(100, 450, wann->text(), strlen(wann->text()));
					sprintf(cpages, "%d", pages);
					painter.drawText(150, 450, "+", 1);
					painter.drawText(160, 450, cpages, strlen(cpages));
					painter.drawText(180, 450, "*45 min.", 9);
					painter.drawText(25, 465, "logfile-name:", 14);
					painter.drawText(100, 465, afilename, strlen(afilename));
					painter.drawText(350, 5, cpages, 3);
					painter.drawText(300, 450, "mem-avarage=");
					painter.drawText(370, 450, cmittel);
					painter.drawText(390, 450, "%", 1);
					painter.setFont(QFont("Helvetica", 6));
					painter.drawText(550, 480, "printed by MOSIXVIEW (rechenburger@netcologne.de)", 50);
					painter.setFont(QFont("Helvetica", 10));
					j=25;
					painter.moveTo(j, 420-nummerint4);
					} else {
					painter.lineTo(j, 420-nummerint4);
				}
				nummerinttmp=420-nummerint4;
		   }
		}
		fclose(zahl2);
	  painter.end();
	}

	}


	delete [] zehn;
	delete [] cwhich;
	delete [] temp;
	delete [] minutes;
	delete [] cpages;
	delete [] cmittel;
	delete [] cnummerint3;


}





















