/***************************************************************************
                          mosixview.cpp  -  description
                             -------------------
    begin                : Tue Jun 26 16:06:00 GMT 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include "mosixview.h"
#include "filesave.xpm"
#include "fileopen.xpm"
#include "filenew.xpm"
#include "green.xpm"
#include "red.xpm"
#include "white.xpm"
#include "black.xpm"
#include "helpicon.xpm"
#include "remote.xpm"
#include "hosti_g.xpm"
#include "proc_g.xpm"
#include "load.xpm"
#include "comment.xpm"
#include "config.xpm"
#include "refresh.xpm"
#include "speed.xpm"
#include "migrator.xpm"
#include "ende.xpm"
#include "clear.xpm"
#include "load2.xpm"
#include "collector.xpm"
#include "fileopen_hell.xpm"
#include "filefind.xpm"
#include "apply.xpm"




MosixviewApp::MosixviewApp()
{

	char *temp;
	temp = new char[100];

	QFile fp("/etc/HOSTNAME");

	if ( fp.open(IO_ReadOnly) ) {
		QTextStream t( &fp );
		QString s;
		s = t.readLine();
		s = s.simplifyWhiteSpace();
	  setCaption(tr("Mosixview " VERSION "  on "+ s));
		fp.close();
	} else {
		strcpy(temp, "");
	  strcpy(temp, "hostname > /tmp/stat.temp");
		if(!system(temp)) {
			QFile fp1("/tmp/stat.temp");
			if ( fp1.open(IO_ReadOnly) ) {
				QTextStream t1( &fp1 );
				QString s1;
				s1 = t1.readLine();
				s1 = s1.simplifyWhiteSpace();
				fp1.close();
			  setCaption(tr("Mosixview " VERSION "  on "+ s1));
     	}
		}	
}



  initActions();
  initMenuBar();
  initStatusBar();
  viewStatusBar->setOn(true);
	initDialog();
  initToolBar();
  viewToolBar->setOn(true);

	delete [] temp;
}



MosixviewApp::~MosixviewApp()
{
}



void  MosixviewApp::initDialog(){

	QPixmap white_pix, fresh, end;
	white_pix= QPixmap(white_xpm);
	fresh = QPixmap(refresh);
	end = QPixmap(ende);
 	QPixmap host;
	host= QPixmap(hosti_g);


  this->resize(740,2000);
  this->setMinimumSize(740,350);
  this->setMaximumSize(740,2000);
	QWhatsThis::add(this,"Control your MOSIX-Cluster with MOSIXVIEW.\nThis GUI will help you manage the configuration, load and process-migration.\n");

  QScrollBar_1= new QScrollBar(this,"NoName");
  QScrollBar_1->setGeometry(720,112,20,345);
  QScrollBar_1->setMinimumSize(0,0);
  QScrollBar_1->setRange(0,50);
	QScrollBar_1->setSteps(60,320);

  QGroupBox_1= new QGroupBox(this,"NoName");
  QGroupBox_1->setGeometry(0,112,720,60);
  QGroupBox_1->setMinimumSize(0,0);
  QGroupBox_1->setTitle("");

  QPushButton_all_nodes= new QPushButton(host, "all-nodes", QGroupBox_1);
  QPushButton_all_nodes->setName("all-nodes");
  QPushButton_all_nodes->setGeometry(30,0,120,20);
	QPushButton_all_nodes->setMinimumSize(0,0);
	QPushButton_all_nodes->setText("all-nodes");
	QObject::connect(QPushButton_all_nodes, SIGNAL(clicked()), this, SLOT( neuwin1()) );
	QWhatsThis::add(QPushButton_all_nodes ,"Click to configure all nodes You can execute the most common mosctl-command or stop/start mosix.\n");

	QProgressBar_overall= new QProgressBar(QGroupBox_1, "overall");
	QProgressBar_overall->setGeometry(310,0,130,20);
	QProgressBar_overall->setMinimumSize(0,0);
	QProgressBar_overall->setTotalSteps(150);
	QWhatsThis::add(QProgressBar_overall ,"These progressbars the mean load of your cluster.\n");

  QLabel_overall_load= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_load->setGeometry(310,30,160,20);
  QLabel_overall_load->setMinimumSize(0,0);
  QLabel_overall_load->setText("overall load");
  QLabel_overall_load->setMargin(1);

	QProgressBar_balance= new QProgressBar(QGroupBox_1, "overall");
	QProgressBar_balance->setGeometry(150,0,150,20);
	QProgressBar_balance->setMinimumSize(0,0);
	QProgressBar_balance->setTotalSteps(100);
	QProgressBar_balance->setProgress(100);
	QWhatsThis::add(QProgressBar_balance ,"These progressbars how good the loadbalancing works. It displays the diffrence between the min. and max. load values for the whole cluster.");

  QLabel_balance= new QLabel(QGroupBox_1,"NoName");
  QLabel_balance->setGeometry(150,30,160,20);
  QLabel_balance->setMinimumSize(0,0);
  QLabel_balance->setText("load-balacing efficiency");
  QLabel_balance->setMargin(1);

  QLabel_overall_mem= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_mem->setGeometry(450,30,160,20);
  QLabel_overall_mem->setMinimumSize(0,0);
  QLabel_overall_mem->setText("overall used mem.");
  QLabel_overall_mem->setMargin(1);

  QLabel_overall_mem1= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_mem1->setGeometry(475,0,70,20);
  QLabel_overall_mem1->setMinimumSize(0,0);
  QLabel_overall_mem1->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_overall_mem1->setNum(0);
  QLabel_overall_mem1->setMargin(0);
  QLabel_overall_mem1->setAlignment( AlignVCenter | AlignCenter );
  QLabel_overall_mem1->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QWhatsThis::add(QLabel_overall_mem1 ,"This box shows the overall used memory of your cluster.\n");

  QLabel_overall_mem2= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_mem2->setGeometry(545,0,30,20);
  QLabel_overall_mem2->setMinimumSize(0,0);
  QLabel_overall_mem2->setText("MB");
  QLabel_overall_mem2->setMargin(1);

  QLabel_overall_mem3= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_mem3->setGeometry(575,0,70,20);
  QLabel_overall_mem3->setMinimumSize(0,0);
  QLabel_overall_mem3->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_overall_mem3->setNum(0);
  QLabel_overall_mem3->setMargin(0);
  QLabel_overall_mem3->setAlignment( AlignVCenter | AlignCenter );
  QLabel_overall_mem3->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QWhatsThis::add(QLabel_overall_mem3 ,"This box shows whole memory of your cluster.\n");

  QLabel_overall_mem4= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_mem4->setGeometry(645,0,30,20);
  QLabel_overall_mem4->setMinimumSize(0,0);
  QLabel_overall_mem4->setText("MB");
  QLabel_overall_mem4->setMargin(1);

  QLabel_overall_mem5= new QLabel(QGroupBox_1,"NoName");
  QLabel_overall_mem5->setGeometry(585,30,70,20);
  QLabel_overall_mem5->setMinimumSize(0,0);
  QLabel_overall_mem5->setText("all mem.");
  QLabel_overall_mem5->setMargin(1);

  QLabel_allcpu= new QLabel(QGroupBox_1,"NoName");
  QLabel_allcpu->setGeometry(675,0,35,20);
  QLabel_allcpu->setMinimumSize(0,0);
  QLabel_allcpu->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_allcpu->setNum(0);
  QLabel_allcpu->setMargin(0);
  QLabel_allcpu->setAlignment( AlignVCenter | AlignCenter );
  QLabel_allcpu->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QWhatsThis::add(QLabel_allcpu ,"This box shows how many processors your cluster have.\n");

  QLabel_allcpu1= new QLabel(QGroupBox_1,"NoName");
  QLabel_allcpu1->setGeometry(670,30,45,20);
  QLabel_allcpu1->setMinimumSize(0,0);
  QLabel_allcpu1->setText("all cpu");
  QLabel_allcpu1->setMargin(1);

}





void MosixviewApp::scroll_view( int value ) {

	int current_h=0;

	current_h=QGroupBox_1->height();
  QGroupBox_1->setGeometry(0, -value+112, 720, current_h);
}




void MosixviewApp::setupQuit(){

	printf("Initializing MOSIXVIEW...\n");
	QTimer *internalTimer = new QTimer( this, "intern" );

	load_config();
	getconfig();
	mosixstatus();
	getval();
	typval();

	QTimer *proctimer = new QTimer( this );
	proctimer->start( 10000 );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit_status()) );
	QObject::connect(procbox_button, SIGNAL(clicked()), this, SLOT(proc_box()) );
	QObject::connect(QScrollBar_1, SIGNAL(sliderMoved ( int )), this, SLOT(scroll_view( int  )) );
	QObject::connect(QScrollBar_1, SIGNAL(valueChanged ( int )), this, SLOT(scroll_view( int  )) );
	QObject::connect(QCheckBox_3, SIGNAL(toggled (bool)), this, SLOT(toggle_ns_menu(bool)) );
	QObject::connect(QCheckBox_2, SIGNAL(toggled (bool)), this, SLOT(toggle_stat_menu(bool)) );
	QObject::connect(QCheckBox_4, SIGNAL(toggled (bool)), this, SLOT(toggle_load_menu(bool)) );
	QObject::connect(QCheckBox_5, SIGNAL(toggled (bool)), this, SLOT(toggle_ssh(bool)) );
	connect( internalTimer, SIGNAL(timeout()), this, SLOT(typval()) );
	internalTimer->start(5000);
}







void MosixviewApp::getconfig() {

	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
 	QPixmap host;
	host= QPixmap(hosti_g);

	int character='#';
	const char *hostname;
	const char *range;
	int lang=0;
	int howmany=0;
	int p=0;
	int second=0;
	int labelheight=5;
	char hostnr[5];
	int current_h=0;
	int allmem=0;
	int allcpu=0;
	int nummerint1=0;
	int nummerint2=0;
	char *fspeed=new char[50];
	FILE *zahl2;
	FILE *zahl3;


	int letzter_punkt=0;
	int lang_testhost=0;
	int lastbit_int=0;
	bool ok;


	QFile fp("/etc/mosix.map");

	if(fp.open(IO_ReadOnly)) {
		QTextStream t( &fp );
		QString s;
		int n = 0;

		while ( !t.eof() ) {
			s = t.readLine();
			s = s.simplifyWhiteSpace();

			if ( (s.find ( character, 0, TRUE )==-1)&&(s.length()>1) ) {
				second=	s.find ( 32, 0, TRUE );
				lang=	s.findRev ( 32, s.length(), TRUE );
				range=(const char *)s+(lang+1);

				if ( (strcmp(range, "0"))||(strcmp(range, "ALIAS")) ) {
					howmany=atoi(range);

					if (howmany!=1){
						s.truncate( lang );
						hostname=(const char *)s+(second+1);

						for (p=0; p<howmany; p++) {
							n++;

							QString *testhost=new QString(hostname);
							lang_testhost=testhost->length();
							letzter_punkt=testhost->findRev(".", -1, false);
							QString *testhost_ohne_lastbit=new QString(*testhost);
							QString *testhost_lastbit=new QString(*testhost);
							testhost_ohne_lastbit->remove(letzter_punkt+1, lang_testhost-letzter_punkt);
							testhost_lastbit->remove(0, letzter_punkt+1);
							lastbit_int=testhost_lastbit->toInt(&ok,10);
							lastbit_int=lastbit_int+p;
							sprintf((char *)testhost_lastbit, "%d", lastbit_int);
							QString *newhost=new QString(*testhost_ohne_lastbit);
							newhost->append((char *)testhost_lastbit);
							sprintf(hostnr, "%d", n);

							QLabel_stat[n]= new QLabel(QGroupBox_1,"NoName");
							QLabel_stat[n]->setGeometry(5,labelheight,25,20);
							QLabel_stat[n]->setMinimumSize(0,0);
							QLabel_stat[n]->setBackgroundPixmap(QPixmap(white_pix));
							QLabel_stat[n]->setText(hostnr);
							QLabel_stat[n]->setMargin(0);
							QLabel_stat[n]->setAlignment( AlignVCenter | AlignCenter );
							QLabel_stat[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
							QWhatsThis::add(QLabel_stat[n] ,"This box shows the status of the MOSIX-node. Green for avaiable, red for down.\n");

							QPushButton_host[n]= new QPushButton(host, *newhost, QGroupBox_1);
							QPushButton_host[n]->setName(*newhost);;
							QPushButton_host[n]->setGeometry(30,labelheight,120,20);
							QPushButton_host[n]->setMinimumSize(0,0);
							QPushButton_host[n]->setText(*newhost);
							QObject::connect( 	QPushButton_host[n], SIGNAL(clicked()), this, SLOT( neuwin1()) );
							QWhatsThis::add(QPushButton_host[n] ,"Click to configure this node You can execute the most common mosctl-command or stop/start mosix.\n");

						  QSlider_host[n]= new QSlider(QGroupBox_1, *newhost);
						  QSlider_host[n]->setGeometry(150,labelheight,110,20);
						  QSlider_host[n]->setMinimumSize(0,0);
						  QSlider_host[n]->setTracking(false);
						  QSlider_host[n]->setValue(0);
						  QSlider_host[n]->setRange(0,100000);
						  QSlider_host[n]->setTickInterval ( 10000 );
						  QSlider_host[n]->setTickmarks ( QSlider::Below );
						  QSlider_host[n]->setOrientation(QSlider::Horizontal);
							QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)), this, SLOT(setspeed(int)) );
							QWhatsThis::add(QSlider_host[n] ,"Change the speed+priority of this host in your cluster. Processes will easier migrate to a node with a higher speed-value.\n");

							QLCDNumber_host[n]= new QLCDNumber(QGroupBox_1, *newhost);
							QLCDNumber_host[n]->setGeometry(260,labelheight,50,20);
							QLCDNumber_host[n]->setMinimumSize(0,0);
							QLCDNumber_host[n]->display("0");
							QLCDNumber_host[n]->setNumDigits(6);
							QLCDNumber_host[n]->setSegmentStyle (QLCDNumber::Flat);
							QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)),   QLCDNumber_host[n], SLOT(display(int)) );
							QWhatsThis::add(QLCDNumber_host[n] ,"The LCD-number shows the current MOSIX-speed of this host.\n");

							QProgressBar_host[n]= new QProgressBar(QGroupBox_1, *newhost);
							QProgressBar_host[n]->setGeometry(310,labelheight,130,20);
							QProgressBar_host[n]->setMinimumSize(0,0);
							QProgressBar_host[n]->setTotalSteps (150);
							QWhatsThis::add(QProgressBar_host[n] ,"These progressbars gives you an overview of the load on your cluster.\n");

							strcpy(fspeed, "");
							strcpy(fspeed, "/proc/mosix/nodes/");
							strcat(fspeed, hostnr);
							strcat(fspeed, "/tmem");

							if((zahl2=fopen(fspeed, "r")) == NULL) {
				        } else {
				        fscanf(zahl2, "%d", &nummerint1);
								nummerint1=nummerint1/1048576;
								fclose(zahl2);
							}

							allmem=allmem+nummerint1;
							QProgressBar_mem[n]= new QProgressBar(QGroupBox_1, *newhost);
							QProgressBar_mem[n]->setGeometry(450,labelheight,130,20);
							QProgressBar_mem[n]->setMinimumSize(0,0);
							QProgressBar_mem[n]->setTotalSteps(nummerint1);
							QWhatsThis::add(QProgressBar_mem[n] ,"These progressbars gives you an overview of the memory on your cluster.\n");

						  QLabel_memo[n]= new QLabel(QGroupBox_1,"NoName");
						  QLabel_memo[n]->setGeometry(595,labelheight,50,20);
						  QLabel_memo[n]->setMinimumSize(0,0);
						  QLabel_memo[n]->setNum(nummerint1);
						  QLabel_memo[n]->setMargin(1);
							QLabel_memo[n]->setBackgroundPixmap(QPixmap(white_pix));
						  QLabel_memo[n]->setAlignment( AlignVCenter | AlignCenter );
						  QLabel_memo[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
							QWhatsThis::add(QLabel_memo[n] ,"This box shows the memory of one node of your cluster\n");

							strcpy(fspeed, "");
							strcpy(fspeed, "/proc/mosix/nodes/");
							strcat(fspeed, hostnr);
							strcat(fspeed, "/cpus");

							if((zahl3=fopen(fspeed, "r")) == NULL) {
				        } else {
				        fscanf(zahl3, "%d", &nummerint2);
								fclose(zahl3);
							}

							QLabel_howmany_cpus[n]= new QLabel(QGroupBox_1,"NoName");
						  QLabel_howmany_cpus[n]->setGeometry(675,labelheight,20,20);
						  QLabel_howmany_cpus[n]->setMinimumSize(0,0);

							if(nummerint2==-101) {
							  QLabel_howmany_cpus[n]->setNum(0);
								} else {
							  QLabel_howmany_cpus[n]->setNum(nummerint2);
								allcpu=allcpu+nummerint2;
							}

						  QLabel_howmany_cpus[n]->setMargin(1);
						  QLabel_howmany_cpus[n]->setBackgroundPixmap(QPixmap(white_pix));
						  QLabel_howmany_cpus[n]->setAlignment( AlignVCenter | AlignCenter );
						  QLabel_howmany_cpus[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
							QWhatsThis::add(QLabel_howmany_cpus[n] ,"This box shows how many CPUs this node has.\n");

							current_h=QGroupBox_1->height();
							current_h=current_h+20;
							QGroupBox_1->setGeometry(0, 112, 720, current_h);

							current_h=QScrollBar_1->maxValue ();
							current_h=current_h+20;
							QScrollBar_1->setRange(0, current_h);

							current_h=QLabel_overall_mem->y();
							current_h=current_h+20;
						  QLabel_overall_mem->setGeometry(450,current_h,160,20);

							current_h=QLabel_overall_mem1->y();
							current_h=current_h+20;
						  QLabel_overall_mem1->setGeometry(475,current_h,70,20);

							current_h=QLabel_overall_mem2->y();
							current_h=current_h+20;
						  QLabel_overall_mem2->setGeometry(545,current_h,30,20);

							current_h=QLabel_overall_mem3->y();
							current_h=current_h+20;
						  QLabel_overall_mem3->setGeometry(575,current_h,70,20);

							current_h=QLabel_overall_mem4->y();
							current_h=current_h+20;
						  QLabel_overall_mem4->setGeometry(645,current_h,30,20);

							current_h=QLabel_overall_mem5->y();
							current_h=current_h+20;
						  QLabel_overall_mem5->setGeometry(585,current_h,70,20);

							current_h=QLabel_allcpu->y();
							current_h=current_h+20;
						  QLabel_allcpu->setGeometry(675,current_h,35,20);

							current_h=QLabel_allcpu1->y();
							current_h=current_h+20;
						  QLabel_allcpu1->setGeometry(670,current_h,45,20);

							current_h=QPushButton_all_nodes->y();
							current_h=current_h+20;
						  QPushButton_all_nodes->setGeometry(30,current_h,120,20);

							current_h=QProgressBar_overall->y();
							current_h=current_h+20;
							QProgressBar_overall->setGeometry(310,current_h,130,20);

							current_h=QLabel_overall_load->y();
							current_h=current_h+20;
						  QLabel_overall_load->setGeometry(310,current_h,160,20);

							current_h=QProgressBar_balance->y();
							current_h=current_h+20;
							QProgressBar_balance->setGeometry(150,current_h,150,20);

							current_h=QLabel_balance->y();
							current_h=current_h+20;
						  QLabel_balance->setGeometry(150,current_h,160,20);

							labelheight=labelheight+20;
						}
					} else {

						n++;
						s.truncate( lang );
						hostname=(const char *)s+(second+1);
						sprintf(hostnr, "%d", n);

					  QLabel_stat[n]= new QLabel(QGroupBox_1,"NoName");
					  QLabel_stat[n]->setGeometry(5,labelheight,25,20);
					  QLabel_stat[n]->setMinimumSize(0,0);
					  QLabel_stat[n]->setBackgroundPixmap(QPixmap(white_pix));
					  QLabel_stat[n]->setText(hostnr);
					  QLabel_stat[n]->setMargin(0);
					  QLabel_stat[n]->setAlignment( AlignVCenter | AlignCenter );
					  QLabel_stat[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
						QWhatsThis::add(QLabel_stat[n] ,"This box shows the status of the MOSIX-node. Green for avaiable, red for down.\n");

					  QPushButton_host[n]= new QPushButton(host, hostname, QGroupBox_1);
					  QPushButton_host[n]->setName(hostname);
					  QPushButton_host[n]->setGeometry(30,labelheight,120,20);
						QPushButton_host[n]->setMinimumSize(0,0);
						QPushButton_host[n]->setText(hostname);
						QObject::connect( 	QPushButton_host[n], SIGNAL(clicked()), this, SLOT( neuwin1()) );
						QWhatsThis::add(QPushButton_host[n] ,"Click to configure this node You can execute the most common mosctl-command or stop/start mosix.\n");

					  QSlider_host[n]= new QSlider(QGroupBox_1,hostname);
					  QSlider_host[n]->setGeometry(150,labelheight,110,20);
					  QSlider_host[n]->setMinimumSize(0,0);
					  QSlider_host[n]->setTracking(false);
					  QSlider_host[n]->setValue(0);
					  QSlider_host[n]->setRange(0,100000);
					  QSlider_host[n]->setTickInterval ( 10000 );
					  QSlider_host[n]->setTickmarks ( QSlider::Below );
					  QSlider_host[n]->setOrientation(QSlider::Horizontal);
						QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)), this, SLOT(setspeed(int)) );
						QWhatsThis::add(QSlider_host[n] ,"Change the speed+priority of this host in your cluster. Processes will easier migrate to a node with a higher speed-value.\n");

						QLCDNumber_host[n]= new QLCDNumber(QGroupBox_1, hostname);
						QLCDNumber_host[n]->setGeometry(260,labelheight,50,20);
						QLCDNumber_host[n]->setMinimumSize(0,0);
						QLCDNumber_host[n]->display("0");
						QLCDNumber_host[n]->setNumDigits(6);
						QLCDNumber_host[n]->setSegmentStyle (QLCDNumber::Flat);
						QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)),   QLCDNumber_host[n], SLOT(display(int)) );
						QWhatsThis::add(QLCDNumber_host[n] ,"The LCD-number shows the current MOSIX-speed of this host.\n");

						QProgressBar_host[n]= new QProgressBar(QGroupBox_1, hostname);
						QProgressBar_host[n]->setGeometry(310,labelheight,130,20);
						QProgressBar_host[n]->setMinimumSize(0,0);
						QProgressBar_host[n]->setTotalSteps (150);
						QWhatsThis::add(QProgressBar_host[n] ,"These progressbars gives you an overview of the load on your cluster.\n");

						strcpy(fspeed, "");
						strcpy(fspeed, "/proc/mosix/nodes/");
						strcat(fspeed, hostnr);
						strcat(fspeed, "/tmem");

						if((zahl2=fopen(fspeed, "r")) == NULL) {
							} else {
			        fscanf(zahl2, "%d", &nummerint1);
							nummerint1=nummerint1/1048576;
							fclose(zahl2);
						}

						allmem=allmem+nummerint1;

						QProgressBar_mem[n]= new QProgressBar(QGroupBox_1, hostname);
						QProgressBar_mem[n]->setGeometry(450,labelheight,130,20);
						QProgressBar_mem[n]->setMinimumSize(0,0);
						QProgressBar_mem[n]->setTotalSteps(nummerint1);
						QWhatsThis::add(QProgressBar_mem[n] ,"These progressbars gives you an overview of the memory on your cluster.\n");

					  QLabel_memo[n]= new QLabel(QGroupBox_1,"NoName");
					  QLabel_memo[n]->setGeometry(595,labelheight,50,20);
					  QLabel_memo[n]->setMinimumSize(0,0);
					  QLabel_memo[n]->setNum(nummerint1);
					  QLabel_memo[n]->setMargin(1);
					  QLabel_memo[n]->setBackgroundPixmap(QPixmap(white_pix));
					  QLabel_memo[n]->setAlignment( AlignVCenter | AlignCenter );
					  QLabel_memo[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
						QWhatsThis::add(QLabel_memo[n] ,"This box shows the memory of one node of your cluster\n");

						strcpy(fspeed, "");
						strcpy(fspeed, "/proc/mosix/nodes/");
						strcat(fspeed, hostnr);
						strcat(fspeed, "/cpus");

						if((zahl3=fopen(fspeed, "r")) == NULL) {
			        } else {
			        fscanf(zahl3, "%d", &nummerint2);
							fclose(zahl3);
						}

					  QLabel_howmany_cpus[n]= new QLabel(QGroupBox_1,"NoName");
					  QLabel_howmany_cpus[n]->setGeometry(675,labelheight,20,20);
					  QLabel_howmany_cpus[n]->setMinimumSize(0,0);

						if(nummerint2==-101) {
						  QLabel_howmany_cpus[n]->setNum(0);
              } else {
						  QLabel_howmany_cpus[n]->setNum(nummerint2);
							allcpu=allcpu+nummerint2;
						}

					  QLabel_howmany_cpus[n]->setMargin(1);
					  QLabel_howmany_cpus[n]->setBackgroundPixmap(QPixmap(white_pix));
					  QLabel_howmany_cpus[n]->setAlignment( AlignVCenter | AlignCenter );
					  QLabel_howmany_cpus[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
						QWhatsThis::add(QLabel_howmany_cpus[n] ,"This box shows how many CPUs this node has.\n");

						current_h=QGroupBox_1->height();
						current_h=current_h+20;
						QGroupBox_1->setGeometry(0, 112, 720, current_h);

						current_h=QScrollBar_1->maxValue ();
						current_h=current_h+20;
						QScrollBar_1->setRange ( 0, current_h );

						current_h=QLabel_overall_mem->y();
						current_h=current_h+20;
					  QLabel_overall_mem->setGeometry(450,current_h,160,20);

						current_h=QLabel_overall_mem1->y();
						current_h=current_h+20;
					  QLabel_overall_mem1->setGeometry(455,current_h,70,20);

						current_h=QLabel_overall_mem2->y();
						current_h=current_h+20;
					  QLabel_overall_mem2->setGeometry(545,current_h,30,20);

						current_h=QLabel_overall_mem3->y();
						current_h=current_h+20;
					  QLabel_overall_mem3->setGeometry(575,current_h,70,20);

						current_h=QLabel_overall_mem4->y();
						current_h=current_h+20;
					  QLabel_overall_mem4->setGeometry(645,current_h,30,20);

						current_h=QLabel_overall_mem5->y();
						current_h=current_h+20;
					  QLabel_overall_mem5->setGeometry(585,current_h,70,20);

						current_h=QLabel_allcpu->y();
						current_h=current_h+20;
					  QLabel_allcpu->setGeometry(675,current_h,35,20);

						current_h=QLabel_allcpu1->y();
						current_h=current_h+20;
					  QLabel_allcpu1->setGeometry(670,current_h,45,20);

						current_h=QPushButton_all_nodes->y();
						current_h=current_h+20;
					  QPushButton_all_nodes->setGeometry(30,current_h,120,20);

						current_h=QProgressBar_overall->y();
						current_h=current_h+20;
						QProgressBar_overall->setGeometry(310,current_h,130,20);

						current_h=QLabel_overall_load->y();
						current_h=current_h+20;
					  QLabel_overall_load->setGeometry(310,current_h,160,20);

						current_h=QProgressBar_balance->y();
						current_h=current_h+20;
						QProgressBar_balance->setGeometry(150,current_h,150,20);

						current_h=QLabel_balance->y();
						current_h=current_h+20;
					  QLabel_balance->setGeometry(150,current_h,160,20);

						labelheight=labelheight+20;
					}
				}
			}

		}
		fp.close();
	}

	QLabel_overall_mem3->setNum(allmem);
  QLabel_allcpu->setNum(allcpu);

	current_h=QGroupBox_1->height();
	current_h=current_h+20;
	QGroupBox_1->setGeometry (0, 112, 720, current_h );

	current_h=QPushButton_all_nodes->y();
	current_h=current_h+10;
  QPushButton_all_nodes->setGeometry(30,current_h,120,20);

	current_h=QProgressBar_overall->y();
	current_h=current_h+10;
	QProgressBar_overall->setGeometry(310,current_h,130,20);

	current_h=QLabel_overall_mem1->y();
	current_h=current_h+10;
  QLabel_overall_mem1->setGeometry(475,current_h,70,20);

	current_h=QLabel_overall_mem2->y();
	current_h=current_h+10;
  QLabel_overall_mem2->setGeometry(545,current_h,30,20);

	current_h=QLabel_overall_mem3->y();
	current_h=current_h+10;
  QLabel_overall_mem3->setGeometry(575,current_h,70,20);

	current_h=QLabel_overall_mem4->y();
	current_h=current_h+10;
  QLabel_overall_mem4->setGeometry(645,current_h,30,20);

	current_h=QLabel_allcpu->y();
	current_h=current_h+10;
  QLabel_allcpu->setGeometry(675,current_h,35,20);

	current_h=QProgressBar_balance->y();
	current_h=current_h+10;
	QProgressBar_balance->setGeometry(150,current_h,150,20);


}






void MosixviewApp::typval() {

	int status=0;
	int nummerint=0;
	int nummerint1=0;
	int memvalue=0;
	FILE *zahl;
	FILE *zahl2;
  char *fspeed;
	fspeed = new char[100];
  char *hist;
	hist = new char[100];
	char *cstatus;
	cstatus = new char[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;
	int mini=100;
	int maxi=0;
	int mean=0;
	int mem_mean=0;
	int diff=0;


	if(QCheckBox_4->isChecked()) {

		if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

			while ((dir_info = readdir(dir))!=NULL) {
				howmany++;
			}
			howmany--;
		}
		closedir(dir);

		for (status=1;status<howmany;status++) {
	
			sprintf(cstatus, "%d", status);	
			strcpy(fspeed, "");
			strcpy(fspeed, "/proc/mosix/nodes/");
			strcat(fspeed, cstatus);
			strcat(fspeed, "/load");

			if((zahl=fopen(fspeed, "r")) == NULL) {
				} else {
        fscanf(zahl, "%d", &nummerint);

				if (nummerint!=-101) {
					if (nummerint<QProgressBar_host[status]->progress()) {
						QProgressBar_host[status]->reset ();
						QProgressBar_host[status]->setProgress(nummerint);
						} else {
						QProgressBar_host[status]->setProgress(nummerint);
					}

					mini=min(mini, nummerint);
					maxi=max(maxi, nummerint);
					mean+=nummerint;
					} else {
					mini=min(mini, 0);
					maxi=max(maxi, 0);
					mean+=0;
				}
				fclose(zahl);
			}

			strcpy(fspeed, "");
			strcpy(fspeed, "/proc/mosix/nodes/");
			strcat(fspeed, cstatus);
			strcat(fspeed, "/mem");

			if((zahl2=fopen(fspeed, "r")) == NULL) {
        } else {
        fscanf(zahl2, "%d", &nummerint1);
				nummerint1=nummerint1/1048576;
				memvalue=QProgressBar_mem[status]->totalSteps()-(nummerint1);
				mem_mean+=memvalue;
				if (memvalue!=0) {
					if (memvalue<QProgressBar_mem[status]->progress()) {
						QProgressBar_mem[status]->reset ();
						QProgressBar_mem[status]->setProgress(memvalue);
						} else {
						QProgressBar_mem[status]->setProgress(memvalue);
					}
				}
				fclose(zahl2);
			}

		}// end of for


		mean/=(status-1);
		diff=maxi-mini;

		if (mean-mini > maxi-mean) {
	    diff=-diff;
		}
		QProgressBar_overall->setProgress(mean);
		QProgressBar_balance->setProgress(100-diff);
	  QLabel_overall_mem1->setNum(mem_mean);
	}

	delete [] fspeed;
	delete [] cstatus;
	delete [] hist;

}











void MosixviewApp::getval() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char *fspeed;
	fspeed = new char[100];
	char *cstatus;
	cstatus = new char[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;

	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

		while ((dir_info = readdir(dir))!=NULL) {
			howmany++;
		}
		howmany--;
	}
	closedir(dir);

	for (status=1;status<howmany;status++) {
		sprintf(cstatus, "%d", status);	
		strcpy(fspeed, "");
		strcpy(fspeed, "/proc/mosix/nodes/");
		strcat(fspeed, cstatus);
		strcat(fspeed, "/speed");

		if((zahl=fopen(fspeed, "r")) == NULL) {
  	  } else {
	    fscanf(zahl, "%d", &nummerint);
			if(nummerint<0) {
				nummerint=0;
			}
			QSlider_host[status]->setValue(nummerint);
			QLCDNumber_host[status]->display(nummerint);
			fclose(zahl);
		}
	}

	delete [] fspeed;
	delete [] cstatus;
}





void MosixviewApp::setspeed(int speed) {

  char *mosspeed;
	mosspeed = new char[6];
  char *setsp;
	setsp = new char[100];
  char *outp;
	outp = new char[100];
	int error;
	const  char *hostname;
	const QObject *button = sender();

	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	if (speed<0) {
  	speed=0;
	}
	sprintf(mosspeed, "%d", speed);

	if(QCheckBox_5->isChecked()) {
		strcpy(setsp, "");
		strcpy(setsp, "ssh ");
		strcat(setsp, hostname);
		strcat(setsp, " mosctl setspeed ");
		strcat(setsp, mosspeed);
		} else {
		strcpy(setsp, "");
		strcpy(setsp, "rsh ");
		strcat(setsp, hostname);
		strcat(setsp, " mosctl setspeed ");
		strcat(setsp, mosspeed);
	}

	if((error=system(setsp)) > 0) {
		printf("cannot set mosspeed\n");
		strcpy(outp, "cannot set speed to ");
		strcat(outp, mosspeed);
		strcat(outp, " on ");
		strcat(outp, hostname);
	  statusBar()->message(outp);
		} else {
		strcpy(outp, "set speed to ");
		strcat(outp, mosspeed);
		strcat(outp, " on ");
		strcat(outp, hostname);
	  statusBar()->message(outp);
	}

	delete [] mosspeed;
	delete [] setsp;
	delete [] outp;
}




void MosixviewApp::action_stop() {
	QPushButton_80->setOn(false);
}

void MosixviewApp::action_start() {
	QPushButton_90->setOn(false);
}

void MosixviewApp::action_lstay(){

	QPushButton_30->setToggleButton ( TRUE );
	QPushButton_30->toggle();
	QPushButton_40->toggle ();
	QPushButton_40->setToggleButton ( FALSE );

}


void MosixviewApp::action_nolstay(){

	QPushButton_40->setToggleButton ( TRUE );
	QPushButton_40->toggle();
	QPushButton_30->toggle ();
	QPushButton_30->setToggleButton ( FALSE );

}


void MosixviewApp::action_migration(){

	QPushButton_2->setToggleButton ( TRUE );
	QPushButton_2->toggle();
	QPushButton_12->toggle ();
	QPushButton_12->setToggleButton ( FALSE );

}


void MosixviewApp::action_nomigration(){

	QPushButton_12->setToggleButton ( TRUE );
	QPushButton_12->toggle ();
	QPushButton_2->toggle();
	QPushButton_2->setToggleButton ( FALSE );

}


void MosixviewApp::action_block(){

	QPushButton_50->setToggleButton ( TRUE );
	QPushButton_50->toggle();
	QPushButton_60->toggle ();
	QPushButton_60->setToggleButton ( FALSE );

}


void MosixviewApp::action_noblock(){

	QPushButton_60->setToggleButton ( TRUE );
	QPushButton_60->toggle();
	QPushButton_50->toggle ();
	QPushButton_50->setToggleButton ( FALSE );

}


void MosixviewApp::action_noquiet(){

	QPushButton_91->setToggleButton ( TRUE );
	QPushButton_91->toggle();
	QPushButton_81->toggle ();
	QPushButton_81->setToggleButton ( FALSE );

}


void MosixviewApp::action_quiet(){

	QPushButton_81->setToggleButton ( TRUE );
	QPushButton_81->toggle();
	QPushButton_91->toggle ();
	QPushButton_91->setToggleButton ( FALSE );

}





void MosixviewApp::neuwin1() {

	const  char *hostname;
	const  char *hostname2;
	const QObject *button = sender();
	struct in_addr **ip;
	struct in_addr num;
	struct hostent *host;
	char ipaddr[20];
  char *temp;
	temp = new char[100];
  char *displays;
	displays = new char[50];
	FILE *fp1;
	int entries=0;

	QPixmap white_pix, conf, end, migrat, clearit, applyit;
	white_pix= QPixmap(white_xpm);
	conf = QPixmap(config);
	end = QPixmap(ende);
	migrat= QPixmap(migrator);
	clearit= QPixmap(clear);
	applyit= QPixmap(apply);
 	QPixmap hosti;
	hosti= QPixmap(hosti_g);

	hostname=button->name();
	QString s;
	QFile fp("/etc/HOSTNAME");

	if ( fp.open(IO_ReadOnly) ) {
		QTextStream t( &fp );
		s = t.readLine();
		s = s.simplifyWhiteSpace();
		fp.close();
		} else {
		strcpy(temp, "");
	  strcpy(temp, "hostname > /tmp/stat.temp");

		if(!system(temp)) {
			QFile fp1("/tmp/stat.temp");

			if ( fp1.open(IO_ReadOnly) ) {
				QTextStream t( &fp1 );
				s = t.readLine();
				s = s.simplifyWhiteSpace();
				fp1.close();
			}
		}
	}

	hinten1= new QWidget(0, hostname);
	hinten1->setGeometry(50,30,50,110);
	hinten1->setMinimumSize(0,0);
	hinten1->resize(260, 325);
	hinten1->setFixedSize(260, 325);

	QGroupBox *backr = new QGroupBox("",hinten1);
	backr->setGeometry(5, 30, 255,215);
	backr->setMinimumSize(0,0);
	backr->resize(250, 290);

  QPushButton_2= new QPushButton(backr,hostname);
  QPushButton_2->setGeometry(10,70,40,20);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setText("on");
  QWhatsThis::add(QPushButton_2,"Click this button to enable\nauto-migration for this host.\n");
	QObject::connect(   QPushButton_2, SIGNAL(clicked()), this, SLOT( action_migration()) );

  QPushButton_12= new QPushButton(backr,hostname);
  QPushButton_12->setGeometry(50,70,40,20);
  QPushButton_12->setMinimumSize(0,0);
  QPushButton_12->setText("off");
  QWhatsThis::add(QPushButton_12,"Click this button to disable\nauto-migration for this host.\n");
	QObject::connect(   QPushButton_12, SIGNAL(clicked()), this, SLOT( action_nomigration()) );

  QPushButton_81= new QPushButton(backr,hostname);
  QPushButton_81->setGeometry(10,90,40,20);
  QPushButton_81->setMinimumSize(0,0);
  QPushButton_81->setText("yes");
	QObject::connect( QPushButton_81, SIGNAL(clicked()), this, SLOT( action_quiet()) );
  QWhatsThis::add(QPushButton_81,"Click this button to execute\nmosctl quiet on this host.\n");

	QPushButton_91= new QPushButton(backr,hostname);
  QPushButton_91->setGeometry(50,90,40,20);
  QPushButton_91->setMinimumSize(0,0);
  QPushButton_91->setText("no");
	QObject::connect( QPushButton_91, SIGNAL(clicked()), this, SLOT( action_noquiet()) );
  QWhatsThis::add(QPushButton_91,"Click this button to execute\nmosctl noquiet on this host.\n");

  QPushButton_30= new QPushButton(backr,hostname);
  QPushButton_30->setGeometry(10,110,40,20);
  QPushButton_30->setMinimumSize(0,0);
  QPushButton_30->setText("yes");
	QObject::connect(   QPushButton_30, SIGNAL(clicked()), this, SLOT( action_lstay()) );
  QWhatsThis::add(QPushButton_30,"Click this button to execute\nmosctl lstay on this host.\n");

  QPushButton_40= new QPushButton(backr,hostname);
  QPushButton_40->setGeometry(50,110,40,20);
  QPushButton_40->setMinimumSize(0,0);
  QPushButton_40->setText("no");
	QObject::connect(   QPushButton_40, SIGNAL(clicked()), this, SLOT( action_nolstay()) );
  QWhatsThis::add(QPushButton_40,"Click this button to execute\nmosctl nolstay on this host.\n");

  QPushButton_50= new QPushButton(backr,hostname);
  QPushButton_50->setGeometry(10,130,40,20);
  QPushButton_50->setMinimumSize(0,0);
  QPushButton_50->setText("yes");
	QObject::connect(   QPushButton_50, SIGNAL(clicked()), this, SLOT( action_block()) );
  QWhatsThis::add(QPushButton_50,"Click this button to execute\nmosctl block on this host.\n");

  QPushButton_60= new QPushButton(backr,hostname);
  QPushButton_60->setGeometry(50,130,40,20);
  QPushButton_60->setMinimumSize(0,0);
  QPushButton_60->setText("no");
	QObject::connect(   QPushButton_60, SIGNAL(clicked()), this, SLOT( action_noblock()) );
  QWhatsThis::add(QPushButton_60,"Click this button to execute\nmosctl noblock on this host.\n");

  QPushButton_80= new QPushButton(backr,hostname);
  QPushButton_80->setGeometry(10,150,40,20);
  QPushButton_80->setMinimumSize(0,0);
  QPushButton_80->setToggleButton (TRUE);
  QPushButton_80->setText("start");
	QObject::connect( QPushButton_80, SIGNAL(clicked()), this, SLOT( action_start()) );
  QWhatsThis::add(QPushButton_80,"Click this button to start\nmosix on this host.\n");

	QPushButton_90= new QPushButton(backr,hostname);
  QPushButton_90->setGeometry(50,150,40,20);
  QPushButton_90->setMinimumSize(0,0);
	QPushButton_90->setToggleButton (TRUE);
  QPushButton_90->setText("stop");
	QObject::connect( QPushButton_90, SIGNAL(clicked()), this, SLOT( action_stop()) );
  QWhatsThis::add(QPushButton_90,"Click this button to stop\nmosix on this host.\n");

  QPushButton_14= new QPushButton(end, hostname, backr);
  QPushButton_14->setGeometry(180,260,60,20);
  QPushButton_14->setMinimumSize(0,0);
  QPushButton_14->setText("close");
  QWhatsThis::add(QPushButton_14,"Close MOSIX-configuration\n");
	QObject::connect( QPushButton_14, SIGNAL(clicked()), hinten1, SLOT( close()) );

  apply_button= new QPushButton(applyit, hostname, backr);
  apply_button->setGeometry(10,170,80,20);
  apply_button->setMinimumSize(0,0);
  apply_button->setText("apply");
  apply_button->setName(hostname);
  QWhatsThis::add(apply_button,"Click this button to apply the changes\n");
	QObject::connect( apply_button, SIGNAL(clicked()), this, SLOT( apply_changes()) );

  proc_remotecon= new QPushButton(hosti, hostname, backr);
  proc_remotecon->setGeometry(10,200,80,20);
  proc_remotecon->setMinimumSize(0,0);
  proc_remotecon->setText("console");
  proc_remotecon->setName(hostname);
  QWhatsThis::add(proc_remotecon,"Open a remote console. Insert your workstation-hostname in the box below if you work from remote\n");
	QObject::connect( proc_remotecon, SIGNAL(clicked()), this, SLOT( open_remotecon()) );

  proc_remotebox= new QPushButton(migrat, hostname, backr);
  proc_remotebox->setGeometry(100,200,140,20);
  proc_remotebox->setMinimumSize(0,0);
  proc_remotebox->setText("remote proc-box");
  proc_remotebox->setName(hostname);
  QWhatsThis::add(proc_remotebox,"Open a remote process box. Insert your workstation-hostname in the box below if you work from remote\n");
	QObject::connect( proc_remotebox, SIGNAL(clicked()), this, SLOT( open_remoteprocs()) );

  QLabel_display= new QLabel(hinten1,hostname);
  QLabel_display->setGeometry(10,255,50,20);
  QLabel_display->setMinimumSize(0,0);
  QLabel_display->setText("-display");
  QLabel_display->setMargin(1);

	display_edit= new QComboBox(TRUE, hinten1, "display");
	display_edit->setGeometry(65,255,110,20);
	display_edit->setMinimumSize(0,0);
	display_edit->setMaxCount(10);

	if ((fp1=fopen("/root/.mosixview.disp", "r"))!=NULL) {

		for(entries=0; (entries<10)&&(!feof(fp1)); entries++) {
			fscanf(fp1, "%s", displays);

			if(!strcmp(displays, s)==0) {
				display_edit->insertItem(displays, -1);
			}
		}
		display_edit->removeItem(display_edit->count()-1);
    fclose(fp1);
    }	else {
		printf("could not open hostlist /root/.mosixview.disp\n");
	}
	display_edit->setEditText(s);

  QLabel_display2= new QLabel(hinten1,hostname);
  QLabel_display2->setGeometry(175,255,5,20);
  QLabel_display2->setMinimumSize(0,0);
  QLabel_display2->setText(":");

	display_one= new QSpinBox(hinten1, "display1");
  display_one->setGeometry(180,255,30,20);
  display_one->setMinimumSize(0,0);

  QLabel_display1= new QLabel(hinten1,hostname);
  QLabel_display1->setGeometry(210,255,5,20);
  QLabel_display1->setMinimumSize(0,0);
  QLabel_display1->setText(".");

	display_two= new QSpinBox(hinten1, "display1");
  display_two->setGeometry(215,255,30,20);
  display_two->setMinimumSize(0,0);

  QPushButton_clear= new QPushButton(clearit, hostname, backr);
  QPushButton_clear->setGeometry(10,260,60,20);
  QPushButton_clear->setMinimumSize(0,0);
  QPushButton_clear->setText("clear");
  QWhatsThis::add(QPushButton_clear,"clear the edit-box above\n");
	QObject::connect( QPushButton_clear, SIGNAL(clicked()), display_edit, SLOT(clearEdit()) );

  QPushButton_chistory= new QPushButton(backr, hostname);
  QPushButton_chistory->setGeometry(80,260,90,20);
  QPushButton_chistory->setMinimumSize(0,0);
  QPushButton_chistory->setText("clear history");
  QWhatsThis::add(QPushButton_chistory,"clear the history\n");
	QObject::connect( QPushButton_chistory, SIGNAL(clicked()), this, SLOT(clear_history()) );

  QLabel_hostconf5= new QLabel(hinten1,hostname);
  QLabel_hostconf5->setGeometry(30,10,200,20);
  QLabel_hostconf5->setMinimumSize(0,0);
  QLabel_hostconf5->setText("MOSIX-configuration");
  QLabel_hostconf5->setMargin(2);

  QLabel_conficon= new QLabel(hinten1,hostname);
  QLabel_conficon->setGeometry(10,10,20,20);
  QLabel_conficon->setMinimumSize(0,0);
  QLabel_conficon->setPixmap(conf);

	if( (QCheckBox_3->isChecked())&&(strcmp(hostname, "all-nodes")) ) {
	  QLabel_hostconf8= new QLabel(hinten1,hostname);
	  QLabel_hostconf8->setGeometry(15,40,80,20);
	  QLabel_hostconf8->setMinimumSize(0,0);
	  QLabel_hostconf8->setText("hostname:");
	  QLabel_hostconf8->setMargin(2);

	  QLabel_hostconf9= new QLabel(hinten1,hostname);
	  QLabel_hostconf9->setGeometry(15,65,80,20);
	  QLabel_hostconf9->setMinimumSize(0,0);
	  QLabel_hostconf9->setText("ip-address:");
	  QLabel_hostconf9->setMargin(2);

	  QLabel_hostconf= new QLabel(hinten1,hostname);
	  QLabel_hostconf->setGeometry(100,40,120,20);
	  QLabel_hostconf->setMinimumSize(0,0);
	  QLabel_hostconf->setMargin(2);
	  QLabel_hostconf->setFrameStyle( QFrame::Panel | QFrame::Sunken );

	  QLabel_hostconf7= new QLabel(hinten1,hostname);
	  QLabel_hostconf7->setGeometry(100,65,120,20);
	  QLabel_hostconf7->setMinimumSize(0,0);
	  QLabel_hostconf7->setMargin(2);
	  QLabel_hostconf7->setFrameStyle( QFrame::Panel | QFrame::Sunken );
		} else {
	  QLabel_hostconf8= new QLabel(hinten1,hostname);
	  QLabel_hostconf8->setGeometry(15,60,80,20);
	  QLabel_hostconf8->setMinimumSize(0,0);
	  QLabel_hostconf8->setText("mosix-node:");
	  QLabel_hostconf8->setMargin(2);

	  QLabel_hostconf= new QLabel(hinten1,hostname);
	  QLabel_hostconf->setGeometry(100,60,120,20);
	  QLabel_hostconf->setMinimumSize(0,0);
	  QLabel_hostconf->setMargin(2);
	  QLabel_hostconf->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	  QLabel_hostconf->setText(hostname);
	  QLabel_hostconf->setBackgroundPixmap(QPixmap(white_pix));
	}

  QLabel_hostconf1= new QLabel(hinten1,"conf1");
  QLabel_hostconf1->setGeometry(100,100,140,20);
  QLabel_hostconf1->setMinimumSize(0,0);
  QLabel_hostconf1->setText("auto-migration on/off");
  QLabel_hostconf1->setMargin(2);

  QLabel_hostconf6= new QLabel(hinten1,"quiet");
  QLabel_hostconf6->setGeometry(100,120,140,20);
  QLabel_hostconf6->setMinimumSize(0,0);
  QLabel_hostconf6->setText("talk to others nodes");
  QLabel_hostconf6->setMargin(2);

  QLabel_hostconf2= new QLabel(hinten1,"conf2");
  QLabel_hostconf2->setGeometry(100,140,140,20);
  QLabel_hostconf2->setMinimumSize(0,0);
  QLabel_hostconf2->setText("local procs stay");
  QLabel_hostconf2->setMargin(2);

  QLabel_hostconf3= new QLabel(hinten1,"conf3");
  QLabel_hostconf3->setGeometry(100,160,140,20);
  QLabel_hostconf3->setMinimumSize(0,0);
  QLabel_hostconf3->setText("send away guest procs");
  QLabel_hostconf3->setMargin(2);

  QLabel_hostconf4= new QLabel(hinten1,"conf4");
  QLabel_hostconf4->setGeometry(100,180,140,20);
  QLabel_hostconf4->setMinimumSize(0,0);
  QLabel_hostconf4->setText("MOSIX start/stop");
  QLabel_hostconf4->setMargin(2);

	hinten1->show();

	if( (QCheckBox_3->isChecked())&&(strcmp(hostname, "all-nodes")) ) {

		if (inet_aton(hostname, &num)!=0) {
			host=gethostbyaddr((char*)&num, sizeof(num), AF_INET);
			ip=(struct in_addr**)host->h_addr_list;
			hostname2=host->h_name;

		  QLabel_hostconf->setText(hostname2);
		  QLabel_hostconf->setBackgroundPixmap(QPixmap(white_pix));
		  QLabel_hostconf7->setText(hostname);
		  QLabel_hostconf7->setBackgroundPixmap(QPixmap(white_pix));
      } else {
			host=gethostbyname(hostname);
			ip=(struct in_addr**)host->h_addr_list;
			sprintf(ipaddr, "%s",inet_ntoa(**ip));
		  QLabel_hostconf->setText(hostname);
		  QLabel_hostconf->setBackgroundPixmap(QPixmap(white_pix));
		  QLabel_hostconf7->setText(ipaddr);
		  QLabel_hostconf7->setBackgroundPixmap(QPixmap(white_pix));
		}

		} else {
	}

	delete [] temp;
	delete [] displays;

}




void MosixviewApp::close_config() {
	delete hinten1;
}


void MosixviewApp::mosixstatus() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char *fspeed;
	fspeed = new char[100];
  char *cstatus;
	cstatus = new char[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;

 	QPixmap green_pix;
	green_pix= QPixmap(green_xpm);
 	QPixmap red_pix;
	red_pix= QPixmap(red_xpm);

	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

		while ((dir_info = readdir(dir))!=NULL) {
			howmany++;
		}
			howmany--;
	}
	closedir(dir);

	for (status=1;status<howmany;status++) {
		sprintf(cstatus, "%d", status);	
		strcpy(fspeed, "");
		strcpy(fspeed, "/proc/mosix/nodes/");
		strcat(fspeed, cstatus);
		strcat(fspeed, "/speed");

		if((zahl=fopen(fspeed, "r")) == NULL) {
      } else {
       fscanf(zahl, "%d", &nummerint);
			if(nummerint>=2) {
				QLabel_stat[status]->setBackgroundPixmap(QPixmap(green_pix));
				} else {
				QLabel_stat[status]->setBackgroundPixmap(QPixmap(red_pix));
			}
			fclose(zahl);
		}
	}

	if(QFile::exists("/tmp/mosixcollector.pid")) {
		label_collector2->setBackgroundPixmap(QPixmap(green_pix));
		} else {
		label_collector2->setBackgroundPixmap(QPixmap(red_pix));
	}

	delete [] fspeed;
	delete [] cstatus;

}




void MosixviewApp::refreshit_status() {

	if(QCheckBox_2->isChecked()) {
		mosixstatus();
	}

}





void MosixviewApp::initActions(){

  QPixmap openIcon, saveIcon, newIcon, help, prem;
  newIcon = QPixmap(filenew);
  openIcon = QPixmap(fileopen);
  saveIcon = QPixmap(filesave);
	help = QPixmap(helpicon);
	prem = QPixmap(remote);

	fileOpen = new QAction(tr("Run program"), openIcon, tr("&Run..."), 0, this);
  fileOpen->setStatusTip(tr("Run a program"));
  fileOpen->setWhatsThis(tr("Run a program"));
  connect(fileOpen, SIGNAL(activated()), this, SLOT(slotFileOpen()));

  fileQuit = new QAction(tr("Exit"), tr("E&xit"), QAccel::stringToKey(tr("Ctrl+Q")), this);
  fileQuit->setStatusTip(tr("Quits the application"));
  fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
  connect(fileQuit, SIGNAL(activated()), qApp, SLOT(quit()));

  viewToolBar = new QAction(tr("Toolbar"), tr("Tool&bar"), 0, this, 0, true);
  viewToolBar->setStatusTip(tr("Enables/disables the toolbar"));
  viewToolBar->setWhatsThis(tr("Toolbar\n\nEnables/disables the toolbar"));
  connect(viewToolBar, SIGNAL(toggled(bool)), this, SLOT(slotViewToolBar(bool)));

  viewStatusBar = new QAction(tr("Statusbar"), tr("&Statusbar"), 0, this, 0, true);
  viewStatusBar->setStatusTip(tr("Enables/disables the statusbar"));
  viewStatusBar->setWhatsThis(tr("Statusbar\n\nEnables/disables the statusbar"));
  connect(viewStatusBar, SIGNAL(toggled(bool)), this, SLOT(slotViewStatusBar(bool)));

  helpAboutApp = new QAction(tr("Help"), help,tr("&Help..."), 0, this);
  helpAboutApp->setStatusTip(tr("Help on mosixview"));
  helpAboutApp->setWhatsThis(tr("Help on mosixview"));
  connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));

  configsave = new QAction(tr("Save config"), saveIcon,tr("&Save config"), 0, this);
  configsave->setStatusTip(tr("Saves MOSIXVIEWs current confgig"));
  configsave->setWhatsThis(tr("Saves MOSIXVIEWs current confgig"));
  connect(configsave, SIGNAL(activated()), this, SLOT(save_config()));

}



void MosixviewApp::initMenuBar() {

  fileMenu=new QPopupMenu();
  fileOpen->addTo(fileMenu);
  fileMenu->insertSeparator();
  fileQuit->addTo(fileMenu);

	refreshmenu=new QPopupMenu();
	refreshmenu->setCheckable(true);

	confmenu=new QPopupMenu();
	confmenu->setCheckable(true);

	refreshmenu->insertItem("status", this, SLOT(toggle_config_stat()), 0, ID_STAT);
	refreshmenu->setItemChecked(ID_CONFIG, false);

	refreshmenu->insertItem("load", this, SLOT(toggle_config_load()), 0, ID_LOAD);
	refreshmenu->setItemChecked(ID_LOAD, true);

	confmenu->insertItem("refresh", refreshmenu);
	confmenu->insertSeparator();
	confmenu->insertItem("nslookup", this, SLOT(toggle_config_ns()), 0, ID_CONFIG);
	confmenu->setItemChecked(ID_CONFIG, false);
	confmenu->insertItem("use ssh", this, SLOT(toggle_menu_ssh()), 0, ID_SSH);
	confmenu->setItemChecked(ID_SSH, false);
	confmenu->insertSeparator();
	confmenu->insertItem("save conf", this, SLOT(save_config()), 0, ID_SAVE);

  analyzer_menu=new QPopupMenu();
	analyzer_menu->insertItem("mosixload", this, SLOT(start_mosixload()), 0, ID_MOSIXLOAD);
	analyzer_menu->insertSeparator();
	analyzer_menu->insertItem("mosixmem", this, SLOT(start_mosixmem()), 0, ID_MOSIXMEM);
	analyzer_menu->insertSeparator();
	analyzer_menu->insertItem("mosixhistory", this, SLOT(start_mosixhistory()), 0, ID_MOSIXHISTORY);

	viewMenu=new QPopupMenu();
  viewMenu->setCheckable(true);
  viewToolBar->addTo(viewMenu);
  viewStatusBar->addTo(viewMenu);

  helpMenu=new QPopupMenu();
  helpMenu->insertItem("Help",this, SLOT(slotHelpAbout()), 0, ID_HELP_ABOUT);
  helpMenu->insertSeparator();
  helpMenu->insertItem("About...", this, SLOT(slotHelp()), 0, ID_HELP_HELP);

	collector_start_stop=new QPopupMenu();
	collector_start_stop->insertItem("start", this, SLOT(start_mosixcollector()), 0, ID_COL_START);
	collector_start_stop->insertSeparator();
	collector_start_stop->insertItem("stop", this, SLOT(stop_mosixcollector()), 0, ID_COL_STOP);
	collector_start_stop->insertSeparator();
	collector_start_stop->insertItem("checkpoint", this, SLOT(checkpoint_mosixcollector()), 0, ID_COL_CHECK);
	collector_start_stop->insertSeparator();
	collector_start_stop->insertItem("save history", this, SLOT(save_mosixcollector()), 0, ID_COL_SHIST);
	collector_start_stop->insertSeparator();
	collector_start_stop->insertItem("clear history", this, SLOT(clear_mosixcollector()), 0, ID_COL_CHIST);

	collectormenu=new QPopupMenu();
	collectormenu->insertItem("mosixcollector", collector_start_stop);

  menuBar()->insertItem(tr("&File"), fileMenu);
  menuBar()->insertItem(tr("&View"), viewMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Config"), confmenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("Collector"), collectormenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Analyzer"), analyzer_menu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Help"), helpMenu);

}






void MosixviewApp::initToolBar()
{


	QPixmap end, proc, white_pix, blacky;
	end = QPixmap(ende);
	proc = QPixmap(proc_g);
	white_pix = QPixmap(white_xpm);
	blacky = QPixmap(black_xpm);

  QLabel_top= new QLabel(this,"NoName");
  QLabel_top->setGeometry(0,26,740,88);
  QLabel_top->setMinimumSize(0,0);

  QLabel_top1= new QLabel(this,"NoName");
  QLabel_top1->setGeometry(0,25,740,1);
  QLabel_top1->setMinimumSize(0,0);
  QLabel_top1->setBackgroundPixmap(QPixmap(blacky));

  QLabel_top2= new QLabel(this,"NoName");
  QLabel_top2->setGeometry(0,112,740,1);
  QLabel_top2->setMinimumSize(0,0);
  QLabel_top2->setBackgroundPixmap(QPixmap(blacky));

  QLabel_top3= new QLabel(this,"NoName");
  QLabel_top3->setGeometry(0,80,740,1);
  QLabel_top3->setMinimumSize(0,0);
  QLabel_top3->setBackgroundPixmap(QPixmap(blacky));

  QLabel_top4= new QLabel(this,"NoName");
  QLabel_top4->setGeometry(0,51,740,1);
  QLabel_top4->setMinimumSize(0,0);
  QLabel_top4->setBackgroundPixmap(QPixmap(blacky));

  fileToolbar = new QToolBar(this, "file operations");
  fileToolbar->setGeometry(5,25,700,25);
  fileOpen->addTo(fileToolbar);
  fileToolbar->addSeparator();
	configsave->addTo(fileToolbar);
  fileToolbar->addSeparator();
  QWhatsThis::whatsThisButton(fileToolbar);
  fileToolbar->addSeparator();
	helpAboutApp->addTo(fileToolbar);

  label_collector1= new QLabel(this,"collector1");
  label_collector1->setGeometry(275,30,120,20);
  label_collector1->setMinimumSize(0,0);
  label_collector1->setText("mosixcollector status");
  label_collector1->setMargin(1);

  label_collector2= new QLabel(this,"collector2");
  label_collector2->setGeometry(260,35,10,10);
  label_collector2->setMinimumSize(0,0);
  label_collector2->setFrameStyle( QFrame::Panel | QFrame::Sunken );
  label_collector2->setText("");
  label_collector2->setMargin(1);

  procbox_button= new QPushButton(proc, "procs", this);
  procbox_button->setGeometry(655,30,80,20);
  procbox_button->setMinimumSize(0,0);
  procbox_button->setText("procbox");
  QWhatsThis::add(procbox_button,"Click this button to open\na local process-box.\n");

  QCheckBox_2= new QCheckBox(this,"NoName");
  QCheckBox_2->setGeometry(5,55,140,25);
  QCheckBox_2->setMinimumSize(0,0);
  QCheckBox_2->setText("auto-refresh status");
  QCheckBox_2->setChecked(false);
	QWhatsThis::add(QCheckBox_2 ,"Toggles auto/manually refresh of the status box.\n");

  QCheckBox_3= new QCheckBox(this,"NoName");
  QCheckBox_3->setGeometry(150,55,220,25);
  QCheckBox_3->setMinimumSize(0,0);
  QCheckBox_3->setText("nslookup hostname in configurator");
	QWhatsThis::add(QCheckBox_3 ,"Toggles hostname lookup in the configuration dialog.(do not use this if your nodes only have ip adresses)\n");

  QCheckBox_4= new QCheckBox(this,"NoName");
  QCheckBox_4->setGeometry(390,55,120,25);
  QCheckBox_4->setMinimumSize(0,0);
  QCheckBox_4->setText("load refresh on/off");
  QCheckBox_4->setChecked(true);
	QWhatsThis::add(QCheckBox_4 ,"Toggles the load-refresh.\n");

  QCheckBox_5= new QCheckBox(this,"NoName");
  QCheckBox_5->setGeometry(540,55,170,25);
  QCheckBox_5->setMinimumSize(0,0);
  QCheckBox_5->setText("use ssh (not rsh)");
	QWhatsThis::add(QCheckBox_5 ,"Uses SSH instead of RSH for executing remote configuration commands.\n");

  QLabel_22= new QLabel(this,"NoName");
  QLabel_22->setGeometry(40,85,90,25);
  QLabel_22->setMinimumSize(0,0);
  QLabel_22->setText("clusternodes");
  QLabel_22->setMargin(0);

  QLabel_6= new QLabel(this,"NoName");
  QLabel_6->setGeometry(170,85,120,25);
  QLabel_6->setMinimumSize(0,0);
  QLabel_6->setText("set priority/speed");
  QLabel_6->setMargin(5);

  QLabel_2= new QLabel(this,"NoName");
  QLabel_2->setGeometry(310,85,80,25);
  QLabel_2->setMinimumSize(0,0);
  QLabel_2->setText("mosix load");
  QLabel_2->setMargin(5);

  QLabel_memory= new QLabel(this,"NoName");
  QLabel_memory->setGeometry(450,85,100,25);
  QLabel_memory->setMinimumSize(0,0);
  QLabel_memory->setText("used memory");
  QLabel_memory->setMargin(5);

  QLabel_gesamtmem= new QLabel(this,"NoName");
  QLabel_gesamtmem->setGeometry(580,85,80,25);
  QLabel_gesamtmem->setMinimumSize(0,0);
  QLabel_gesamtmem->setText("avaiable(MB)");
  QLabel_gesamtmem->setMargin(1);

  QLabel_cpus= new QLabel(this,"NoName");
  QLabel_cpus->setGeometry(665,85,50,25);
  QLabel_cpus->setMinimumSize(0,0);
  QLabel_cpus->setText("CPU(s)");
  QLabel_cpus->setMargin(1);


}







void MosixviewApp::initStatusBar()
{
  statusBar()->message(tr("Ready."), 2000);
}






void MosixviewApp::slotFileOpen()
{


	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;

 	QPixmap end, procicon_g, white_pix, host;
	end = QPixmap(ende);
	procicon_g= QPixmap(proc_g);
	white_pix= QPixmap(white_xpm);
	host= QPixmap(hosti_g);

	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

		while ((dir_info = readdir(dir))!=NULL) {
			howmany++;
		}
		howmany--;
		howmany--;
	}
	closedir(dir);
  statusBar()->message(tr("running programm..."));
  QString fileName = QFileDialog::getOpenFileName(0,0,this);

  if (!fileName.isEmpty())  {
		hinten2= new QWidget(0, fileName);
		hinten2->setGeometry(100,130,50,110);
		hinten2->setMinimumSize(0,0);
		hinten2->resize(400, 280);
		hinten2->setFixedSize(400, 280);

		exec_label1 = new QLabel("",hinten2);
		exec_label1->setGeometry(35,5,200,20);
		exec_label1->setMinimumSize(0,0);
		exec_label1->setText("MOSIXVIEW Advanced Execution");

	  exec_label2= new QLabel("",hinten2);
	  exec_label2->setGeometry(5,5,20,20);
	  exec_label2->setMinimumSize(0,0);
	  exec_label2->setPixmap(procicon_g);

		QButtonGroup *back1 = new QButtonGroup("",hinten2);
		back1->setGeometry(5, 30, 245,215);
		back1->setMinimumSize(0,0);
		back1->resize(390, 240);
		back1->setExclusive(true);

	  QPushButton_exe_end= new QPushButton(end, "close", back1);
	  QPushButton_exe_end->setGeometry(320,210,60,20);
	  QPushButton_exe_end->setMinimumSize(0,0);
	  QPushButton_exe_end->setText("close");
		QObject::connect( QPushButton_exe_end, SIGNAL(clicked()), hinten2, SLOT(close()) );
	  QWhatsThis::add(QPushButton_exe_end,"Close the advanced\nexecution dialog.");

	  QPushButton_exe= new QPushButton(procicon_g, "execute", back1);
	  QPushButton_exe->setGeometry(150,210,150,20);
	  QPushButton_exe->setMinimumSize(0,0);
	  QPushButton_exe->setText("execute");
		QObject::connect( QPushButton_exe, SIGNAL(clicked()), this, SLOT(execute_it()) );
	  QWhatsThis::add(QPushButton_exe,"Click this button to execute\nthe the commandline.");

	  QPushButton_parallel_exe= new QPushButton(procicon_g, "execute parallel", back1);
	  QPushButton_parallel_exe->setGeometry(150,210,150,20);
	  QPushButton_parallel_exe->setMinimumSize(0,0);
	  QPushButton_parallel_exe->setText("parallel execute");

	  QPushButton_parallel_exe->hide();
	  QPushButton_parallel_exe->setEnabled(false);
		QObject::connect( QPushButton_parallel_exe, SIGNAL(clicked()), this, SLOT(parallel_execute_it()) );
	  QWhatsThis::add(QPushButton_parallel_exe,"Click this button to execute\nthe the commandline parallel on\nseveral cluster-nodes.");

		QGroupBox *chooser = new QGroupBox("host-chooser",back1);
		chooser->setGeometry(150,70,100,150);
		chooser->setMinimumSize(0,0);
		chooser->resize(190, 120);

		lcd_host_chooser=new QLCDNumber(chooser, "lcdhostchooser");
		lcd_host_chooser->setGeometry(120, 60, 50, 20);
		lcd_host_chooser->setNumDigits(4);
		lcd_host_chooser->display(1);
		lcd_host_chooser->setSegmentStyle(QLCDNumber::Flat);

		host_chooser= new QDial(chooser, "hostchooser");
		host_chooser->setGeometry(10, 25, 80, 80);
		host_chooser->setMinValue(1);
		host_chooser->setMaxValue(howmany);
		host_chooser->setLineStep(1);
		host_chooser->setNotchesVisible(true);
		host_chooser->setValue(1);
		QObject::connect( host_chooser, SIGNAL(valueChanged(int)), lcd_host_chooser, SLOT(display(int)) );
	  QWhatsThis::add(host_chooser,"Choose a mosix-node for running the command on.");

		nomig_check= new QRadioButton(back1, "nomig");
		nomig_check->setGeometry(10,50,100,20);
		nomig_check->setText("no migration");
		QObject::connect(nomig_check, SIGNAL(clicked()), chooser, SLOT(hide()) );
		QObject::connect(nomig_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(nomig_check,"Runs a non migrating job.");

		runhome_check= new QRadioButton(back1, "runhome");
		runhome_check->setGeometry(10,70,100,20);
		runhome_check->setText("run home");
		QObject::connect(runhome_check, SIGNAL(clicked()), chooser, SLOT(hide()) );
		QObject::connect(runhome_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
  	QWhatsThis::add(runhome_check,"Runs a job on the home node.");

		runon_check= new QRadioButton(back1, "runon");
		runon_check->setGeometry(10,90,100,20);
		runon_check->setText("run on");
		runon_check->setChecked(true);
		QObject::connect(runon_check, SIGNAL(clicked()), chooser, SLOT(show()) );
		QObject::connect(runon_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(runon_check,"Runs a job on one mosix-node.");

		cpu_check= new QRadioButton(back1, "cpujob");
		cpu_check->setGeometry(10,110,100,20);
		cpu_check->setText("cpu job");
		QObject::connect(cpu_check, SIGNAL(clicked()), chooser, SLOT(show()) );
		QObject::connect(cpu_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(cpu_check,"Runs a cpu-intensive job on one mosix-node.");

		iojob_check= new QRadioButton(back1, "iojob");
		iojob_check->setGeometry(10,130,100,20);
		iojob_check->setText("io job");
		QObject::connect(iojob_check, SIGNAL(clicked()), chooser, SLOT(show()) );
		QObject::connect(iojob_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(iojob_check,"Runs a io-intensive job on one mosix-node.");

		nodecay_check= new QRadioButton(back1, "nodecay");
		nodecay_check->setGeometry(10,150,100,20);
		nodecay_check->setText("no decay");
		QObject::connect(nodecay_check, SIGNAL(clicked()), chooser, SLOT(show()) );
		QObject::connect(nodecay_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(nodecay_check,"Runs job with no decay on one mosix-node.");

		slowdecay_check= new QRadioButton(back1, "slowdecay");
		slowdecay_check->setGeometry(10,170,100,20);
		slowdecay_check->setText("slow decay");
		QObject::connect(slowdecay_check, SIGNAL(clicked()), chooser, SLOT(show()) );
		QObject::connect(slowdecay_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(slowdecay_check,"Runs job with slow decay on one mosix-node.");

		fastdecay_check= new QRadioButton(back1, "fastdecay");
		fastdecay_check->setGeometry(10,190,100,20);
		fastdecay_check->setText("fast decay");
		QObject::connect(fastdecay_check, SIGNAL(clicked()), chooser, SLOT(show()) );
		QObject::connect(fastdecay_check, SIGNAL(clicked()), this, SLOT(no_parallel()) );
	  QWhatsThis::add(fastdecay_check,"Runs job with fast decay on one mosix-node.");

		parallel_check= new QRadioButton(back1, "parallel");
		parallel_check->setGeometry(10,210,100,20);
		parallel_check->setText("parallel");
		QObject::connect(parallel_check, SIGNAL(clicked()), chooser, SLOT(hide()) );
		QObject::connect(parallel_check, SIGNAL(clicked()), this, SLOT(parallel_command()) );
  	QWhatsThis::add(parallel_check,"Runs parallel command on several mosix-nodes.");

		command_line= new QLineEdit(back1, "commandline");
		command_line->setGeometry(5, 10, 370,20);
		command_line->setMinimumSize(0,0);
		command_line->setMaxLength(290);
		command_line->setText(fileName);
	  QWhatsThis::add(command_line,"You can specify the way how\nthis command should be executed.");

		option_label1 = new QLabel("options",back1);
		option_label1->setGeometry(5,30,370,20);
		option_label1->setMinimumSize(0,0);
		option_label1->setText("(you can now specify additional command-line arguments)");

		option_label2 = new QLabel("options1",chooser);
		option_label2->setGeometry(100, 15, 80, 40);
		option_label2->setMinimumSize(0,0);
		option_label2->setText("run job on\nMOSIX-node");

		option_label3 = new QLabel("nodeicon",chooser);
		option_label3->setGeometry(100, 60, 20, 20);
		option_label3->setMinimumSize(0,0);
		option_label3->setPixmap(host);

		node_hint = new QLabel("hint",chooser);
		node_hint->setGeometry(130, 85, 20, 20);
		node_hint->setMinimumSize(0,0);
		node_hint->setText("");
		node_hint->hide();

		hinten2->show();

		parallel_label1 = new QLabel("exe parallel",back1);
		parallel_label1->setGeometry(150, 70, 170, 20);
		parallel_label1->setMinimumSize(0,0);
		parallel_label1->setText("Execute this command parallel");
		parallel_label1->hide();

		parallel_label2 = new QLabel("exe parallel",back1);
		parallel_label2->setGeometry(150, 100, 80, 20);
		parallel_label2->setMinimumSize(0,0);
		parallel_label2->setText("from node");
		parallel_label2->hide();

		parallel_label3 = new QLabel("exe parallel",back1);
		parallel_label3->setGeometry(250, 100, 80, 20);
		parallel_label3->setMinimumSize(0,0);
		parallel_label3->setText("up to node");
		parallel_label3->hide();

		parallel_from= new QSpinBox(back1, "from");
	  parallel_from->setGeometry(210,100,35,20);
	  parallel_from->setMinimumSize(0,0);
	  parallel_from->setValue(1);
	  parallel_from->setMinValue(1);
	  parallel_from->setMaxValue(howmany);
	  parallel_from->hide();
		QObject::connect(parallel_from, SIGNAL(valueChanged(int)), this, SLOT(sync_qspinbox(int)));
	  QWhatsThis::add(parallel_from,"Specify the first node on which\nthe command should be executed.");

		parallel_to= new QSpinBox(back1, "to");
	  parallel_to->setGeometry(320,100,35,20);
	  parallel_to->setMinimumSize(0,0);
	  parallel_to->setValue(howmany);
	  parallel_to->setMinValue(1);
	  parallel_to->setMaxValue(howmany);
	  parallel_to->hide();
		QObject::connect(parallel_to, SIGNAL(valueChanged(int)), this, SLOT(sync_qspinbox(int)));
	  QWhatsThis::add(parallel_to,"Specify the last node on which\nthe command should be executed.");

	  QCheckBox_6= new QCheckBox(hinten2,"NoName");
	  QCheckBox_6->setGeometry(215,170,150,20);
	  QCheckBox_6->setMinimumSize(0,0);
	  QCheckBox_6->setText("reverse selection");
	  QCheckBox_6->setChecked(false);
	  QCheckBox_6->hide();
		QWhatsThis::add(QCheckBox_6 ,"Executes the command on all other nodes\nbut not on the selected ones\n");
		} else {
    statusBar()->message(tr("running aborted"), 2000);
  }

}







void MosixviewApp::execute_it() {

  char *temp;
	temp = new char[300];
  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

  QString message=tr("execute  ")+command_line->text();
	strcpy(temp, "");

	if (nomig_check->isOn()) {
		strcpy(temp, "nomig ");
		strcpy(outp, "run a local, non migrating job");
	  statusBar()->message(outp);
	}

	if (runhome_check->isOn()) {
		strcpy(temp, "runhome ");
		strcpy(outp, "run a local job");
	  statusBar()->message(outp);
	}

	if (runon_check->isOn()) {

		strcpy(temp, "runon ");
  	node_hint->setNum(lcd_host_chooser->intValue());
  	strcat(temp, node_hint->text());
  	strcat(temp, " ");
		strcpy(outp, "run a job on mosix-node ");
		strcat(outp, node_hint->text());
	  statusBar()->message(outp);
	}

	if (cpu_check->isOn()) {
		strcpy(temp, "cpujob -");
  	node_hint->setNum(lcd_host_chooser->intValue());
  	strcat(temp, node_hint->text());
  	strcat(temp, " ");
		strcpy(outp, "run a cpujob on mosix-node ");
		strcat(outp, node_hint->text());
	  statusBar()->message(outp);
	}

	if (iojob_check->isOn()) {
		strcpy(temp, "iojob -");
  	node_hint->setNum(lcd_host_chooser->intValue());
  	strcat(temp, node_hint->text());
  	strcat(temp, " ");
		strcpy(outp, "run a iojob on mosix-node ");
		strcat(outp, node_hint->text());
	  statusBar()->message(outp);
	}

	if (nodecay_check->isOn()) {
		strcpy(temp, "nodecay -");
  	node_hint->setNum(lcd_host_chooser->intValue());
  	strcat(temp, node_hint->text());
  	strcat(temp, " ");
		strcpy(outp, "run a nodecay job on mosix-node ");
		strcat(outp, node_hint->text());
	  statusBar()->message(outp);
	}

	if (slowdecay_check->isOn()) {
		strcpy(temp, "slowdecay -");
  	node_hint->setNum(lcd_host_chooser->intValue());
  	strcat(temp, node_hint->text());
  	strcat(temp, " ");
		strcpy(outp, "run a slowdecay job on mosix-node ");
		strcat(outp, node_hint->text());
	  statusBar()->message(outp);
	}

	if (fastdecay_check->isOn()) {
		strcpy(temp, "fastdecay -");
  	node_hint->setNum(lcd_host_chooser->intValue());
  	strcat(temp, node_hint->text());
  	strcat(temp, " ");
		strcpy(outp, "run a fastdecay job on mosix-node ");
		strcat(outp, node_hint->text());
  	statusBar()->message(outp);
	}

	strcat(temp, command_line->text());
	strcat(temp, "&");

	if (system(temp)) {
		statusBar()->message(tr("could not execute"), 2000);
		} else {
		statusBar()->message(message, 2000);
	}

	delete [] temp;
	delete [] outp;
}





void MosixviewApp::slotViewToolBar(bool toggle) {

	statusBar()->message(tr("Toggle toolbar..."));
	if (toggle== false) {
    fileToolbar->hide();
	  } else {
    fileToolbar->show();
  }
  statusBar()->message(tr("Ready."));
}




void MosixviewApp::slotViewStatusBar(bool toggle) {

  statusBar()->message(tr("Toggle statusbar..."));
  if (toggle == false) {
		statusBar()->hide();
	  } else {
		statusBar()->show();
	}
	statusBar()->message(tr("Ready."));
}







void MosixviewApp::slotHelpAbout() {

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
  QPixmap help, prem, conf, com, lo, procicon_g, smile, fresh, migrat, load_icon, collector_icon, open_icon, finder;
	help = QPixmap(helpicon);
	prem = QPixmap(remote);
	conf = QPixmap(config);
	lo = QPixmap(load);
	com = QPixmap(comment);
	procicon_g= QPixmap(proc_g);
	smile = QPixmap(speed);
	fresh = QPixmap(refresh);
	migrat = QPixmap(migrator);
	load_icon = QPixmap(load2);
	collector_icon = QPixmap(collector);
	open_icon = QPixmap(fileopen_hell);
	finder = QPixmap(filefind);

	QTabDialog *tabs = new QTabDialog();
	tabs->setGeometry(200,50,300,200);
	tabs->resize(530, 300);

	QLabel *a = new QLabel(tabs, 0, 0);
	a->setGeometry(5,5,20,20);
	a->resize(200, 200);
	a->setMargin(3);
	a->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	a->setBackgroundPixmap(QPixmap(white_pix));
	a->setText("Help on MOSIXVIEW\n\nMOSIXVIEW is designed to manage MOSIX-Cluster.\n"	\
	"(more information on the great MOSIX on www.mosix.org\n" \
	"MOSIX is developed at the university of Jerusalem)\n" \
	"It gives an overview of what happen on your system(s)\nand helps to distribute processes to the best avaiable nodes\n" \
	"automatically or manually. The configuration of each.\n" \
	"cluster-member can be change by dialogs-windows.\n\n" \
	"I hope this free software is usefull for you and your are\n" \
	"invited to send me your comments or wanted features.\n\n" \
	"M. Rechenburg / rechenburger@netcologne.de");

	QLabel *b = new QLabel(tabs, 0, 0);
	b->setGeometry(5,5,20,20);
	b->resize(200, 200);
	b->setMargin(3);
	b->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	b->setBackgroundPixmap(QPixmap(white_pix));
	b->setText("Config your cluster\n\nIf you click on an host-button a configuration-dialog will pop up\n"	\
	"The following most common use mosix-commands can be execute\n" \
	"on every cluster-node:\n" \
	"automigration on/off, quiet yes/no, bring/lstay yes/no,\n" \
	"expel yes/no, mosix stop/start.\n\n" \
	"(if the nslookup-checkbox is checked MOSIXVIEW will lookup the\n" \
	"hostname and ip-adress in the configuration-dialog.\n" \
	"Do not use this option if your cluster-nodes only have\n" \
	"ip-adresses and no hostnames (e.g. DNS or /etc/hosts entry).\n" \
	"If MOSIXVIEW cannot find the hostname it will quit!)\n");

	QLabel *c = new QLabel(tabs, 0, 0);
	c->setGeometry(5,5,20,20);
	c->resize(200, 200);
	c->setMargin(3);
	c->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	c->setBackgroundPixmap(QPixmap(white_pix));
	c->setText("Set the speed/priority of each node\n\nYou can adjust the mosix-speed with the sliders for each node.\n"	\
	"Processes will easier migrate to cluster-nodes with more mosix-speed.\n" \
	"Just increase the speed of one host which less load and the load\n" \
	"will also increase because MOSIX 'thinks' that this host can handle\n" \
	"more processes and will migrate processes to.\n" \
	"If an host has too much load, decrease the speed and the load will\n" \
	"decrease, too.\n\n" \
	"Use the speed-sliders to set the priority for each cluster-member.\n" \
	"Of course you can change this also at runtime.\n" \
	"Managing the load-balancing manually or automatically is easy now.\n");

	QLabel *d = new QLabel(tabs, 0, 0);
	d->setGeometry(5,5,20,20);
	d->resize(200, 200);
	d->setMargin(3);
	d->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	d->setBackgroundPixmap(QPixmap(white_pix));
	d->setText("Load and Memory on your cluster\n\n"	\
	"The two progressbars are displaying the load and memory values\n" \
	"on your cluster.\n" \
	"\n" \
	"Memory is count in percent of used memory on each cluster-node.\n" \
	"The whole physical avaiable memory is shown on the left of the\n" \
	"memory-progressbar.\n" \
	"\n" \
	"The load is count in percent too so it just gives you an overview\n" \
	"of the load. It does not exactly represent the the value of\n" \
	"/proc/mosix/nodes/x/load of each node!\n" \
	"\n");

	QLabel *e = new QLabel(tabs, 0, 0);
	e->setGeometry(5,5,20,20);
	e->resize(200, 200);
	e->setMargin(3);
	e->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	e->setBackgroundPixmap(QPixmap(white_pix));
	e->setText("Processes on your cluster\n\nClick on the local procbox button and\n"	\
	"you can watch all your running processes on the local maschine.\n" \
	"(you should start all procs from your 'local-node' because then\n" \
	"they appear in the process-list as local)\n" \
	"The processes are sorted by the column you click on.\n" \
	"Just double-click on a process and a new dialog-box will appear\n" \
	"in which you can choose the host you want the process to migrate\n" \
	"to. The second column shows the MOSIX-node number on which the\n" \
	"process is running. 0 stands for local, any other number is remote.\n" \
	"Remote processes are easy to recognize by the green proc-icon.\n" \
	"Unmoveable processes will appear with a lock icon!\n");

	QLabel *f = new QLabel(tabs, 0, 0);
	f->setGeometry(5,5,20,20);
	f->resize(200, 200);
	f->setMargin(3);
	f->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	f->setBackgroundPixmap(QPixmap(white_pix));
	f->setText("Refresh or not refresh\n\nThe status, load and memory-views can set to refresh\n"	\
	"automatically by the checkboxes or by the config-menu.\n" \
	"It may be usefull to disable the refreshs sometimes to\n" \
	"decrease the network-traffic/load.\n" \
	"\n" \
	"Check the nslookup-checkbox if your nodes are in DNS or\n" \
	"have hostname-entries in your /etc/hosts file.\n" \
	"If MOSIXVIEW cannot lookup the hostname it will quit.\n\n" \
	"\n" \
	"\n");

	QLabel *g = new QLabel(tabs, 0, 0);
	g->setGeometry(5,5,20,20);
	g->resize(200, 200);
	g->setMargin(3);
	g->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	g->setBackgroundPixmap(QPixmap(white_pix));
	g->setText("Managing procs from remote nodes\n\nBy clicking on the button below the processbox you can influence\n"	\
	"the processes from remote nodes running on this host.\n" \
	"The popup-window will show how many procs from remote are\n" \
	"currently migrated to this host and from where they come from.\n" \
	"\n" \
	"You can migrate one processes back to its home node or to the\n" \
	"best avaiable node in your cluster. If you choose the second\n" \
	"possibility MOSIX decides where the proc will go.\n" \
	"(this can also influenced by the speed-sliders)\n" \
	"\n" \
	"\n");

	QLabel *h = new QLabel(tabs, 0, 0);
	h->setGeometry(5,5,20,20);
	h->resize(200, 200);
	h->setMargin(3);
	h->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	h->setBackgroundPixmap(QPixmap(white_pix));
	h->setText("Remote processbox\n\nIn the configuration window of each host you can\n"	\
	"click on the remote-procbox-button to open a remote migrator-box.\n" \
	"If properly installed on each cluster-node this button executes a\n" \
	"xhost +hostname local on your maschine to allow remote X-apps to be\n" \
	"displayed. After that it runs a rsh (or ssh) to the node which opens the process-box.\n" \
  "\n" \
	"If you are logged on your cluster from a remote workstation put your local hostname\n" \
	"in the edit-box below the 'remote proc-box'-button. Then the mosixview_client will\n" \
	"be displayed on your workstations display and not on the display of the\n" \
	"cluster-node you are logged on (add 'xhost +clusternode' at your workstation).\n");

	QLabel *i = new QLabel(tabs, 0, 0);
	i->setGeometry(5,5,20,20);
	i->resize(200, 200);
	i->setMargin(3);
	i->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	i->setBackgroundPixmap(QPixmap(white_pix));
	i->setText("Help on MOSIX- LOAD, MEM, HISTORY and COLLECTOR\n\n"	\
	"MOSIXLOAD, MOSIXMEM, MOSIXHISTORY and MOSIXCOLLECTOR are \n" \
	"usefull to have a history-view of your MOSIX-cluster.\n" \
	"The MOSIXCOLLECTOR is a daemon running on one cluster-node.\n" \
	"It saves the load+mem of each cluster-member to a directory.\n" \
	"MOSIXLOAD, -MEM and HISTORY analyzes the files in this directory\n" \
	"and produce a graphical overview of the load- and memory history.\n" \
	"All MOSIX-tools can be managed from the main MOSIXVIEW-application.\n" \
	"You can even set checkpoints everytime you want. These checkpoints\n" \
	"are marked in MOSIXLOAD/MOSIXMEM. This help describes how to use these tools.\n" \
	"M. Rechenburg / rechenburger@netcologne.de");

	QLabel *j = new QLabel(tabs, 0, 0);
	j->setGeometry(5,5,20,20);
	j->resize(200, 200);
	j->setMargin(3);
	j->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	j->setBackgroundPixmap(QPixmap(white_pix));
	j->setText("MOSIXCOLLECTOR\n"	\
	"The MOSIXCOLLECTOR is a small daemon started on one cluster-member.\n" \
	"It collects the load/mem/procs of all cluster-nodes to /tmp/mosixview/*\n" \
	"and writes a  PID-file to /tmp/mosixcollector.pid.\n" \
	"mosixcollector -d			// starts the collector as a daemon\n" \
	"mosixcollector -k			// stops the collector\n" \
	"mosixcollector -c			// stops the collector and delete the history-files\n" \
	"mosixcollector -n			// write a checkpoint to the history\n" \
	"mosixcollector -r			// saves the history and start a new one\n" \
	"				// (automatically executed once a day!)\n" \
	"mosixcollector -help		// print out a short help\n" \
	"mosixcollector -h			// print out a short help\n");

	QLabel *k = new QLabel(tabs, 0, 0);
	k->setGeometry(5,5,20,20);
	k->resize(200, 200);
	k->setMargin(3);
	k->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	k->setBackgroundPixmap(QPixmap(white_pix));
	k->setText("MOSIXLOAD\n\n"	\
	"MOSIXLOAD analyzes the data collected by MOSIXCOLLECTOR\n" \
	"in a graphical way. By default it displays the current dataset\n" \
	"from the directory /tmp/mosixview/* but of course you can open older\n" \
	"history logfiles by the filemenu.\n" \
	"MOSIXLOAD displays one whole day of load information from your cluster.\n" \
	"Black lines are values <50, yellow lines are values >50 and the red lines are\n" \
	"values above 80. If there was a checkpoint written you can see it as\n" \
	"a vertical blue line. You can easily get the avarage value of each node\n" \
	"by clicking on the X-button of each node.\n");

	QLabel *l = new QLabel(tabs, 0, 0);
	l->setGeometry(5,5,20,20);
	l->resize(200, 200);
	l->setMargin(3);
	l->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	l->setBackgroundPixmap(QPixmap(white_pix));
	l->setText("MOSIXMEM\n\n"	\
	"MOSIXMEM is similar to MOSIXLOAD\n" \
	"By default it displays the current dataset from the directory\n" \
	"/tmp/mosixview/* and like MOSIXLOAD you can open older history\n" \
	"logfiles by the filemenu, too.\n" \
	"MOSIXMEM displays one whole day of memory information from your cluster.\n" \
	"The black line shows the used memory in percent from the avaiable mem.\n" \
	"You can get the avarage value of used memory by clicking on the\n" \
	"X-button of each node.\n");

	QLabel *m = new QLabel(tabs, 0, 0);
	m->setGeometry(5,5,20,20);
	m->resize(200, 200);
	m->setMargin(3);
	m->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	m->setBackgroundPixmap(QPixmap(white_pix));
	m->setText("MOSIXHISTORY\n\n"	\
	"MOSIXHISTORY is a process-history view.\n" \
	"By default it displays the current dataset from the directory\n" \
	"/tmp/mosixview/* and like MOSIXLOAD (or MOSIXMEM) you can \n" \
	"open older history logfiles by the filemenu, too.\n" \
	"MOSIXHISTORY starts at the start-date of the MOSIXCOLLECTOR\n" \
	"and you can move on in time by the time-line slider.\n" \
	"One mouseclick is similar to one minute.\n" \
	"The processbox displays the processes and where they ran\n" \
	"in dependency of the time (startdate +minutes).\n");

	QLabel *n = new QLabel(tabs, 0, 0);
	n->setGeometry(5,5,20,20);
	n->resize(200, 200);
	n->setMargin(3);
	n->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	n->setBackgroundPixmap(QPixmap(white_pix));
	n->setText("Open older logfiles\n\n"	\
	"The MOSIXCOLLECTOR writes the current dataset of load-informations to\n" \
	"/tmp/mosixview/*  and saves this directory to /tmp/mosixview[date]/*\n" \
	"automatically once a day.\n" \
	"Open the main logfile /tmp/mosixview[date]/mosix.load by the filemenu\n" \
	"and you can analyze the older logfiles.\n" \
	"\n" \
	"You have to open only the main logfile mosix.load for the complet history\n" \
	"information view.\n" \
	"\n");

	QLabel *o = new QLabel(tabs, 0, 0);
	o->setGeometry(5,5,20,20);
	o->resize(200, 200);
	o->setMargin(3);
	o->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	o->setBackgroundPixmap(QPixmap(white_pix));
	o->setText("Comments on MOSIXVIEW\n\n"	\
	"I am looking forward to any comment, bug report or\n" \
	"wanted features.\n" \
	"I also want to use this for saying thanks to Prof. Amnon Barak,\n" \
	"Moshe Bar and their developers for the great work they do on MOSIX.\n" \
	"Thanks to all testers of MOSIXVIEW who report bugs/probs ot me.\n" \
	"Last but not least a warm thanks also to my wife who\n" \
	"gives me the time for developing, clustering, linuxing,\n" \
	"fixing problems, installing, trying new software.....\n" \
	"\n" \
	"Hope you have fun with MOSIXVIEW.\n");

	tabs->addTab(a, help,  "general");
	tabs->addTab(b, conf,  "config");
	tabs->addTab(c, smile, "speed");
	tabs->addTab(d, lo, "load");
	tabs->addTab(e, procicon_g, "procs");
	tabs->addTab(f, fresh, "refresh");
	tabs->addTab(g, prem, "remote");
	tabs->addTab(h, migrat, "migrator");
	tabs->addTab(i, help, "load/collector");
	tabs->addTab(j, collector_icon, "mosixcollector");
	tabs->addTab(k, load_icon, "mosixload");
	tabs->addTab(l, load_icon, "mosixmem");
	tabs->addTab(m, finder, "mosixhistory");
	tabs->addTab(n, open_icon, "open history");
	tabs->addTab(o, com, "comments");
	tabs->show();
}





void MosixviewApp::slotHelp() {
  QMessageBox::about(this,"About...", IDS_APP_ABOUT );
}





void MosixviewApp::toggle_config_stat() {

	if (confmenu->isItemChecked(ID_STAT)) {
		confmenu->setItemChecked(ID_STAT, false);
		QCheckBox_2->toggle();
		} else {
		confmenu->setItemChecked(ID_STAT, true);
		QCheckBox_2->toggle();
	}
}



void MosixviewApp::toggle_config_ns() {

   if (confmenu->isItemChecked(ID_CONFIG)) {
		confmenu->setItemChecked(ID_CONFIG, false);
		QCheckBox_3->toggle();
	  } else {
		confmenu->setItemChecked(ID_CONFIG, true);
		QCheckBox_3->toggle();
	}
}



void MosixviewApp::toggle_ns_menu(bool on) {

   if (!on) {
		confmenu->setItemChecked(ID_CONFIG, false);
		} else {
		confmenu->setItemChecked(ID_CONFIG, true);
	}
}




void MosixviewApp::toggle_stat_menu(bool on) {

   if (!on) {
		confmenu->setItemChecked(ID_STAT, false);
		} else {
		confmenu->setItemChecked(ID_STAT, true);
	}
}




void MosixviewApp::toggle_config_load() {

   if (confmenu->isItemChecked(ID_LOAD)) {
		confmenu->setItemChecked(ID_LOAD, false);
		QCheckBox_4->toggle();
		} else {
		confmenu->setItemChecked(ID_LOAD, true);
		QCheckBox_4->toggle();
	}
}




void MosixviewApp::toggle_load_menu(bool on) {

   if (!on) {
		confmenu->setItemChecked(ID_LOAD, false);
		} else {
		confmenu->setItemChecked(ID_LOAD, true);
	}
}





void MosixviewApp::toggle_ssh(bool on) {

   if (!on) {
		confmenu->setItemChecked(ID_SSH, false);
		} else {
		confmenu->setItemChecked(ID_SSH, true);
	}
}





void MosixviewApp::toggle_menu_ssh() {

	if (confmenu->isItemChecked(ID_SSH)) {
		confmenu->setItemChecked(ID_SSH, false);
		QCheckBox_5->toggle();
		} else {
		confmenu->setItemChecked(ID_SSH, true);
		QCheckBox_5->toggle();
	}
}





void MosixviewApp::open_remoteprocs() {

	FILE *fp;
	const char *hostname;
	const QObject *button = sender();
  hostname=button->name();
  char *setsp;
	setsp = new char[150];
  char *setsp1;
	setsp1 = new char[100];
  char *setsp2;
	setsp2 = new char[100];
  char *temp;
	temp = new char[100];
  char *outp;
	outp = new char[100];
	int error;
	int entries;
	int neu=0;
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;
	int j=0;

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	strcpy(outp, "open a remote processbox");
  statusBar()->message(outp);

	if (!display_edit->currentText().isEmpty()) {

		if(strcmp(QLabel_hostconf->text(), "all-nodes")) {
			strcpy(setsp1, "");
			strcpy(setsp1, "xhost +");
			strcat(setsp1, hostname);
			if((error=system(setsp1)) > 0) {
				printf("cannot set xhost + for remote host\n");
        } else {
        printf("set xhost + for remote host.\nIf you have your X-screen not on the node mosixview is running on\nyou have to 'xhost +' for your X-display too!\n");
			}

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosixview_client -display ");
				strcat(setsp, display_edit->currentText());
				strcat(setsp, ":");
				strcat(setsp, display_one->text());
				strcat(setsp, ".");
				strcat(setsp, display_two->text());
				strcat(setsp, "&");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosixview_client -display ");
				strcat(setsp, display_edit->currentText());
				strcat(setsp, ":");
				strcat(setsp, display_one->text());
				strcat(setsp, ".");
				strcat(setsp, display_two->text());
				strcat(setsp, "&");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot open remote processbox\n");
				strcpy(outp, "cannot open remote processbox");
			  statusBar()->message(outp);
        } else {
				printf("Initializing MOSIXVIEW-CLIENT...\n");
			}

			} else {


			strcpy(setsp1, "");
			strcpy(setsp1, "xhost +");
			if((error=system(setsp1)) > 0) {
				printf("cannot set xhost +\n");
        } else {
	      printf("set xhost + .\nIf you have your X-screen not on the node mosixview is running on\nyou have to 'xhost +' for your X-display too!\n");
			}

			if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

				while ((dir_info = readdir(dir))!=NULL) {
					howmany++;
				}
				howmany--;
			}
			closedir(dir);

		  for(j=1; j<howmany; j++) {
				strcpy(setsp2, "");
				strcpy(setsp2, QPushButton_host[j]->text());

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosixview_client -display ");
					strcat(setsp, display_edit->currentText());
					strcat(setsp, ":");
					strcat(setsp, display_one->text());
					strcat(setsp, ".");
					strcat(setsp, display_two->text());
					strcat(setsp, "&");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosixview_client -display ");
					strcat(setsp, display_edit->currentText());
					strcat(setsp, ":");
					strcat(setsp, display_one->text());
					strcat(setsp, ".");
					strcat(setsp, display_two->text());
					strcat(setsp, "&");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot open remote processbox\n");
					strcpy(outp, "cannot open remote processbox");
					statusBar()->message(outp);
	        } else {
					printf("Initializing MOSIXVIEW-CLIENT...\n");
				}

			} //for

		}	// allnodes end

		for(entries=0; entries<display_edit->count(); entries++) {

			if(strcmp(display_edit->currentText(), display_edit->text(entries))==0) {
				neu=1;
			}
		}

		if (!neu) {
			display_edit->insertItem(display_edit->currentText(), 0);
		}

		if ((fp=fopen("/root/.mosixview.disp", "w"))!=NULL) {

			for(entries=0; entries<display_edit->count(); entries++) {
				fputs(display_edit->text(entries), fp);
				fputs("\n", fp);
			}
      fclose(fp);
      }	else {
			printf("could not write hostlist to /root/.mosixview.disp\n");
			strcpy(outp, "could not write hostlist to /root/.mosixview.disp");
		  statusBar()->message(outp);
		}

		} else {
		printf("no hostname to display given\nInsert the hostname you want the mosixview_client\nto be displayed in the edit-box!\n");
		strcpy(outp, "no hostname to display given");
	  statusBar()->message(outp);
	}

	delete [] setsp;
	delete [] setsp1;
	delete [] setsp2;
	delete [] temp;
	delete [] outp;

}









void MosixviewApp::save_config()
{

	FILE *fp;
  char *outp;
	outp = new char[100];
	int sta=0;
	int loa=0;
	int nsl=0;
	int ssh=0;

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (QCheckBox_2->isChecked()) {
		sta=1;
		} else {
		sta=0;
	}

	if (QCheckBox_3->isChecked()) {
		loa=1;
		} else {
		loa=0;
	}

	if (QCheckBox_4->isChecked()) {
		nsl=1;
		} else {
		nsl=0;
	}

	if (QCheckBox_5->isChecked()) {
		ssh=1;
		} else {
		ssh=0;
	}



	if ((fp=fopen("/root/.mosixview", "w"))!=NULL) {
		fprintf(fp, "%d%d%d%d", sta, loa, nsl, ssh);
		fclose(fp);
		printf("config saved to /root/.mosixview.\n");
		strcpy(outp, "config saved to /root/.mosixview");
		statusBar()->message(outp);
		} else {
		printf("failed to save config.\n");
		strcpy(outp, "failed to save config");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::load_config()
{

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QFile map("/root/.mosixview");
  if (map.exists()) {

    if ( map.open(IO_ReadOnly) ) {
			QTextStream t( &map );
			QString s;

			while ( !t.eof() ) {
				s = t.readLine();
			}
			map.close();

			printf("load config from /root/.mosixview.\n");
			strcpy(outp, "load config from /root/.mosixview");
		  statusBar()->message(outp);

			if(QString(s[0]) == "1") {
			  QCheckBox_2->setChecked(true);
				refreshmenu->setItemChecked(ID_STAT, true);
				} else {
			  QCheckBox_2->setChecked(false);
				refreshmenu->setItemChecked(ID_STAT, false);
			}

			if(QString(s[1]) == "1") {
			  QCheckBox_3->setChecked(true);
				confmenu->setItemChecked(ID_CONFIG, true);
				} else {
			  QCheckBox_3->setChecked(false);
				confmenu->setItemChecked(ID_CONFIG, false);
			}

			if(QString(s[2]) == "1") {
			  QCheckBox_4->setChecked(true);
				refreshmenu->setItemChecked(ID_LOAD, true);
				} else {
			  QCheckBox_4->setChecked(false);
				refreshmenu->setItemChecked(ID_LOAD, false);
			}

			if(QString(s[3]) == "1") {
			  QCheckBox_5->setChecked(true);
				confmenu->setItemChecked(ID_SSH, true);
				} else {
			  QCheckBox_5->setChecked(false);
				confmenu->setItemChecked(ID_SSH, false);
			}

			} else {
			printf("could not open config-file /root/.mosixview.\n");
			strcpy(outp, "could not open config-file /root/.mosixview");
		  statusBar()->message(outp);
		}

    } else {
		printf("loading default config.\n");
		strcpy(outp, "loading default config");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::clear_history() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!remove("/root/.mosixview.disp")) {
		printf("history cleared\n");
		strcpy(outp, "history cleared");
	  statusBar()->message(outp);
		} else {
		printf("could not clear history\n");
		strcpy(outp, "could not clear history");
	  statusBar()->message(outp);
	}

	delete [] outp;

}





void MosixviewApp::start_mosixload() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixload &")) {
		printf("starting mosixload\n");
		strcpy(outp, "starting mosixload");
	  statusBar()->message(outp);
		} else {
		printf("could not start mosixload\n");
		strcpy(outp, "could not start mosixload");
	  statusBar()->message(outp);
	}

	delete [] outp;
}







void MosixviewApp::start_mosixmem() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixmem &")) {
		printf("starting mosixmem\n");
		strcpy(outp, "starting mosixmem");
	  statusBar()->message(outp);
		} else {
		printf("could not start mosixmem\n");
		strcpy(outp, "could not start mosixmem");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::start_mosixhistory() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixhistory &")) {
		printf("starting mosixhistory\n");
		strcpy(outp, "starting mosixhistory");
	  statusBar()->message(outp);
		} else {
		printf("could not start mosixhistory\n");
		strcpy(outp, "could not start mosixhistory");
	  statusBar()->message(outp);
	}

	delete [] outp;
}







void MosixviewApp::start_mosixcollector() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QFile map("/tmp/mosixcollector.pid");

  if (map.exists()) {
	  QMessageBox::about(this,tr("mosixcollector already running!"),tr("It seems that the mosixcollector is already running!\n If not, please remove the PID-file\n/tmp/mosixcollctor.pid manually.") );
		} else {

		if (!system("mosixcollector -d")) {
			printf("starting mosixcollector\n");
			strcpy(outp, "starting mosixcollector");
		  statusBar()->message(outp);
			} else {
			printf("could not start mosixcollector\n");
			strcpy(outp, "could not start mosixcollector");
		  statusBar()->message(outp);
		}
	}

	delete [] outp;
}





void MosixviewApp::stop_mosixcollector() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixcollector -k")) {
		printf("stopping mosixcollector\n");
		strcpy(outp, "stopping mosixcollector");
	  statusBar()->message(outp);
		} else {
		printf("could not stop mosixcollector\n");
		strcpy(outp, "could not stop mosixcollector");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::checkpoint_mosixcollector() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixcollector -n")) {
		printf("checkpoint written\n");
		strcpy(outp, "checkpoint written");
	  statusBar()->message(outp);	
		} else {
		printf("could not write checkpoint\n");
		strcpy(outp, "could not write checkpoint");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::clear_mosixcollector() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixcollector -c")) {
		printf("mosixcollector history cleared\n");
		strcpy(outp, "mosixcollector history cleared");
	  statusBar()->message(outp);
		} else {
		printf("could not clear history\n");
		strcpy(outp, "could not clear history");
	  statusBar()->message(outp);
	}

	delete [] outp;
}





void MosixviewApp::save_mosixcollector() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixcollector -r")) {
		printf("mosixcollector history saved to /tmp/mosixview[date]/mosix.load\n");
		strcpy(outp, "mosixcollector history saved");
	  statusBar()->message(outp);
		} else {
		printf("could not save history\n");
		strcpy(outp, "could not save history");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::proc_box() {

  char *outp;
	outp = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	if (!system("mosixview_client &")) {
		printf("open local processbox\n");
		strcpy(outp, "open local processbox");
	  statusBar()->message(outp);
		} else {
		printf("could not open local processbox\n");
		strcpy(outp, "could not open local processbox");
	  statusBar()->message(outp);
	}

	delete [] outp;
}






void MosixviewApp::parallel_command() {

  QPushButton_exe->hide();
	QPushButton_exe->setEnabled(false);
  QPushButton_parallel_exe->show();
  QPushButton_parallel_exe->setEnabled(true);

  parallel_from->show();
  parallel_to->show();
	parallel_label1->show();
	parallel_label2->show();
	parallel_label3->show();
  QCheckBox_6->show();

}





void MosixviewApp::no_parallel() {

  QPushButton_exe->show();
  QPushButton_exe->setEnabled(true);

  QPushButton_parallel_exe->hide();
  QPushButton_parallel_exe->setEnabled(false);

  parallel_from->hide();
  parallel_to->hide();
	parallel_label1->hide();
	parallel_label2->hide();
	parallel_label3->hide();
  QCheckBox_6->hide();

}












void MosixviewApp::parallel_execute_it() {

  char *temp;
	temp = new char[300];
  char *outp;
	outp = new char[100];
	int i=0;

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

  QString message=tr("parallel execute  ")+command_line->text();
	strcpy(temp, "");

	if(QCheckBox_6->isChecked()) {

// ########## reverse

		for (i=1; i<parallel_from->value(); i++) {

			if(QCheckBox_5->isChecked()) {
				strcpy(temp, "");
				strcpy(temp, "ssh ");
				strcat(temp, QPushButton_host[i]->text());
				strcat(temp, " ");
				strcat(temp, command_line->text());
				strcat(temp, " ");
				strcat(temp, "&");
				} else {
				strcpy(temp, "");
				strcpy(temp, "rsh ");
				strcat(temp, QPushButton_host[i]->text());
				strcat(temp, " ");
				strcat(temp, command_line->text());
				strcat(temp, " ");
				strcat(temp, "&");
			}

			if (!system(temp)) {
				printf("parallel command executed\n");
				strcpy(outp, "parallel command executed");
			  statusBar()->message(outp);
				} else {
  			printf("could not execute parallel command\n");
				strcpy(outp, "could not execute parallel command");
			  statusBar()->message(outp);
			}
		}

//#########


		for (i=parallel_to->value()+1; i<=parallel_to->maxValue(); i++) {

			if(QCheckBox_5->isChecked()) {
				strcpy(temp, "");
				strcpy(temp, "ssh ");
				strcat(temp, QPushButton_host[i]->text());
				strcat(temp, " ");
				strcat(temp, command_line->text());
				strcat(temp, " ");
				strcat(temp, "&");
				} else {
				strcpy(temp, "");
				strcpy(temp, "rsh ");
				strcat(temp, QPushButton_host[i]->text());
				strcat(temp, " ");
				strcat(temp, command_line->text());
				strcat(temp, " ");
				strcat(temp, "&");
			}

			if (!system(temp)) {
				printf("parallel command executed\n");
				strcpy(outp, "parallel command executed");
			  statusBar()->message(outp);
				} else {
				printf("could not execute parallel command\n");
				strcpy(outp, "could not execute parallel command");
			  statusBar()->message(outp);
			}
		}

		} else {

// ########## not reverse

		for (i=parallel_from->value(); i<=parallel_to->value(); i++) {

			if(QCheckBox_5->isChecked()) {
				strcpy(temp, "");
				strcpy(temp, "ssh ");
				strcat(temp, QPushButton_host[i]->text());
				strcat(temp, " ");
				strcat(temp, command_line->text());
				strcat(temp, " ");
				strcat(temp, "&");
				} else {
				strcpy(temp, "");
				strcpy(temp, "rsh ");
				strcat(temp, QPushButton_host[i]->text());
				strcat(temp, " ");
				strcat(temp, command_line->text());
				strcat(temp, " ");
				strcat(temp, "&");
			}

			if (!system(temp)) {
				printf("parallel command executed\n");
				strcpy(outp, "parallel command executed");
			  statusBar()->message(outp);
				} else {
				printf("could not execute parallel command\n");
				strcpy(outp, "could not execute parallel command");
			  statusBar()->message(outp);
			}
		}
	}

	delete [] temp;
	delete [] outp;
}





void MosixviewApp::sync_qspinbox(int val) {

	if (parallel_from->value()>parallel_to->value()) {
	  parallel_from->setValue(parallel_to->value());
	}
	val=val;
}




int MosixviewApp::min(int eins, int zwei) {

	if(eins>zwei) {
		return zwei;
		} else {
		return eins;
	}
}


int MosixviewApp::max(int eins, int zwei) {

	if(eins<zwei) {
		return zwei;
		} else {
		return eins;
	}
}







void MosixviewApp::apply_changes() {

  char *setsp;
	setsp = new char[100];
  char *setsp1;
	setsp1 = new char[100];
  char *setsp2;
	setsp2 = new char[100];
  char *outp;
	outp = new char[100];
	int error;
	const char *hostname;
	const QObject *button = sender();
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;
	int j=0;

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	if(strcmp(hostname, "all-nodes")) {

// single node
// automigration on

		if(QPushButton_2->isOn()) {

			strcpy(outp, "");
			strcpy(outp, "auto-migration enabled for ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -stay");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -stay");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set -stay\n");
				strcpy(outp, "");
				strcpy(outp, "failed to set auto-migration enabled for ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// automigration off

		if(QPushButton_12->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "auto-migration disabled for ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl stay");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl stay");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set stay\n");
				strcpy(outp, "");
				strcpy(outp, "failed to disable auto-migration on ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}


// quiet

		if(QPushButton_91->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "auto load-dissemination stopped on ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl quiet");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl quiet");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set quiet\n");
				strcpy(outp, "");
				strcpy(outp, "failed to execute mosctl quiet on ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// noquiet

		if(QPushButton_81->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "auto load-dissemination resumed on ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -quiet");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -quiet");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot execute mosctl -quiet\n");
				strcpy(outp, "");
				strcpy(outp, "failed to execute mosctl -quiet on ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}


// lstay

		if(QPushButton_30->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "local processes return to ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl bring");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl bring");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set -lstay\n");
				strcpy(outp, "");
				strcpy(outp, "cannot return local processes to ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// nolstay

		if(QPushButton_40->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "local processes can migrate on ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -lstay");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -lstay");
			}

			if((error=system(setsp)) > 0) {
        printf("cannot set -lstay\n");
				strcpy(outp, "");
				strcpy(outp, "allowing local processes to migrate failed on ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// block

		if(QPushButton_50->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "blocking enabled for ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl expel");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl expel");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set expel\n");
				strcpy(outp, "");
				strcpy(outp, "failed to set blocking enabled for ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// noblock

		if(QPushButton_60->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "blocking disabled for ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -block");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, hostname);
				strcat(setsp, " mosctl -block");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set -block\n");
				strcpy(outp, "");
				strcpy(outp, "failed to set blocking disabled for ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// start

		if(QPushButton_80->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "starting mosix on ");
			strcat(outp, hostname);
		  statusBar()->message(outp);

		 	QFile map("/etc/rc.d/init.d/mosix");
		  if (map.exists()) {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/rc.d/init.d/mosix start");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/rc.d/init.d/mosix start");
				}

				} else {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/init.d/mosix start");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/init.d/mosix start");
				}
			}

			if((error=system(setsp)) > 0) {
				printf("cannot start mosix\n");
				strcpy(outp, "");
				strcpy(outp, "cannot start mosix on ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

// stop

		if(QPushButton_90->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "stopping mosix on ");
			strcat(outp, hostname);
		  statusBar()->message(outp);
		 	QFile map("/etc/rc.d/init.d/mosix");

		  if (map.exists()) {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/rc.d/init.d/mosix stop");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/rc.d/init.d/mosix stop");
				}

				} else {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/init.d/mosix stop");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, hostname);
					strcat(setsp, " /etc/init.d/mosix stop");
				}
			}

			if((error=system(setsp)) > 0) {
				printf("cannot stop mosix\n");
				strcpy(outp, "");
				strcpy(outp, "cannot stop mosix on ");
				strcat(outp, hostname);
			  statusBar()->message(outp);
			}
		}

		} else {

// all-nodes

		if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

			while ((dir_info = readdir(dir))!=NULL) {
				howmany++;
			}
			howmany--;
		}
		closedir(dir);

	  for(j=1; j<howmany; j++) {
			strcpy(setsp2, "");
			strcpy(setsp2, QPushButton_host[j]->text());
			printf("hostname=%s\n", setsp2);

// automigration on

			if(QPushButton_2->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "auto-migration enabled for ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl -stay");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl -stay");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot set -stay\n");
					strcpy(outp, "");
					strcpy(outp, "failed to set auto-migration enabled for ");
					strcat(outp, setsp2);
			  	statusBar()->message(outp);
        }
			}

// automigration off

			if(QPushButton_12->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "auto-migration disabled for ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl stay");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl stay");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot set stay\n");
					strcpy(outp, "");
					strcpy(outp, "failed to disable auto-migration on ");
					strcat(outp, setsp2);
				  statusBar()->message(outp);
				}
			}

// quiet

			if(QPushButton_91->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "auto load-dissemination stopped on ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl quiet");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl quiet");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot set quiet\n");
					strcpy(outp, "");
					strcpy(outp, "failed to execute mosctl quiet on ");
					strcat(outp, setsp2);
				  statusBar()->message(outp);
				}
			}

// noquiet

			if(QPushButton_81->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "auto load-dissemination resumed on ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl -quiet");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl -quiet");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot execute mosctl -quiet\n");
					strcpy(outp, "");
					strcpy(outp, "failed to execute mosctl -quiet on ");
					strcat(outp, setsp2);
				  statusBar()->message(outp);
        }
			}

// lstay

			if(QPushButton_30->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "local processes return to ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl bring");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl bring");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot set -lstay\n");
					strcpy(outp, "");
					strcpy(outp, "cannot return local processes to ");
					strcat(outp, setsp2);
				  statusBar()->message(outp);
				}
			}

// nolstay

			if(QPushButton_40->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "local processes can migrate on ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl -lstay");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl -lstay");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot set -lstay\n");
					strcpy(outp, "");
					strcpy(outp, "allowing local processes to migrate failed on ");
					strcat(outp, setsp2);
				  statusBar()->message(outp);
				}
			}

// block

			if(QPushButton_50->isOn()) {
				strcpy(outp, "");
				strcpy(outp, "blocking enabled for ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " mosctl expel");
		     } else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, setsp2);
				strcat(setsp, " mosctl expel");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set expel\n");
				strcpy(outp, "");
				strcpy(outp, "failed to set blocking enabled for ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);
			}
		}

// noblock

		if(QPushButton_60->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "blocking disabled for ");
			strcat(outp, setsp2);
		  statusBar()->message(outp);

			if(QCheckBox_5->isChecked()) {
				strcpy(setsp, "");
				strcpy(setsp, "ssh ");
				strcat(setsp, setsp2);
				strcat(setsp, " mosctl -block");
				} else {
				strcpy(setsp, "");
				strcpy(setsp, "rsh ");
				strcat(setsp, setsp2);
				strcat(setsp, " mosctl -block");
			}

			if((error=system(setsp)) > 0) {
				printf("cannot set -block\n");
				strcpy(outp, "");
				strcpy(outp, "failed to set blocking disabled for ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);
			}
		}

// start

		if(QPushButton_80->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "starting mosix on ");
			strcat(outp, setsp2);
		  statusBar()->message(outp);

		 	QFile map("/etc/rc.d/init.d/mosix");

		  if (map.exists()) {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/rc.d/init.d/mosix start");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/rc.d/init.d/mosix start");
		  	}

				} else {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/init.d/mosix start");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/init.d/mosix start");
				}
			}

			if((error=system(setsp)) > 0) {
				printf("cannot start mosix\n");
				strcpy(outp, "");
				strcpy(outp, "cannot start mosix on ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);
			}
		}

// stop

		if(QPushButton_90->isOn()) {
			strcpy(outp, "");
			strcpy(outp, "stopping mosix on ");
			strcat(outp, setsp2);
		  statusBar()->message(outp);

		 	QFile map("/etc/rc.d/init.d/mosix");

		  if (map.exists()) {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/rc.d/init.d/mosix stop");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/rc.d/init.d/mosix stop");
				}

				} else {

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/init.d/mosix stop");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, setsp2);
					strcat(setsp, " /etc/init.d/mosix stop");
				}
			}

			if((error=system(setsp)) > 0) {
				printf("cannot stop mosix\n");
				strcpy(outp, "");
				strcpy(outp, "cannot stop mosix on ");
				strcat(outp, setsp2);
			  statusBar()->message(outp);
			}
		}


	} //for

	delete [] setsp1;
	delete [] setsp2;

}


delete [] setsp;
delete [] outp;

}





void MosixviewApp::open_remotecon() {

	FILE *fp;
  char *setsp;
	setsp = new char[150];
  char *setsp1;
	setsp1 = new char[100];
  char *setsp2;
	setsp2 = new char[100];
  char *temp;
	temp = new char[100];
  char *outp;
	outp = new char[100];
	int error;
	int entries;
	int neu=0;
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;
	int j=0;
	const char *hostname;
	const QObject *button = sender();
  hostname=button->name();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


	strcpy(outp, "open a remote processbox");
  statusBar()->message(outp);

	if (!display_edit->currentText().isEmpty()) {

		if(strcmp(QLabel_hostconf->text(), "all-nodes")) {
			strcpy(setsp1, "");
			strcpy(setsp1, "xhost +");
			strcat(setsp1, hostname);
				if((error=system(setsp1)) > 0) {
	        printf("cannot set xhost + for remote host\n");
  	      } else {
    	    printf("set xhost + for remote host.\nIf you have your X-screen not on the node mosixview is running on\nyou have to 'xhost +' for your X-display too!\n");
				}

				if(QCheckBox_5->isChecked()) {
					strcpy(setsp, "");
					strcpy(setsp, "ssh ");
					strcat(setsp, hostname);
					strcat(setsp, " xterm -display ");
					strcat(setsp, display_edit->currentText());
					strcat(setsp, ":");
					strcat(setsp, display_one->text());
					strcat(setsp, ".");
					strcat(setsp, display_two->text());
					strcat(setsp, "&");
					} else {
					strcpy(setsp, "");
					strcpy(setsp, "rsh ");
					strcat(setsp, hostname);
					strcat(setsp, " xterm -display ");
					strcat(setsp, display_edit->currentText());
					strcat(setsp, ":");
					strcat(setsp, display_one->text());
					strcat(setsp, ".");
					strcat(setsp, display_two->text());
					strcat(setsp, "&");
				}

				if((error=system(setsp)) > 0) {
					printf("cannot open remote console\n");
					strcpy(outp, "cannot open remote console");
				  statusBar()->message(outp);
					} else {
					printf("Open remote console...\n");
				}

				} else {

//############################ remote console for all-nodes

				strcpy(setsp1, "");
				strcpy(setsp1, "xhost +");

				if((error=system(setsp1)) > 0) {
	        printf("cannot set xhost +\n");
	        } else {
  	      printf("set xhost + .\nIf you have your X-screen not on the node mosixview is running on\nyou have to 'xhost +' for your X-display too!\n");
				}

				if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

	        while ((dir_info = readdir(dir))!=NULL) {
						howmany++;
					}
					howmany--;
				}
				closedir(dir);

			  for(j=1; j<howmany; j++) {
					strcpy(setsp2, "");
					strcpy(setsp2, QPushButton_host[j]->text());

					if(QCheckBox_5->isChecked()) {
						strcpy(setsp, "");
						strcpy(setsp, "ssh ");
						strcat(setsp, setsp2);
						strcat(setsp, " xterm -display ");
						strcat(setsp, display_edit->currentText());
						strcat(setsp, ":");
						strcat(setsp, display_one->text());
						strcat(setsp, ".");
						strcat(setsp, display_two->text());
						strcat(setsp, "&");
						} else {
						strcpy(setsp, "");
						strcpy(setsp, "rsh ");
						strcat(setsp, setsp2);
						strcat(setsp, " xterm -display ");
						strcat(setsp, display_edit->currentText());
						strcat(setsp, ":");
						strcat(setsp, display_one->text());
						strcat(setsp, ".");
						strcat(setsp, display_two->text());
						strcat(setsp, "&");
					}

					if((error=system(setsp)) > 0) {
		        printf("cannot open remote console\n");
						strcpy(outp, "cannot open remote console");
					  statusBar()->message(outp);
    		    } else {
						printf("Open remote console...\n");
					}

				} //for
			}	// allnodes end

			for(entries=0; entries<display_edit->count(); entries++) {

				if(strcmp(display_edit->currentText(), display_edit->text(entries))==0) {
					neu=1;
				}
			}

			if (!neu) {
				display_edit->insertItem(display_edit->currentText(), 0);
			}

      if ((fp=fopen("/root/.mosixview.disp", "w"))!=NULL) {

				for(entries=0; entries<display_edit->count(); entries++) {
					fputs(display_edit->text(entries), fp);
					fputs("\n", fp);
				}
        fclose(fp);
        }	else {
				printf("could not write hostlist to /root/.mosixview.disp\n");
				strcpy(outp, "could not write hostlist to /root/.mosixview.disp");
			  statusBar()->message(outp);
			}

		} else {
		printf("no hostname to display given\nInsert the hostname you want the mosixview_client\nto be displayed in the edit-box!\n");
		strcpy(outp, "no hostname to display given");
  	statusBar()->message(outp);
	}

	delete [] setsp;
	delete [] setsp1;
	delete [] setsp2;
	delete [] temp;
	delete [] outp;

}













