/***************************************************************************
                          mosixview.h  -  description
                             -------------------
    begin                : Tue Jun 26 16:06:00 GMT 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOSIXVIEW_H
#define MOSIXVIEW_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qfile.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qscrollbar.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qprogressbar.h>
#include <qlistbox.h>
#include <qaccel.h>
#include <qtextstream.h>
#include <qtabdialog.h>
#include <qmultilineedit.h>
#include <qlineedit.h>
#include <qfont.h>
#include <qtimer.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qdial.h>
#include <qcombobox.h>
#include <qspinbox.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/resource.h>


#include "resource.h"








// application specific includes
#include "mosixviewview.h"
#include "mosixviewdoc.h"

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class MosixviewView is
  * created which creates your view.
  */
class MosixviewApp : public QMainWindow
{
  Q_OBJECT
  
public:

    /** construtor */
    MosixviewApp();
    /** destructor */
    ~MosixviewApp();

    void initDialog();
    void initActions();
    void initMenuBar();
    void initToolBar();
    void initStatusBar();

public slots:

	void slotFileOpen();
	void slotViewToolBar(bool toggle);
	void slotViewStatusBar(bool toggle);
	void slotHelpAbout();
	void slotHelp();
	void setupQuit();
	void scroll_view(int value);
	void getconfig();
	void typval();
	void getval();
	void setspeed(int speed);
	void toggle_ns_menu(bool on);
	void toggle_config_ns();
	void toggle_stat_menu(bool on);
	void toggle_config_stat();
	void toggle_load_menu(bool on);
	void toggle_config_load();
	void toggle_ssh(bool on);
	void toggle_menu_ssh();
	void save_config();
	void load_config();
	void action_lstay();
	void action_nolstay();
	void action_migration();
	void action_nomigration();
	void action_stop();
	void action_start();
	void action_block();
	void action_noblock();
	void action_noquiet();
	void action_quiet();
	void neuwin1();
	void close_config();
	void mosixstatus();
	void refreshit_status();
	void open_remoteprocs();
	void open_remotecon();
	void execute_it();
	void clear_history();
	void start_mosixload();
	void start_mosixmem();
	void start_mosixhistory();
	void start_mosixcollector();
	void stop_mosixcollector();
	void checkpoint_mosixcollector();
	void clear_mosixcollector();
	void save_mosixcollector();
	void proc_box();
	void parallel_command();
	void no_parallel();
	void parallel_execute_it();
	void sync_qspinbox(int val);
	void apply_changes();
	int max(int eins, int zwei);
	int min(int eins, int zwei);

protected:

	QScrollBar *QScrollBar_1;
	QPushButton *QPushButton_1;
	QGroupBox *QGroupBox_1;
	QLabel *QLabel_22;
	QLabel *QLabel_top;
	QLabel *QLabel_top1;
	QLabel *QLabel_top2;
	QLabel *QLabel_top3;
	QLabel *QLabel_top4;
	QLabel *QLabel_6;
	QLabel *QLabel_2;
	QLabel *QLabel_memory;
	QLabel *QLabel_gesamtmem;
	QLabel *QLabel_cpus;
	QCheckBox *QCheckBox_2;
	QCheckBox *QCheckBox_3;
	QCheckBox *QCheckBox_4;
	QCheckBox *QCheckBox_5;
	QCheckBox *QCheckBox_6;
	QLabel *QLabel_host[1000];
	QLabel *QLabel_stat[1000];
	QLabel *QLabel_memo[1000];
	QSlider *QSlider_host[1000];
	QLCDNumber *QLCDNumber_host[1000];
	QProgressBar *QProgressBar_host[1000];
	QProgressBar *QProgressBar_mem[1000];
	QPushButton *QPushButton_host[1000];
	QLabel *QLabel_howmany_cpus[1000];
	QPushButton *proc_remotebox;
	QPushButton *proc_remotecon;
	QPushButton *QPushButton_2;
	QPushButton *QPushButton_12;
	QPushButton *QPushButton_30;
	QPushButton *QPushButton_40;
	QPushButton *QPushButton_50;
	QPushButton *QPushButton_60;
	QPushButton *QPushButton_71;
	QPushButton *QPushButton_72;
	QPushButton *QPushButton_80;
	QPushButton *QPushButton_90;
	QPushButton *QPushButton_81;
	QPushButton *QPushButton_91;
	QPushButton *QPushButton_14;
	QLabel *QLabel_hostconf;
	QLabel *QLabel_hostconf1;
	QLabel *QLabel_hostconf2;
	QLabel *QLabel_hostconf3;
	QLabel *QLabel_hostconf4;
	QLabel *QLabel_hostconf5;
	QLabel *QLabel_hostconf6;
	QLabel *QLabel_hostconf7;
	QLabel *QLabel_hostconf8;
	QLabel *QLabel_hostconf9;
	QLabel *QLabel_conficon;
	QLabel *QLabel_display;
	QLabel *QLabel_display1;
	QLabel *QLabel_display2;
	QComboBox *display_edit;
	QPushButton *QPushButton_clear;
	QPushButton *QPushButton_chistory;
  QWidget *hinten1;
  QWidget *hinten2;
	QSpinBox *display_one;
	QSpinBox *display_two;
	QTabDialog *rem;
	QLabel *rem_processbox[500];
	QLabel *rem_from_who[500];
	QLabel *rem_from_ip[500];
	QLabel *rem_from_who_label[500];
	QLabel *rem_from_ip_label[500];
	QPushButton *rem_gohome[500];
	QPushButton *rem_gobest[500];
	QMultiLineEdit* qtchild[500];
	QLabel *rem_stats[500];
	QPushButton *QPushButton_exe_end;
	QPushButton *QPushButton_parallel_exe;
	QPushButton *QPushButton_exe;
	QLineEdit *command_line;
	QLabel *exec_label1;
	QLabel *exec_label2;
	QRadioButton *nomig_check;
	QRadioButton *runhome_check;
	QRadioButton *runon_check;
	QRadioButton *cpu_check;
	QRadioButton *iojob_check;
	QRadioButton *nodecay_check;
	QRadioButton *slowdecay_check;
	QRadioButton *fastdecay_check;
	QRadioButton *parallel_check;
	QDial *host_chooser;
	QLCDNumber *lcd_host_chooser;
	QLabel *option_label1;
	QLabel *option_label2;
	QLabel *option_label3;
	QLabel *node_hint;
	QLabel *label_collector1;
	QLabel *label_collector2;
	QPushButton *procbox_button;
	QSpinBox *parallel_from;
	QSpinBox *parallel_to;
	QLabel *parallel_label1;
	QLabel *parallel_label2;
	QLabel *parallel_label3;
	QProgressBar *QProgressBar_overall;
	QPushButton *QPushButton_all_nodes;
	QPushButton *apply_button;
	QProgressBar *QProgressBar_balance;
	QLabel *QLabel_balance;
	QLabel *QLabel_overall_mem;
	QLabel *QLabel_overall_mem1;
	QLabel *QLabel_overall_mem2;
	QLabel *QLabel_overall_mem3;
	QLabel *QLabel_overall_mem4;
	QLabel *QLabel_overall_mem5;
	QLabel *QLabel_allcpu;
	QLabel *QLabel_allcpu1;
	QLabel *QLabel_overall_load;

	virtual void resizeEvent(QResizeEvent* ev) {
	  QScrollBar_1->setGeometry(720,112,20,ev->size().height()-150);
	}

private:

	MosixviewView *view;
	MosixviewDoc *doc;

	QPopupMenu *fileMenu;
	QPopupMenu *confmenu;
	QPopupMenu *refreshmenu;
	QPopupMenu *viewMenu;
	QPopupMenu *analyzer_menu;
	QPopupMenu *helpMenu;
	QPopupMenu *collectormenu;
	QPopupMenu *collector_start_stop;
	QToolBar *fileToolbar;
	QAction *fileOpen;
	QAction *fileQuit;
	QAction *config_stat;
	QAction *viewToolBar;
	QAction *viewStatusBar;
	QAction *helpAboutApp;
	QAction *configsave;
};
#endif 

