/***************************************************************************
                          mosixview_client.cpp  -  description
                             -------------------
    begin                : Fri Jul  6 19:44:05 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include "mosixview_client.h"

#include "white.xpm"
#include "hosti.xpm"
#include "proc.xpm"
#include "proc_g.xpm"
#include "proc_remote.xpm"
#include "refresh.xpm"
#include "speed.xpm"
#include "migrator.xpm"
#include "gohome.xpm"
#include "kill.xpm"
#include "ende.xpm"
#include "proc_cant.xpm"



Mosixview_clientApp::Mosixview_clientApp() {

  char *temp;
	temp = new char[100];

	QFile fp("/etc/HOSTNAME");

	if ( fp.open(IO_ReadOnly) ) {
		QTextStream t( &fp );
		QString s;
		s = t.readLine();
		s = s.simplifyWhiteSpace();
	  setCaption(tr("procs on "+ s));
		fp.close();
		} else {
		strcpy(temp, "");
	  strcpy(temp, "hostname > /tmp/stat.temp");

			if(!system(temp)) {
				QFile fp1("/tmp/stat.temp");

				if ( fp1.open(IO_ReadOnly) ) {
					QTextStream t1( &fp1 );
					QString s1;
					s1 = t1.readLine();
					s1 = s1.simplifyWhiteSpace();
					fp1.close();
				  setCaption(tr("procs on "+ s1));
	     	}
		}	
	}
	initDialog();

	delete [] temp;
}


Mosixview_clientApp::~Mosixview_clientApp()
{
}





void  Mosixview_clientApp::initDialog(){

  char *sub_string;
	sub_string = new char[50];
  char *temp1;
	temp1 = new char[200];
	FILE *fp;

	QPixmap white_pix, fresh, end;
	white_pix= QPixmap(white_xpm);
	fresh = QPixmap(refresh);
	end = QPixmap(ende);

  QCheckBox_1= new QCheckBox(this,"NoName");
  QCheckBox_1->setGeometry(85,35,100,20);
  QCheckBox_1->setMinimumSize(0,0);
  QCheckBox_1->setText("auto-refresh");
  QCheckBox_1->setChecked(true);
  QWhatsThis::add(QCheckBox_1,"If this checkbox is enabled\nthe process-box will\nauto-refresh.");

  QPushButton_70= new QPushButton(fresh, "NoName", this);
  QPushButton_70->setGeometry(5,35,70,20);
  QPushButton_70->setMinimumSize(0,0);
  QPushButton_70->setText("refresh");
	QObject::connect( QPushButton_70, SIGNAL(clicked()), this, SLOT( refreshitmanual()) );
  QWhatsThis::add(QPushButton_70,"Click this button to refresh\nthe processbox.");

  QPushButton_1= new QPushButton(end, "NoName", this);
  QPushButton_1->setGeometry(130,390,60,20);
  QPushButton_1->setMinimumSize(0,0);
  QPushButton_1->setText("quit");
	QObject::connect(QPushButton_1, SIGNAL(clicked()), qApp, SLOT(quit()) );
  QWhatsThis::add(QPushButton_1,"Close the the processbox.");

  QLabel_52= new QLabel(this,"NoName");
  QLabel_52->setGeometry(100,10,100,20);
  QLabel_52->setMinimumSize(0,0);
  QLabel_52->setText("managed proc:");
  QLabel_52->setMargin(2);

  QLabel_50= new QLabel(this,"NoName");
  QLabel_50->setGeometry(200,10,70,20);
  QLabel_50->setMinimumSize(0,0);
  QLabel_50->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_50->setText("");
  QLabel_50->setMargin(3);
	QLabel_50->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QLabel_50->setAlignment( AlignVCenter | AlignRight );
  QWhatsThis::add(QLabel_50,"This box shows the current\nmanage process.");

  QPushButton_rem= new QPushButton(this,"NoName");
  QPushButton_rem->setGeometry(5,375,90,35);
  QPushButton_rem->setMinimumSize(0,0);
  QPushButton_rem->setText("manage procs\nfrom remote");
  QWhatsThis::add(QPushButton_rem,"Click this button to manage processes\ncurrently migraged to the node.");

  fileToolbar = new QToolBar(this, "QWhatsThis");
  fileToolbar->setGeometry(0,0,25,25);
  QWhatsThis::whatsThisButton(fileToolbar);

	userbox = new QComboBox(this);
	userbox->setGeometry(200,35,100,20);
	userbox->setMinimumSize(0,0);
	userbox->resize(100, 20);
	QObject::connect(userbox, SIGNAL(activated(int)), this, SLOT(sync_user(int)) );
	QWhatsThis::add(userbox,"Select the user (or all) for a more selective view\n.");

	userbox->insertItem("all", -1);

	if ((fp=fopen("/etc/passwd", "r"))!=NULL) {

		while(!feof(fp)) {

			if ((fgets(temp1, 190, fp))!=NULL) {
				sub_string=strtok(temp1, ":");
				userbox->insertItem(sub_string, -1);

			  while ( (sub_string=strtok(NULL, ":")) != NULL) {
				}
			}
		}
		fclose(fp);
    } else {
		printf("could not open /etc/passwd for reading\n");
	}

  user_select_label= new QLabel(this,"NoName");
  user_select_label->setGeometry(5,70,70,20);
  user_select_label->setMinimumSize(0,0);
  user_select_label->setText("all");

  QLabel_userbox= new QLabel(this,"NoName");
  QLabel_userbox->setGeometry(300,35,50,20);
  QLabel_userbox->setMinimumSize(0,0);
  QLabel_userbox->setMargin(1);
  QLabel_userbox->setText("procs");
  QWhatsThis::add(QLabel_userbox,"Select the user (or all) for a more selective view\n.");

	delete [] temp1;
	delete [] sub_string;
}




void Mosixview_clientApp::setupQuit(){

	neuwin();
	QTimer *proctimer = new QTimer( this, "procs" );
	proctimer->start( 10000 );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit()) );
	QObject::connect( QPushButton_rem, SIGNAL(clicked()), this, SLOT( remoteproc()) );

}


void Mosixview_clientApp::closehostbox() {
	delete hinten;
}


void Mosixview_clientApp::refreshit() {

	if(QCheckBox_1->isChecked()) {
		fill_procbox();
	}
}



void Mosixview_clientApp::refreshitmanual() {

	fill_procbox();
}




void Mosixview_clientApp::killproc() {

  char *killprocnr;
	killprocnr = new char[50];
  char *outp;
	outp = new char[100];
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	strcpy(killprocnr, "");
	strcpy(killprocnr, "/bin/kill ");
	strcat(killprocnr, cproc);
	if((error=system(killprocnr)) > 0) {
		printf("cannot kill proc\n");
		strcpy(outp, "cannot kill PID ");
		strcat(outp, cproc);
	}
	strcpy(outp, "killed PID ");
	strcat(outp, cproc);

	delete [] killprocnr;
	delete [] outp;
}






void Mosixview_clientApp::neuwin(){

	processbox = new QListView(this);
	processbox->setGeometry(5,60,50,100);
	processbox->setMinimumSize(0,0);
	processbox->setAllColumnsShowFocus(1);
	processbox->addColumn("pid");
	processbox->addColumn("n#");
	processbox->addColumn("stat");
	processbox->addColumn("cmdline");
	processbox->addColumn("nice");
	processbox->addColumn("UID");
	processbox->setSorting(2, TRUE);
	processbox->setColumnAlignment (0, AlignLeft);
	processbox->setColumnAlignment (1, AlignLeft);
	processbox->setColumnAlignment (2, AlignLeft);
	processbox->setItemMargin(2);
	processbox->resize(190, 300);
	fill_procbox();
	processbox->show();
	QObject::connect( processbox, SIGNAL(doubleClicked(QListViewItem *)), this, SLOT( labelit( QListViewItem *)) );
  QWhatsThis::add(processbox,"This box displays the\nprocesses on this node.\nDouble-click a process\nfor managing it.");
}




void Mosixview_clientApp::labelit( QListViewItem *index) {

	int character='#';
	const char *hostname;
	const char *range;
  char *sub_string1;
	sub_string1 = new char[50];
  char *hostnametmp;
	hostnametmp = new char[50];
  char *new_last_bit;
	new_last_bit = new char[5];
  char *host_ohne_bit;
	host_ohne_bit = new char[50];
  char *temp;
	temp = new char[100];
  char *output;
	output = new char[250];
	int lang=0;
	int howmany=0;
	int p=0;
	int second=0;
	int current_proc=0;
	int current_prio=0;
	int letzter_punkt=0;
	int lang_testhost=0;
	int lastbit_int=0;
	bool ok;

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
 	QPixmap host, migrat, home, smile, killit, end;
	host= QPixmap(hosti);
	migrat= QPixmap(migrator);
	home= QPixmap(gohome);
	smile = QPixmap(speed);
	killit = QPixmap(kill);
	end = QPixmap(ende);

	hinten = new QWidget(0, "");
	hinten->setGeometry(640,300,50,110);
	hinten->setMinimumSize(0,0);
	hinten->resize(300, 360);
	hinten->setFixedSize(300, 370);

	QGroupBox *backr2 = new QGroupBox("",hinten);
	backr2->setGeometry(5,25,50,130);
	backr2->setMinimumSize(0,0);
	backr2->resize(290, 255);
	backr2->resize(290, 340);

	QLabel *QLabel_proc = new QLabel("",backr2);
	QLabel_proc->setGeometry(10,90,20,30);
	QLabel_proc->setMinimumSize(0,0);
	QLabel_proc->resize(140, 100);

	QListBox *hostbox = new QListBox(hinten);
	hostbox->setGeometry(10,30,50,110);
	hostbox->setMinimumSize(0,0);
	hostbox->resize(150, 100);
	QWhatsThis::add(hostbox,"This box displays all mosix-nodes\nto which the process could be migrated.\nJust double-click a node\nfor migrating the process to.");

	QFile fp("/etc/mosix.map");

	if ( fp.open(IO_ReadOnly) ) {
		QTextStream t( &fp );
		QString s;
		int n = 0;

		while ( !t.eof() ) {
			s = t.readLine();
			s = s.simplifyWhiteSpace();

			if ( (s.find ( character, 0, TRUE )==-1)&&(s.length()>1) ) {
				second=	s.find ( 32, 0, TRUE );
				lang=	s.findRev ( 32, s.length(), TRUE );
				range=(const char *)s+(lang+1);

				if ( (strcmp(range, "0"))||(strcmp(range, "ALIAS")) ) {
					howmany=atoi(range);

						if (howmany!=1){
							s.truncate( lang );
							hostname=(const char *)s+(second+1);

							for (p=0; p<howmany; p++) {
								n++;

								QString *testhost=new QString(hostname);
								lang_testhost=testhost->length();
								letzter_punkt=testhost->findRev(".", -1, false);
								QString *testhost_ohne_lastbit=new QString(*testhost);
								QString *testhost_lastbit=new QString(*testhost);
								testhost_ohne_lastbit->remove(letzter_punkt+1, lang_testhost-letzter_punkt);
								testhost_lastbit->remove(0, letzter_punkt+1);
								lastbit_int=testhost_lastbit->toInt(&ok,10);
								lastbit_int=lastbit_int+p;
								sprintf((char *)testhost_lastbit, "%d", lastbit_int);
								QString *newhost=new QString(*testhost_ohne_lastbit);
								newhost->append((char *)testhost_lastbit);
								hostbox->insertItem(host, *newhost, n);
							}
							} else {
							n++;
							s.truncate( lang );
							hostname=(const char *)s+(second+1);
            	hostbox->insertItem(host, hostname, n);
	          }
  				}
				}
			}
			fp.close();
		}
		QObject::connect( hostbox, SIGNAL(selected(int)), this, SLOT( migrateto( int )) );
		QLabel_50->setText(index->text(0));
		QLabel_50->setBackgroundPixmap(QPixmap(white_pix));

		strcpy(output, "");
		strcpy(output, "doubleclick a mosix host \nfor migrating the process:\n");
		strcat(output, index->text(0));

		if (strcmp(index->text(1), "0")) {
			strcat(output, " running on node ");
			strcat(output, index->text(1));
			} else {
			strcat(output, " running local");
		}
		strcat(output, "\n");

		QLabel_proc->setText(output);

	  QPushButton_71= new QPushButton(end, "close", hinten);
	  QPushButton_71->setGeometry(230,340,60,20);
	  QPushButton_71->setMinimumSize(0,0);
	  QPushButton_71->setText("close");
		QObject::connect( QPushButton_71, SIGNAL(clicked()), hinten, SLOT( close()) );
	  QWhatsThis::add(QPushButton_71,"Close the migrator-box.");

	  QPushButton_home= new QPushButton(home, index->text(0), hinten);
	  QPushButton_home->setGeometry(60,185,60,20);
	  QPushButton_home->setMinimumSize(0,0);
	  QPushButton_home->setText("home");
	  QPushButton_home->setName(index->text(0));
		QObject::connect( QPushButton_home, SIGNAL(clicked()), this, SLOT( migratehome()) );
	  QWhatsThis::add(QPushButton_home,"Click this button to migrate\nthe process to its\nhome-node.");

	  QPushButton_best= new QPushButton(smile, index->text(0), hinten);
	  QPushButton_best->setGeometry(60,205,60,20);
  	QPushButton_best->setMinimumSize(0,0);
	  QPushButton_best->setText("best");
	  QPushButton_best->setName(index->text(0));
		QObject::connect( QPushButton_best, SIGNAL(clicked()), this, SLOT( migratebest()) );
	  QWhatsThis::add(QPushButton_best,"Click this button to migrate\nthe process to the\nbest-avaiable node.");

	  QPushButton_72= new QPushButton(killit, index->text(0), hinten);
	  QPushButton_72->setGeometry(60,225,60,20);
  	QPushButton_72->setMinimumSize(0,0);
	  QPushButton_72->setText("kill");
	  QPushButton_72->setName(index->text(0));
		QObject::connect( QPushButton_72, SIGNAL(clicked()), this, SLOT( killproc()) );
	  QWhatsThis::add(QPushButton_72,"Click this button to kill\nthe process.");

		home_label = new QLabel("",hinten);
		home_label->setGeometry(15,185,40,20);
		home_label->setMinimumSize(0,0);
		home_label->setText("send to");

		best_label = new QLabel("",hinten);
		best_label->setGeometry(15,205,40,20);
		best_label->setMinimumSize(0,0);
		best_label->setText("send to");

		home_label1 = new QLabel("",hinten);
		home_label1->setGeometry(125,185,30,20);
		home_label1->setMinimumSize(0,0);
		home_label1->setText("node");

		best_label1 = new QLabel("",hinten);
		best_label1->setGeometry(125,205,30,20);
		best_label1->setMinimumSize(0,0);
		best_label1->setText("node");

		or_label = new QLabel("",hinten);
		or_label->setGeometry(15,225,40,20);
		or_label->setMinimumSize(0,0);
		or_label->setText("      or");

		proc_label = new QLabel("",hinten);
		proc_label->setGeometry(125,225,30,20);
		proc_label->setMinimumSize(0,0);
		proc_label->setText("proc.");

		prio_label1 = new QLabel("",hinten);
		prio_label1->setGeometry(15,300,20,20);
		prio_label1->setMinimumSize(0,0);
		prio_label1->setText("-20");

		prio_label2 = new QLabel("",hinten);
		prio_label2->setGeometry(135,300,20,20);
		prio_label2->setMinimumSize(0,0);
		prio_label2->setText("20");

		prio_label3 = new QLabel("",hinten);
		prio_label3->setGeometry(80,300,20,20);
		prio_label3->setMinimumSize(0,0);
		prio_label3->setText("0");

		prio_label4 = new QLabel("",hinten);
		prio_label4->setGeometry(45,280,100,20);
		prio_label4->setMinimumSize(0,0);
		prio_label4->setText("renice process");

		current_proc = atoi(index->text(0));
		current_prio = getpriority(PRIO_PROCESS, current_proc);

	  proc_prio= new QSlider(hinten,index->text(0));
	  proc_prio->setGeometry(20,320,130,20);
	  proc_prio->setMinimumSize(0,0);
	  proc_prio->setTracking(false);
	  proc_prio->setRange(0, 40);
	  proc_prio->setValue(current_prio+20);
	  proc_prio->setTickInterval (2);
	  proc_prio->setTickmarks ( QSlider::Below );
	  proc_prio->setOrientation(QSlider::Horizontal);
		QObject::connect(proc_prio, SIGNAL(valueChanged(int)), this, SLOT(setprocprio(int)) );
	  QWhatsThis::add(proc_prio,"You can set the nice-value\nfor the process with\nthis slider.");

		prio_label5 = new QLabel("",hinten);
		prio_label5->setGeometry(15,340,20,20);
		prio_label5->setMinimumSize(0,0);
		prio_label5->setText("fast");

		prio_label6 = new QLabel("",hinten);
		prio_label6->setGeometry(130,340,100,20);
		prio_label6->setMinimumSize(0,0);
		prio_label6->setText("slow");

	  sigstop_button= new QPushButton(hinten,index->text(0));
	  sigstop_button->setGeometry(20,250,70,20);
  	sigstop_button->setMinimumSize(0,0);
	  sigstop_button->setText("SIGSTOP");
		QObject::connect(sigstop_button, SIGNAL(clicked()), this, SLOT(action_sigstop()) );
	  QWhatsThis::add(sigstop_button,"This button sends a\nkill -SIGSTOP\nsignal to the process.\nThe process will\nstop immediatly");

	  sigcont_button= new QPushButton(hinten,index->text(0));
	  sigcont_button->setGeometry(90,250,70,20);
	  sigcont_button->setMinimumSize(0,0);
	  sigcont_button->setText("SIGCONT");
		QObject::connect( sigcont_button, SIGNAL(clicked()), this, SLOT(action_sigcont()) );
	  QWhatsThis::add(sigcont_button,"This button sends a\nkill -SIGCONT\nsignal to the process.\nThe process will\ncontinue immediatly");

		proc_titel = new QLabel("",hinten);
		proc_titel->setGeometry(25,5,150,20);
		proc_titel->setMinimumSize(0,0);
		proc_titel->setText("MOSIXVIEW-Migrator");

		pix_titel = new QLabel("",hinten);
		pix_titel->setGeometry(5,5,20,20);
		pix_titel->setMinimumSize(0,0);
		pix_titel->setPixmap(migrat);

	  procstat = new QMultiLineEdit(hinten, "status");
	  procstat->setGeometry(170,30,120,300);
	  procstat->setReadOnly(TRUE);
		QWhatsThis::add(procstat,"This box shows the status information\nof this process.");

		strcpy(temp, "");
		strcpy(temp, "/bin/cat /proc/");
		strcat(temp, index->text(0));
		strcat(temp, "/status > /tmp/stat.temp");

		if(!system(temp)) {
			QFile fp1("/tmp/stat.temp");

			if ( fp1.open(IO_ReadOnly) ) {
				QTextStream t1( &fp1 );
				QString s1;

					while ( !t1.eof() ) {
						s1 = t1.readLine();
						s1 = s1.simplifyWhiteSpace();
						procstat->insertLine(s1,-1);
					}
					fp1.close();
				}

        } else {
				procstat->insertLine("could not get status",-1);
			}
		  procstat->setReadOnly(TRUE);
		  procstat->setBackgroundPixmap(QPixmap(white_pix));

			hinten->show();

	delete [] hostnametmp;
	delete [] new_last_bit;
	delete [] host_ohne_bit;
	delete [] temp;
	delete [] output;

}





void Mosixview_clientApp::migrateto(int index) {

  char *setsp;
	setsp = new char[100];
  char *outp;
	outp = new char[100];
  char *cindex;
	cindex = new char[5];
	int error;
	const char *cproc;

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	cproc=(const char *)QLabel_50->text();
	index++;
	strcpy(cindex, "");
	sprintf(cindex, "%d", index);
	strcpy(setsp, "");
	strcpy(setsp, "migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " ");
	strcat(setsp, cindex);
	if((error=system(setsp)) > 0) {
		printf("cannot migrate PID\n");
		strcpy(outp, "cannot migrate PID ");
		strcat(outp, cproc);
	}
	strcpy(outp, "try to migrate PID ");
	strcat(outp, cproc);

	delete [] setsp;
	delete [] outp;
	delete [] cindex;

}






void Mosixview_clientApp::migratehome() {

  char *setsp;
	setsp = new char[100];
  char *outp;
	outp = new char[100];
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	strcpy(setsp, "");
	strcpy(setsp, "migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " home");

	if((error=system(setsp)) > 0) {
		printf("cannot send PID home\n");
		strcpy(outp, "cannot send home PID ");
		strcat(outp, cproc);
	}
	strcpy(outp, "try to send home PID ");
	strcat(outp, cproc);

	delete [] setsp;
	delete [] outp;


}










void Mosixview_clientApp::migratebest() {

  char *setsp;
	setsp = new char[100];
  char *outp;
	outp = new char[100];
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	strcpy(setsp, "");
	strcpy(setsp, "migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " balance");

	if((error=system(setsp)) > 0) {
		printf("cannot send PID to best node\n");
		strcpy(outp, "cannot send to best node PID ");
		strcat(outp, cproc);
	}
	strcpy(outp, "try to send to best node PID ");
	strcat(outp, cproc);

	delete [] setsp;
	delete [] outp;
}








void Mosixview_clientApp::fill_procbox() {

	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
  char *cmdline;
	cmdline = new char[10000];
  char *temp;
	temp = new char[10000];
  char *where;
	where = new char[5];
  char *stat;
	stat = new char[1000];
  char *cannot;
	cannot = new char[100];
  char *cproc_nice;
	cproc_nice = new char[6];
	int proc_nice=0;
	int current_procprio=0;
  char *line;
	line = new char[80];
  char *userid;
	userid = new char[8];
  char *userid1;
	userid1 = new char[8];
	int raus=0;

 	QPixmap procicon, remoteprocicon, cantprocicon;
	procicon= QPixmap(proc);
	remoteprocicon= QPixmap(proc_remote);
	cantprocicon= QPixmap(proc_cant);

	processbox->clear();

	if ((dir=opendir("/proc"))!=NULL) {

		while ((dir_info = readdir(dir))!=NULL) {

			if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {
				strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/cmdline");

	      if ((fp=fopen(temp, "r"))!=NULL) {
					fscanf(fp, "%s", cmdline);
        	fclose(fp);
				}
        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/where");

				if ((fp=fopen(temp, "r"))!=NULL) {
					fscanf(fp, "%s", where);
					fclose(fp);
				}
        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/stat");

				if ((fp=fopen(temp, "r"))!=NULL) {
					fscanf(fp, "%s", stat);
					fscanf(fp, "%s", stat);
					fscanf(fp, "%s", stat);
					fclose(fp);
				}
        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/cantmove");
				strcpy(cannot, "");

				if ((fp=fopen(temp, "r"))!=NULL) {
					fscanf(fp, "%s", cannot);
					fclose(fp);
				}
        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/status");
				strcpy(userid, "");

				if ((fp=fopen(temp, "r"))!=NULL) {
					raus=0;

					while ( (fgets(line, 79, fp) != NULL)&&(raus==0) ) {

						if (strstr(line, "PPid:")) {
							fscanf(fp, "%s %s", userid1, userid);
							raus=1;
						}
					}
          fclose(fp);
        }
				proc_nice = atoi(dir_info->d_name);
				current_procprio = getpriority(PRIO_PROCESS, proc_nice);
				sprintf(cproc_nice, "%d", current_procprio);

				if( (!strcmp(user_select_label->text(), userid))||(!strcmp(user_select_label->text(), "all")) ) {
					QListViewItem *i1;
					i1 = new QListViewItem(processbox, dir_info->d_name, where, stat, cmdline, cproc_nice, userid);

					if (atoi(where)==0) {

						if( (!strstr(cannot, "init_proc"))&&(!strstr(cannot, "clone_vm"))&&(!strstr(cannot, "daemon")) ) {
							i1->setPixmap(0, procicon);
							} else {
							i1->setPixmap(0, cantprocicon);
						}
			      } else {
						i1->setPixmap(0, remoteprocicon);
					}
				} //stcmp if
	    }

		} //while

	closedir(dir);
	} //if


	delete [] cmdline;
	delete [] temp;
	delete [] where;
	delete [] stat;
	delete [] cannot;

}






void Mosixview_clientApp::remoteproc() {

	int procs=0;
	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
  char *from;
	from = new char[6];
  char *ip_from;
	ip_from = new char[20];
  char *temp;
	temp = new char[100];
  char *temp1;
	temp1 = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);
	QPixmap procicon_g, home, smile;
	procicon_g= QPixmap(proc_g);
	home= QPixmap(gohome);
	smile = QPixmap(speed);

	QTabDialog *rem = new QTabDialog();
	rem->setGeometry(600,250,300,200);
	rem->resize(300, 300);

	if ((dir=opendir("/proc/mosix/remote"))!=NULL) {

		while ((dir_info = readdir(dir))!=NULL) {

			if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {
				procs++;
        strcpy(temp, "");
        strcpy(temp, "/proc/mosix/remote/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/from");
				if ((fp=fopen(temp, "r"))!=NULL) {
					fscanf(fp, "%s %s", from, ip_from);
					fclose(fp);
				}
				rem_processbox[procs] = new QLabel(rem);
				rem_processbox[procs]->setGeometry(10,10,300,300);
				rem_processbox[procs]->setMinimumSize(0,0);

				rem_from_who_label[procs] = new QLabel(rem_processbox[procs]);
				rem_from_who_label[procs]->setGeometry(10,10,140,20);
				rem_from_who_label[procs]->setMinimumSize(0,0);
				rem_from_who_label[procs]->setMargin(3);
				rem_from_who_label[procs]->setText("from MOSIX-node:");

				rem_from_ip_label[procs] = new QLabel(rem_processbox[procs]);
				rem_from_ip_label[procs]->setGeometry(10,40,140,20);
				rem_from_ip_label[procs]->setMinimumSize(0,0);
				rem_from_ip_label[procs]->setMargin(3);
				rem_from_ip_label[procs]->setText("IP-adress of the node:");

				rem_from_who[procs] = new QLabel(rem_processbox[procs]);
				rem_from_who[procs]->setGeometry(150,10,30,20);
				rem_from_who[procs]->setMinimumSize(0,0);
				rem_from_who[procs]->setMargin(3);
				rem_from_who[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
				rem_from_who[procs]->setBackgroundPixmap(QPixmap(white_pix));
				rem_from_who[procs]->setText(from);
				QWhatsThis::add(rem_from_who[procs],"This box shows the mosix-ID from the\nnode the process is currently running on.");

				rem_from_ip[procs] = new QLabel(rem_processbox[procs]);
				rem_from_ip[procs]->setGeometry(150,40,100,20);
				rem_from_ip[procs]->setMinimumSize(0,0);
				rem_from_ip[procs]->setMargin(3);
				rem_from_ip[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
				rem_from_ip[procs]->setBackgroundPixmap(QPixmap(white_pix));
				rem_from_ip[procs]->setText(ip_from);
				QWhatsThis::add(rem_from_ip[procs],"This box shows the ip-adress from the\nnode the process is currently running on.");

			  rem_gohome[procs]=  new QPushButton(home, dir_info->d_name, rem_processbox[procs]);
			  rem_gohome[procs]->setGeometry(10,90,120,25);
			  rem_gohome[procs]->setMinimumSize(0,0);
			  rem_gohome[procs]->setText("goto home node");
			  rem_gohome[procs]->setName(dir_info->d_name);
			  QObject::connect( rem_gohome[procs], SIGNAL(clicked()), this, SLOT( remote_gohome()) );
				QWhatsThis::add(rem_gohome[procs],"Click this button to migrate\nthe process to its\nhome node.");

			  rem_gobest[procs]=  new QPushButton(smile, dir_info->d_name, rem_processbox[procs]);
			  rem_gobest[procs]->setGeometry(10,120,120,25);
			  rem_gobest[procs]->setMinimumSize(0,0);
				rem_gobest[procs]->setText("goto best node");
			  rem_gobest[procs]->setName(dir_info->d_name);
			  QObject::connect( rem_gobest[procs], SIGNAL(clicked()), this, SLOT( remote_gobest()) );
				QWhatsThis::add(rem_gobest[procs],"Click this button to migrate\nthe process to the\nbest-avaiable node.");

				rem->addTab(rem_processbox[procs], procicon_g, dir_info->d_name);
				rem_stats[procs] = new QLabel(rem_processbox[procs]);
				rem_stats[procs]->setGeometry(145,65,100,20);
				rem_stats[procs]->setMinimumSize(0,0);
				rem_stats[procs]->setMargin(3);
				rem_stats[procs]->setText("stats:");

		   qtchild[procs] = new QMultiLineEdit(rem_processbox[procs], "status");
		   qtchild[procs]->setGeometry(150,90,120,120);
		   qtchild[procs]->setReadOnly(TRUE);

			strcpy(temp1, "");
			strcpy(temp1, "/proc/mosix/remote/");
			strcat(temp1, dir_info->d_name);
			strcat(temp1, "/stats");
			QFile fp(temp1);

				if ( fp.open(IO_ReadOnly) ) {
					QTextStream t( &fp );
					QString s;

					while ( !t.eof() ) {
						s = t.readLine();
						s = s.simplifyWhiteSpace();
				   qtchild[procs]->insertLine(s,-1);
					}
					fp.close();
				}
				qtchild[procs]->setReadOnly(TRUE);
				qtchild[procs]->setBackgroundPixmap(QPixmap(white_pix));
				QWhatsThis::add(qtchild[procs],"This box shows status information\nof the process\ncurrently migrated to this node.");
	    }
		} //while
	closedir(dir);
	} //if

	if (procs==0) {
		rem_processbox[procs] = new QLabel(rem);
		rem_processbox[procs]->setGeometry(10,10,300,300);
		rem_processbox[procs]->setMinimumSize(0,0);
		rem_from_who_label[procs] = new QLabel(rem_processbox[procs]);
		rem_from_who_label[procs]->setGeometry(10,10,200,60);
		rem_from_who_label[procs]->setMinimumSize(0,0);
		rem_from_who_label[procs]->setMargin(3);
		rem_from_who_label[procs]->setBackgroundPixmap(QPixmap(white_pix));
		rem_from_who_label[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
		rem_from_who_label[procs]->setText("No processes from remote\nnodes running on this host!");
		rem->addTab(rem_processbox[procs], procicon_g, "none");
	}
	rem->show();
	QWhatsThis::add(rem,"This box shows the processes currently\nmigrated to this host.");

	delete [] from;
	delete [] ip_from;
	delete [] temp;
	delete [] temp1;
}






void Mosixview_clientApp::remote_gohome() {

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *proctab;
	const QObject *button = sender();
  proctab=button->name();

  char *setsp;
	setsp = new char[100];
	int error;

	strcpy(setsp, "");
	strcpy(setsp, "echo 0 > /proc/mosix/remote/");
	strcat(setsp, proctab);
	strcat(setsp, "/goto");
	if((error=system(setsp)) > 0) {
		printf("cannot send proc home\n");
	}
	delete [] setsp;
}



void Mosixview_clientApp::remote_gobest() {

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *proctab;
	const QObject *button = sender();
  proctab=button->name();

  char *setsp;
	setsp = new char[100];
	int error;

	strcpy(setsp, "");
	strcpy(setsp, "echo -1 > /proc/mosix/remote/");
	strcat(setsp, proctab);
	strcat(setsp, "/goto");
	if((error=system(setsp)) > 0) {
		printf("cannot send proc to best avaiable node\n");
	}
	delete [] setsp;
}






void Mosixview_clientApp::setprocprio(int prio) {

  char *myrenice;
	myrenice = new char[100];
  char *cprio;
	cprio = new char[6];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *procpid;
	const QObject *button = sender();
	procpid=button->name();

	sprintf(cprio, "%d", prio-20);
	strcpy(myrenice, "");
	strcpy(myrenice, "renice ");
	strcat(myrenice, cprio);
	strcat(myrenice, " ");
	strcat(myrenice, procpid);
	if (!system(myrenice)) {
		printf("renice successfull\n");
		} else {
		printf("renice failed\n");
	}

	delete [] cprio;
	delete [] myrenice;
}





void Mosixview_clientApp::action_sigstop() {

  char *sys_sigstop;
	sys_sigstop = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *procpid;
	const QObject *button = sender();
	procpid=button->name();

	strcpy(sys_sigstop, "");
	strcpy(sys_sigstop, "kill -SIGSTOP ");
	strcat(sys_sigstop, procpid);
	if (!system(sys_sigstop)) {
		printf("process paused\n");
		} else {
		printf("could not pause process\n");
	}
	sigstop_button-> setToggleButton ( TRUE );
	sigstop_button-> toggle();
	sigcont_button-> toggle ();
	sigcont_button-> setToggleButton ( FALSE );

	delete [] sys_sigstop;
}






void Mosixview_clientApp::action_sigcont() {

  char *sys_sigcont;
	sys_sigcont = new char[100];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *procpid;
	const QObject *button = sender();
	procpid=button->name();

	strcpy(sys_sigcont, "");
	strcpy(sys_sigcont, "kill -SIGCONT ");
	strcat(sys_sigcont, procpid);

	if (!system(sys_sigcont)) {
		printf("process continued\n");
		} else {
		printf("could not continued process\n");
	}
	sigcont_button-> setToggleButton ( TRUE );
	sigcont_button-> toggle();
	sigstop_button-> toggle ();
	sigstop_button-> setToggleButton ( FALSE );

	delete [] sys_sigcont;
}





void Mosixview_clientApp::sync_user(int index) {

  char *sub_string;
	sub_string = new char[50];
  char *temp1;
	temp1 = new char[200];
  char *temp2;
	temp2 = new char[200];
	FILE *fp;
	index=index;

	if ((fp=fopen("/etc/passwd", "r"))!=NULL) {

		while(!feof(fp)) {

			if ((fgets(temp1, 190, fp))!=NULL) {
				sub_string=strtok(temp1, ":");
				strcpy(temp2, "");
				strcpy(temp2, sub_string);
				sub_string=strtok(NULL, ":");
				sub_string=strtok(NULL, ":");

				if(!strcmp(userbox->currentText(), temp2)) {
				  user_select_label->setText(sub_string);
				}

			  while ( (sub_string=strtok(NULL, ":")) != NULL) {
				}
			}
		}
		fclose(fp);
    } else {
		printf("could not open /etc/passwd for reading\n");
	}

	if(!strcmp(userbox->currentText(), "all")) {
	  user_select_label->setText("all");
	}

	refreshit();

	delete [] temp1;
	delete [] temp2;
	delete [] sub_string;

}















