/***************************************************************************
                          mosixview_client.h  -  description
                             -------------------
    begin                : Fri Jul  6 19:44:05 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOSIXVIEW_CLIENT_H
#define MOSIXVIEW_CLIENT_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qscrollbar.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qprogressbar.h>
#include <qlistbox.h>
#include <qaccel.h>
#include <qtextstream.h>
#include <qtabdialog.h>
#include <qmultilineedit.h>
#include <qtimer.h>
#include <qcombobox.h>


#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/resource.h>

#include "resource.h"



// application specific includes
#include "mosixview_clientview.h"
#include "mosixview_clientdoc.h"

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class Mosixview_clientView is
  * created which creates your view.
  */
class Mosixview_clientApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    Mosixview_clientApp();
    /** destructor */
    ~Mosixview_clientApp();

    void initDialog();

  public slots:

	void setupQuit();
	void neuwin();
	void labelit( QListViewItem * index);
	void migrateto(int index);
	void migratehome();
	void migratebest();
	void refreshit();
	void refreshitmanual();
	void fill_procbox();
	void closehostbox();
	void killproc();
	void remoteproc();
	void remote_gohome();
	void remote_gobest();
	void setprocprio(int prio);
	void action_sigstop();
	void action_sigcont();
	void sync_user(int index);

	protected:

	QCheckBox *QCheckBox_1;
	QCheckBox *QCheckBox_big;
	QPushButton *QPushButton_70;
	QPushButton *QPushButton_1;
	QGroupBox *QGroupBox_1;
	QLabel *QLabel_22;
	QLabel *QLabel_6;
	QLabel *QLabel_2;
	QLabel *QLabel_52;
	QLabel *QLabel_50;
	QLabel *QLabel_110;
	QLabel *QLabel_111;
	QPushButton *QPushButton_home;
	QPushButton *QPushButton_best;
	QLabel *home_label;
	QLabel *best_label;
	QLabel *home_label1;
	QLabel *best_label1;
	QLabel *or_label;
	QLabel *proc_label;
	QLabel *proc_titel;
	QLabel *pix_titel;
	QPushButton *QPushButton_rem;
	QCheckBox *QCheckBox_2;
	QCheckBox *QCheckBox_3;
	QCheckBox *QCheckBox_4;
	QPushButton *QPushButton_2;
	QPushButton *QPushButton_12;
	QPushButton *QPushButton_30;
	QPushButton *QPushButton_40;
	QPushButton *QPushButton_50;
	QPushButton *QPushButton_60;
	QPushButton *QPushButton_71;
	QPushButton *QPushButton_72;
	QPushButton *QPushButton_80;
	QPushButton *QPushButton_90;
	QPushButton *QPushButton_81;
	QPushButton *QPushButton_91;
	QPushButton *QPushButton_14;
	QLabel *QLabel_hostconf;
	QLabel *QLabel_hostconf1;
	QLabel *QLabel_hostconf2;
	QLabel *QLabel_hostconf3;
	QLabel *QLabel_hostconf4;
	QLabel *QLabel_hostconf5;
	QLabel *QLabel_hostconf6;
	QLabel *QLabel_hostconf7;
	QLabel *QLabel_hostconf8;
	QLabel *QLabel_hostconf9;
	QLabel *QLabel_conficon;
	QListView *processbox;
  QWidget *hinten;
	QTabDialog *rem;
	QLabel *rem_processbox[500];
	QLabel *rem_from_who[500];
	QLabel *rem_from_ip[500];
	QLabel *rem_from_who_label[500];
	QLabel *rem_from_ip_label[500];
	QPushButton *rem_gohome[500];
	QPushButton *rem_gobest[500];
	QMultiLineEdit* qtchild[500];
	QLabel *rem_stats[500];
	QMultiLineEdit* procstat;
	QSlider *proc_prio;
	QLabel *prio_label1;
	QLabel *prio_label2;
	QLabel *prio_label3;
	QLabel *prio_label4;
	QLabel *prio_label5;
	QLabel *prio_label6;
	QPushButton *sigstop_button;
	QPushButton *sigcont_button;
	QComboBox *userbox;
	QLabel *QLabel_userbox;
	QLabel *user_select_label;


	virtual void resizeEvent(QResizeEvent* ev) {
		processbox->setGeometry(5,60,ev->size().width()-5,ev->size().height()-120);
		QPushButton_1->setGeometry(130,ev->size().height()-30,60,20);
	  QPushButton_rem->setGeometry(5,ev->size().height()-45,90,35);
	}

  private:

    QToolBar *fileToolbar;

};
#endif

